SystemOrganization addCategory: #'ActiveContext-Core'!
SystemOrganization addCategory: #'ActiveContext-Utils'!
SystemOrganization addCategory: #'ActiveContext-Tests'!
SystemOrganization addCategory: #'ActiveContext-Kernel'!

Trait named: #TClassResolution
	uses: {}
	category: 'ActiveContext-Core'!

!TClassResolution methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceClassResolution: aVariableNode

"| newName newCls | "

"Transcript show: aVariableNode name; cr. "

"(aVariableNode name = 'Array') ifTrue: [ newName := 'Array2' ].
(aVariableNode name = 'HashedCollection') ifTrue: [ newName := 'HashedCollection2' ].
(aVariableNode name = 'Dictionary') ifTrue: [ newName := 'Dictionary2' ].
(aVariableNode name = 'IdentityDictionary') ifTrue: [ newName := 'IdentityDictionary2' ].
(aVariableNode name = 'Set') ifTrue: [ newName := 'Set2' ].
(aVariableNode name = 'LookupKey') ifTrue: [ newName := 'LookupKey2' ].
(aVariableNode name = 'Association') ifTrue: [ newName := 'Association2' ].
(aVariableNode name = 'OrderedCollection') ifTrue: [ newName := 'OrderedCollection2' ]."

"(aVariableNode name = 'Array2') ifTrue: [ newName := 'Array22' ].
(aVariableNode name = 'HashedCollection2') ifTrue: [ newName := 'HashedCollection22' ].
(aVariableNode name = 'Dictionary2') ifTrue: [ newName := 'Dictionary22' ].
(aVariableNode name = 'IdentityDictionary2') ifTrue: [ newName := 'IdentityDictionary22' ].
(aVariableNode name = 'Set2') ifTrue: [ newName := 'Set22' ].
(aVariableNode name = 'LookupKey2') ifTrue: [ newName := 'LookupKey22' ].
(aVariableNode name = 'Association2') ifTrue: [ newName := 'Association22' ].
(aVariableNode name = 'OrderedCollection2') ifTrue: [ newName := 'OrderedCollection22' ]."

"newName:= (aVariableNode name , '2').
newCls := Smalltalk at: newName asSymbol ifAbsent: [ nil ]."

"newName isNil ifFalse: [
		aVariableNode token value: newName. 
].
^ super replaceClassResolution: aVariableNode ."


		| m rec args c lit  cls |
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
				
				lit := RBLiteralNode value: (aVariableNode  name).
				lit parent: aVariableNode parent.
					
				args := Array new: 1..
				args at: 1 put: lit.
				
				m := RBMessageNode 
							receiver: rec
							selector: #ctxClass:
							arguments: args.
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				self visitNode: m.! !

Trait named: #TOptimizedAccessors
	uses: {}
	category: 'ActiveContext-Core'!

!TOptimizedAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:42'!
replaceInstVarRead: aVariableNode

		| m rec args c readSelector  t |
				
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
					
				readSelector := 	#ctxRead , aVariableNode name .
									
				m := RBMessageNode 
							receiver: rec
							selector: readSelector 
							arguments: #().
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				self visitNode: m.! !

!TOptimizedAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:42'!
replaceInstVarWrite: anAssignmentNode

		| m rec args c writeSelector lit2 |
				
				rec := RBVariableNode named: 'self'.
				rec parent: anAssignmentNode parent.
				
				writeSelector := #ctxWrite , anAssignmentNode variable name , ':' asSymbol .
				
				args := Array new: 1.
				args at: 1 put: (anAssignmentNode value).
				
				m := RBMessageNode 
							receiver: rec
							selector: writeSelector 
							arguments: args.
				m parent: anAssignmentNode parent.
				
				anAssignmentNode replaceWith: m.
				
				self visitNode: m.! !

Trait named: #TRegularAccessors
	uses: {}
	category: 'ActiveContext-Core'!

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceClassVarRead: aVariableNode

		| m cls rec args c lit  t |
				
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
						
				lit := RBLiteralNode value: (aVariableNode  name).
				lit parent: aVariableNode parent.
				
				
				args := Array new: 1.
				args at: 1 put: (lit).
				
				cls := RBMessageNode 
							receiver: rec
							selector: #class
							arguments: #().
							
				m := RBMessageNode 
							receiver: cls
							selector: #ctxRead:
							arguments: args.
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				self visitNode: m.! !

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceClassVarWrite: anAssignmentNode

		| m cls rec args c lit lit2 |
				
				rec := RBVariableNode named: 'self'.
				rec parent: anAssignmentNode parent.
				
				lit := RBLiteralNode value: (anAssignmentNode variable name).
				lit parent: anAssignmentNode parent.
				
				args := Array new: 2.
				args at: 1 put: ( lit ).
				args at: 2 put: (anAssignmentNode value).
				
				cls := RBMessageNode 
					receiver: rec
					selector: #class
					arguments: #().
						
				m := RBMessageNode 
					receiver: cls
					selector: #ctxWrite:value:
					arguments: args.
					
				m parent: anAssignmentNode parent.
				
				anAssignmentNode replaceWith: m.
				
				self visitNode: m.! !

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceInstVarRead: aVariableNode

		| m rec args c lit  t |
				
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
						
				lit := RBLiteralNode value: (aVariableNode  name).
				lit parent: aVariableNode parent.
				
				
				args := Array new: 1.
				args at: 1 put: (lit).
				
				m := RBMessageNode 
							receiver: rec
							selector: #ctxRead:
							arguments: args.
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				self visitNode: m.! !

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceInstVarWrite: anAssignmentNode

		| m rec args c lit lit2 |
				
				rec := RBVariableNode named: 'self'.
				rec parent: anAssignmentNode parent.
				
				lit := RBLiteralNode value: (anAssignmentNode variable name).
				lit parent: anAssignmentNode parent.
				
				args := Array new: 2.
				args at: 1 put: ( lit ).
				args at: 2 put: (anAssignmentNode value).
				
				m := RBMessageNode 
							receiver: rec
							selector: #ctxWrite:value:
							arguments: args.
				m parent: anAssignmentNode parent.
				
				anAssignmentNode replaceWith: m.
				
				self visitNode: m.! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
_postCopy 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
asNativeArray
	<ctxMeta>
	| a|
	a := Array new: self size. 
	(1 to: self size) do: [ :i | a at: i put: (self at: i )].
	^ a.! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
at: i 
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		^ super at: i.  
	]
	ifFalse: [
		^ super at: i. 
	]  
	! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
at: i put: v
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		self markOtherAsDirty .
		^ super at: i put: v. 
	]
	ifFalse: [
		^ super at: i put: v. 
	]! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
globalize: aUuuid
	<ctxMeta>
	^ super globalize: aUuuid   ! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
migrateToNext
	<ctxMeta>
	| clone |
	clone := ( Array22 new: self size ) globalize: self uuid..
	clone dirty: true.
	self nextMe: clone.
	clone prevMe: self.! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
migrateToPrev
	<ctxMeta>
	| clone |
	clone :=  (self species  new: self size) globalize: self uuid..
	clone dirty: true.
	self prevMe: clone.
	clone nextMe: self.! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
primAt: i 
	<ctxMeta>
	^ super at: i.  
	! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
primAt: i put: v
	<ctxMeta>
	^ super at: i put: v! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:03'!
species 
	<ctxMeta>
	^ ArrayL1   ! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
synchronize
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			ContextStatistics track: self . 
			1 to: self size  do: [ :i |
				| p |
				p := self prevMe primAt: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToNextIfNecessary .
					self primAt: i put: p nextMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					self primAt: i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]   
		] 
		ifNil: [
			1 to: self size do: [ :i |
				| n |
				n := self nextMe primAt: i.   
				( n isPrimitive not )  ifTrue: [
					"lazy migration after update"
					n migrateToPrevIfNecessary .
					self primAt: i put: n prevMe.
					"Transcript show: ( self uuid, '.' , field, ' := ', n prev asString ); cr."
				] ifFalse: [
					self primAt: i put: n.  
					"Transcript show: ( self uuid, '.' , field, ' := ', n asString ); cr."
				]. 
			]   
		].! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
synchronizeIfNecessary 
	<ctxMeta>
	self dirty ifTrue: [
		self synchronize.
		self dirty: false.
	]! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
synchronizeIfNecessary: index
	<ctxMeta>
	"We use 1 and not i because the array in context info might not be long enoug"
	(self dirtyBit: 1) ifTrue: [
		self synchronize. 
		self dirtyBit: 1 set: false.
	]! !

!Array22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
traverseAndDo: aBlock exclude: visited globalize: doGlobalize
	<ctxMeta>
	
	| infPrev infNext prev next |	
	
	self isPrimitive ifTrue: [ ^ self ].  
	doGlobalize ifTrue: [ self globalize ].
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	1 to: self size  do:  [ :i | ( self primAt: i  ) traverseAndDo: aBlock exclude:  visited globalize: doGlobalize  ].! !

!Character methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:28'!
isPrimitive ^true! !

!MCPatch methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 13:12'!
initializeWithBase: baseSnapshot target: targetSnapshot
	| base target |	
	operations := OrderedCollection new.
	base := MCDefinitionIndex definitions: baseSnapshot definitions.
	target := MCDefinitionIndex definitions: targetSnapshot definitions.
	
	target definitions do:
		[:t |
		base
			definitionLike: t
			ifPresent: [:b | (b isSameRevisionAs: t) ifFalse: [
					| mod |
					mod := MCModification of: b to: t.
					mod hasEffectiveChanges ifTrue: [	operations add: mod ] 
				]]
			ifAbsent: [operations add: (MCAddition of: t)]]
		displayingProgress: 'Diffing...'.
		
	base definitions do:
		[:b |
		target
			definitionLike: b
			ifPresent: [:t]
			ifAbsent: [operations add: (MCRemoval of: b)]]		! !

!Semaphore methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:32'!
isPrimitive ^true! !

!Behavior methodsFor: '*ActiveContext' stamp: 'ewe 9/26/2011 21:09'!
recompileAll
	Transcript show: ( 'Recompile all methods for: ' , self asString  ) ; cr. 
	self methodDict keys do: [ :method | 	method first = $_ ifFalse: [ self recompile: method ] ].! !

WeakArray weakSubclass: #WeakReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!WeakReference class methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:08'!
new
	^ super new: 1. ! !

!WeakReference methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:07'!
get
	^ self at: 1. ! !

!WeakReference methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:07'!
set: anObject
	self at: 1 put: anObject ! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 9/19/2011 17:12'!
dirty 
	^ false. ! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 5/20/2011 12:24'!
isPrimitive 
	^ true! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
nextMe: aValue
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:08'!
prevMe
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
prevMe: aValue
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 7/6/2011 16:09'!
uuid
	Abort signal: 'Uuid on nil is forbidden'.! !

!String methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:27'!
isPrimitive ^true! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 16:55'!
_globalize: uuid
	self isPrimitive ifTrue: [
		^ self. 
	].   
	self isCtxGlobal ifFalse: [   
		
		self contextInfo: ContextualInfo new.
		self contextInfo global: true.
		self contextInfo dirty: false.
		self contextInfo uuid: uuid..

		(self class = self optimizedClass) ifFalse: [
			| c2 |
			self flag: 'Don''t know why we need to instantiate the class--might cause problems'.
			c2 := BlockClosure_ new: self size.
			c2 instVarNamed: #outerContext put: self outerContext.   
			c2 instVarNamed: #startpc put: self startpc  .
			c2 instVarNamed: #numArgs put: self numArgs .  
			1 to: self size  do: [ :i |	c2 at: i put: (self at: i) globalize ].  
			self become: c2. 
			"Transcript show: ( '** Globalize closure ', self optimizedClass name ) ; cr."
		] ifTrue: [
			self error: 'BlockClosure should be optimized'.
		].
	].
	^ self.
! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 14:29'!
isPrimitive ^false! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 14:42'!
migrateToNext
	<ctxMeta>
	| clone ctx sender receiver newCtx cls newClass newMeth newSender newReceiver args  |
	self flag: 'The outerContext''s method should be migrated to the corresponding method in the new class'.
	clone := ( BlockClosure new: self size ) globalize: self uuid..
	
	ctx := self outerContext. 
	cls := ctx method methodClass.
	sender := ctx sender.
	receiver := ctx receiver. 
	newClass := self safeMigrate: cls.  
	newMeth := newClass methodDict at: ctx method selector.
	newSender := self safeMigrate: sender..  
	self flag: 'Don''t know what''s the sender exactly'.
	newReceiver := self safeMigrate:   receiver .  
	args := ( 1 to: ctx numArgs ) collect: [ :i | ctx at: i ].
	newCtx := MethodContext sender: newSender  
						 receiver: newReceiver 
						method: newMeth arguments: args. 
	
	"Transcript show: '------', newCtx ; cr. "
	
	clone instVarNamed: #outerContext put: newCtx.
	clone instVarNamed: #numArgs put: self  numArgs .
	clone instVarNamed: #startpc put: self  startpc .

	1 to: self size  do: [ :i |
				| p |
				p := self at: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToNextIfNecessary .
					clone at: i put: p nextMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					clone at:  i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]  .
		
	clone dirty: false.
	self nextMe: clone.
	clone prevMe: self.! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 9/8/2011 09:23'!
migrateToPrev
	<ctxMeta>
	Abort signal: 'Closure should never be dirty, hence never migrated back'! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 9/13/2011 17:04'!
newProcess

		|p ctx|
		ctx := CurrentContext instance. 
		ctx isNil ifTrue: [
			^ self primNewProcess. 
		] ifFalse: [
			p :=  [ ctx do:  self  ] primNewProcess.
			p environmentAt: #activeContext put: CurrentContext instance.
			^ p.
		].
	! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 7/7/2011 17:08'!
primNewProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self value.
			Processor terminateActive] asContext
		priority: Processor activePriority! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 9/7/2011 17:47'!
safeMigrate: aClassOrMetaclass
	aClassOrMetaclass ifNil: [ ^ nil ].
	aClassOrMetaclass isClass ifFalse: [ aClassOrMetaclass migrateToNextIfNecessary . ^ aClassOrMetaclass nextMe ].  
	aClassOrMetaclass isMeta ifTrue: [ aClassOrMetaclass theNonMetaClass migrateToNextIfNecessary.
									^ aClassOrMetaclass theNonMetaClass  nextMe class ] 
					ifFalse: [ aClassOrMetaclass migrateToNextIfNecessary .
						 		^ aClassOrMetaclass nextMe ].! !

!MCModification methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 13:12'!
hasEffectiveChanges
	^ ( self fromSource = self toSource ) not ! !

RBCompiler subclass: #BaseCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString 
	^ self evaluate: aString for: nil logged: false! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString for: anObject logged: aBoolean 
	^ self evaluate: aString for: anObject notifying: nil logged: aBoolean! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString for: anObject notifying: aController logged: aBoolean
	^ self new evaluate: aString in: nil to: anObject notifying: aController ifFail: [ ^ nil ] logged: aBoolean! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString logged: aBoolean 
	^ self evaluate: aString for: nil logged: aBoolean! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString notifying: aController logged: aBoolean 
	^ self evaluate: aString for: nil notifying: aController logged: aBoolean! !

!BaseCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 9/1/2011 15:51'!
translate: aProgramNode
| vis |
vis := self visitorClass new.
vis compiledClass: class.  
self flag: 'Skip class resolution is probably wrong. Classes whose instance only are contextual must still resolve *other* classes that could be contextual correctly, not only self-reference....'.
"((CurrentContext contextualClasses includes: class class) not and: [ class isMeta not ]  ) ifTrue:  [ vis skipClassResolution ]  ."
vis  visitNode: aProgramNode methodNode.
^ super translate: aProgramNode methodNode.
! !

BaseCompiler subclass: #ContextualCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextualCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 18:06'!
evaluate: textOrString for: anObject notifying: aController logged: logFlag
	"Compile and execute the argument, textOrString with respect to the class 
	of anObject. If a compilation error occurs, notify aController. If both 
	compilation and execution are successful then, if logFlag is true, log 
	(write) the text onto a system changes file so that it can be replayed if 
	necessary."

	^ self new
				evaluate: textOrString
				in: nil
				to: anObject
				notifying: aController
				ifFail: [^nil]
				logged: logFlag.! !

!ContextualCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 18:05'!
evaluate: textOrString notifying: aController logged: logFlag 
	"See Compiler|evaluate:for:notifying:logged:. Compilation is carried out 
	with respect to nil, i.e., no object."

	^self evaluate: textOrString for: nil notifying: aController logged: logFlag! !

!ContextualCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 11:30'!
visitorClass 
	^ ContextualProgramNodeVisitor! !

BaseCompiler subclass: #NormalizedCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!NormalizedCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:59'!
visitorClass 
	^ NormalizedProgramNodeVisitor  ! !

BaseCompiler subclass: #OptimizedContextualCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!OptimizedContextualCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 11:30'!
visitorClass 
	^ OptimizedContextualProgramNodeVisitor ! !

Collection subclass: #HashedCollectionL1
	instanceVariableNames: 'tally array __ctxInfo__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

HashedCollectionL1 subclass: #DictionaryL1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!DictionaryL1 class methodsFor: 'instance creation' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!DictionaryL1 class methodsFor: 'instance creation' stamp: 'ewe 9/26/2011 23:42'!
newFrom: t1 
	| t2 |
	t2 := self new: t1 size.
	t1
		associationsDo: [:t3 | (t2 includesKey: t3 key)
				ifTrue: [self error: 'Duplicate key: ' , t3 key printString]
				ifFalse: [t2 add: t3]].
	^ t2! !

!DictionaryL1 class methodsFor: 'instance creation' stamp: 'ewe 9/26/2011 23:42'!
newFromPairs: t1 
	| t2 |
	t2 := self new: t1 size / 2.
	1
		to: t1 size - 1
		by: 2
		do: [:t3 | t2
				at: (t1 at: t3)
				put: (t1 at: t3 + 1)].
	^ t2! !

!DictionaryL1 methodsFor: 'comparing' stamp: 'ewe 9/26/2011 23:42'!
= t1 
	self == t1
		ifTrue: [^ true].
	t1 isDictionary
		ifFalse: [^ false].
	self size = t1 size
		ifFalse: [^ false].
	self
		associationsDo: [:t2 | (t1
					at: t2 key
					ifAbsent: [^ false])
					= t2 value
				ifFalse: [^ false]].
	^ true! !

!DictionaryL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 11:25'!
_postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:30'!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element value: anAssociation value].
	^ anAssociation! !

!DictionaryL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:30'!
addAll: aKeyedCollection
	aKeyedCollection == self ifFalse: [
		aKeyedCollection keysAndValuesDo: [:key :value |
			self at: key put: value]].
	^aKeyedCollection! !

!DictionaryL1 methodsFor: 'converting' stamp: 'ewe 9/26/2011 23:42'!
asSet
	^ Set2 withAll: self! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
associationAt: key 
	^ self associationAt: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
associationAt: key ifAbsent: aBlock 
	"Answer the association with the given key.
	If key is not found, return the result of evaluating aBlock."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	nil == assoc ifTrue: [ ^ aBlock value ].
	^ assoc! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
associationDeclareAt: aKey
	"Return an existing association, or create and return a new one.  Needed as a single message by ImageSegment.prepareToBeSaved."

	^ self associationAt: aKey ifAbsent: [
		| existing |
		(Undeclared includesKey: aKey)
			ifTrue: 
				[existing := Undeclared associationAt: aKey.
				Undeclared removeKey: aKey.
				self add: existing]
			ifFalse: 
				[self add: aKey -> false]]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
associations
	"Answer a Collection containing the receiver's associations."
	"Suggested by l. Uzonyi"
	
	^Array new: self size streamContents: [ :stream |
		self associationsDo: [ :each | stream nextPut: each ] ]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
associationsDo: aBlock 
	"Evaluate aBlock for each of the receiver's elements (key/value 
	associations)."

	tally = 0 ifTrue: [^ self].
	array do:
		[:each |
		each ifNotNil: [aBlock value: each]]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/26/2011 23:42'!
associationsSelect: t1 
	| t2 |
	t2 := self species new.
	self
		associationsDo: [:t3 | (t1 value: t3)
				ifTrue: [t2 add: t3]].
	^ t2! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key 
	"Answer the value associated with the key."

	^ self at: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifAbsent: aBlock 
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."

	^((array at: (self findElementOrNil: key)) 
			ifNil: [aBlock] 
			ifNotNil: [:assoc | assoc]) value.! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifAbsentPut: aBlock 
	"Return the value at the given key. 
	If key is not included in the receiver store the result 
	of evaluating aBlock as new value."

	^ self at: key ifAbsent: [self at: key put: aBlock value]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| v |
	v := self at: key ifAbsent: [^ nil].
	^ aBlock value: v
! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifPresent: oneArgBlock ifAbsent: absentBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the oneArgBlock with the value associated with the key, otherwise answer the value of absentBlock."
	
	self at: key ifPresent: [ :v | ^oneArgBlock value: v ].
	^absentBlock value! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (Association key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := self species new.
	self associationsDo:[:each |
		newCollection at: each key put: (aBlock value: each value).
	].
	^newCollection! !

!DictionaryL1 methodsFor: 'adding' stamp: 'ewe 9/26/2011 23:42'!
declare: t1 from: t2 
	(self includesKey: t1)
		ifTrue: [^ self].
	(t2 includesKey: t1)
		ifTrue: [self
				add: (t2 associationAt: t1).
			t2 removeKey: t1]
		ifFalse: [self add: t1 -> nil]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
do: aBlock

	^self valuesDo: aBlock! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
errorKeyNotFound

	self error: 'key not found'! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
errorValueNotFound

	self error: 'value not found'! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: element key) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!DictionaryL1 methodsFor: 'printing' stamp: 'ewe 9/26/2011 23:42'!
flattenOnStream: t1 
	^ t1 writeDictionary: self! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
hasBindingThatBeginsWith: aString
	"Answer true if the receiver has a key that begins with aString, false otherwise"
	
	self keysDo:[:each | 
		(each beginsWith: aString)
			ifTrue:[^true]].
	^false! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includes: anObject

	self do: [:each | anObject = each ifTrue: [^true]].
	^false! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includesAssociation: anAssociation
  ^ (self   
      associationAt: anAssociation key
      ifAbsent: [ ^ false ]) value = anAssociation value
! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includesIdentity: anObject
	"Answer whether anObject is one of the values of the receiver.  Contrast #includes: in which there is only an equality check, here there is an identity check"

	self do: [:each | anObject == each ifTrue: [^ true]].
	^ false! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includesKey: key 
	"Answer whether the receiver has a key equal to the argument, key."
	
	self at: key ifAbsent: [^false].
	^true! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/26/2011 23:42'!
isDictionary
	^ true! !

!DictionaryL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keyAtIdentityValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer nil.
	Note: There can be multiple keys with the same value. Only one is returned."

	^self keyAtIdentityValue: value ifAbsent: [self errorValueNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keyAtIdentityValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	Note: There can be multiple keys with the same value. Only one is returned."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^association key]].
	^exceptionBlock value! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keyAtValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, signal an error."

	^self keyAtValue: value ifAbsent: [self errorValueNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/26/2011 23:42'!
keyAtValue: t1 ifAbsent: t2 
	self
		associationsDo: [:t3 | 
			t1 = t3 value
				ifTrue: [^ t3 key].
			nil].
	^ t2 value! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
keyForIdentity: anObject
	"If anObject is one of the values of the receive, return its key, else return nil.  Contrast #keyAtValue: in which there is only an equality check, here there is an identity check"

	self associationsDo: [:assoc | assoc value == anObject ifTrue: [^ assoc key]].
	^ nil! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keys
	"Answer an Array containing the receiver's keys."
	
	^Array new: self size streamContents: [:s| self keysDo: [:key| s nextPut: key]]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
keysAndValuesDo: aBlock
	^self associationsDo:[:assoc|
		aBlock value: assoc key value: assoc value].! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/26/2011 23:42'!
keysAndValuesRemove: t1 
	| t2 |
	t2 := OrderedCollection2 new.
	self
		associationsDo: [:t3 | (t1 value: t3 key value: t3 value)
				ifTrue: [t2 add: t3 key]].
	t2
		do: [:t3 | self removeKey: t3]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
keysDo: aBlock 
	"Evaluate aBlock for each of the receiver's keys."

	self associationsDo: [:association | aBlock value: association key]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keysSortedSafely
	"Answer an Array containing the receiver's keys."
 	"Suggested by l. Uzonyi"
	
 	| sortedKeys |
 	sortedKeys := Array 
						new: self size 
						streamContents: [ :stream |
 								self keysDo: [ :each | stream nextPut: each ] ].
 	sortedKeys sort: [ :x :y |
 		"Should really be use <obj, string, num> compareSafely..."
 		((x isString and: [ y isString ])
 			or: [ x isNumber and: [ y isNumber ] ])
 			ifTrue: [ x < y ]
 			ifFalse: [ x class == y class
 				ifTrue: [ x printString < y printString ]
 				ifFalse: [ x class name < y class name ] ] ].
 	^sortedKeys! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/26/2011 23:42'!
noCheckAdd: t1 
	self ctxReadarray
		at: (self findElementOrNil: t1 key)
		put: t1.
	self ctxWritetally: self ctxReadtally + 1! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :association |
			array
				at: (self scanForEmptySlotFor: association key)
				put: association ] ]! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| count |
	count := 0.
	self do: [:each | anObject = each ifTrue: [count := count + 1]].
	^count! !

!DictionaryL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 11:11'!
postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	super postCopy .
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:30'!
printElementsOn: aStream 
	aStream nextPut: $(.
	self size > 100
		ifTrue: [aStream nextPutAll: 'size '.
			self size printOn: aStream]
		ifFalse: [self keysSortedSafely
				do: [:key | aStream print: key;
						 nextPutAll: '->';				
						 print: (self at: key);
						 space]].
	aStream nextPut: $)! !

!DictionaryL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 14:32'!
printOn: aStream

	super printOn: aStream .
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]  ! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
rehash
	"Smalltalk rehash."
	| newSelf |
	newSelf := self species new: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
remove: anObject

	self shouldNotImplement! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
remove: anObject ifAbsent: exceptionBlock

	self shouldNotImplement! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."

	^ self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ assoc value! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeUnreferencedKeys   "Undeclared removeUnreferencedKeys"

	^ self unreferencedKeys do: [:key | self removeKey: key].! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/26/2011 23:42'!
select: t1 
	| t2 |
	t2 := self copyEmpty.
	self
		associationsDo: [:t3 | (t1 value: t3 value)
				ifTrue: [t2 add: t3 copy]].
	^ t2! !

!DictionaryL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:30'!
storeOn: aStream
	| noneYet |
	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new)'.
	noneYet := true.
	self associationsDo: 
			[:each | 
			noneYet
				ifTrue: [noneYet := false]
				ifFalse: [aStream nextPut: $;].
			aStream nextPutAll: ' add: '.
			aStream store: each].
	noneYet ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
unreferencedKeys
	"| uk | (Time millisecondsToRun: [uk := TextConstants unreferencedKeys]) -> uk"

	^'Scanning for references . . .' 
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: Smalltalk globals classNames size * 2
		during: 
			[:bar | | currentClass n associations referencedAssociations |
			currentClass := nil.
			n := 0.
			associations := self associations asIdentitySet.
			referencedAssociations := IdentitySet new: associations size.
			self systemNavigation allSelect:
				[:m|
				m methodClass ~~ currentClass ifTrue:
					[currentClass := m methodClass.
					 bar value: (n := n + 1)].
				m literalsDo:
					[:l|
					(l isVariableBinding and: [associations includes: l]) ifTrue:
						[referencedAssociations add: l]].
				false].
			((associations reject: [:assoc | referencedAssociations includes: assoc]) collect: [:assoc| assoc key]) asSet]! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/26/2011 23:42'!
valueAtNewKey: t1 put: t2 atIndex: t3 declareFrom: t4 
	(t4 includesKey: t1)
		ifTrue: [self
				atNewIndex: t3
				put: ((t4 associationAt: t1)
						value: t2).
			t4 removeKey: t1]
		ifFalse: [self
				atNewIndex: t3
				put: (Association2 key: t1 value: t2)]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
values
	"Answer a Collection containing the receiver's values."
	| out |
	out := (Array new: self size) writeStream.
	self valuesDo: [:value | out nextPut: value].
	^ out contents! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
valuesDo: aBlock 
	"Evaluate aBlock for each of the receiver's values."

	self associationsDo: [:association | aBlock value: association value]! !

DictionaryL1 subclass: #IdentityDictionaryL1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!IdentityDictionaryL1 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
fasterKeys
	"This was taking some time in publishing and we didn't really need a Set"
	| answer index |
	self deprecated: 'use keys. #fasterKeys
New implementation of #keys answers an Array and thus supersedes #fasterKeys both in Squeak3.11 and Pharo1.1'  on:  '9 February 2010' in: 'Pharo 1.1'.
	answer := Array new: self size.
	index := 0.
	self keysDo: [:key | answer at: (index := index + 1) put: key].
	^ answer! !

!IdentityDictionaryL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^ association key]].
	^ exceptionBlock value! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	finish := array size.
	start := (anObject identityHash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey identityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!HashedCollectionL1 class methodsFor: 'cleanup' stamp: 'ewe 9/6/2011 17:30'!
cleanUp: aggressive
	"Rehash all instances when cleaning aggressively"

	aggressive ifTrue: [self compactAll].
! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
compactAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #compactAllInstances! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
compactAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each compact ]! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
new
	^ self basicNew
		initialize: 5! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: (self sizeFor: nElements)! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	^self subclassResponsibility! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
rehashAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #rehashAllInstances! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
rehashAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each rehash ]! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
rehashAllSubInstances
	"HashedCollection rehashAll"	
	self deprecated: 'Use HashedCollection rehashAll ' on: '01 September 2010' in: 'Pharo1.2'.
	self rehashAll! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"
	
	nElements < 4 ifTrue: [ ^5 ].
	^ HashTableSizes atLeast: nElements +1 * 4 // 3! !

!HashedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:30'!
add: newObject withOccurrences: anInteger
	"Add newObject anInteger times to the receiver. Do nothing if anInteger is less than one. Answer newObject."
	
	anInteger < 1 ifTrue: [ ^newObject ].
	"I can only store an object once."
	^ self add: newObject! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
array
	^ array! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 9/12/2011 19:08'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!HashedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!HashedCollectionL1 methodsFor: 'objects from disk' stamp: 'ewe 9/6/2011 17:30'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self  compact.
	"^ self"
! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
compact
	"Reduce the size of array so that the load factor will be ~75%."
	
	| newCapacity |
	newCapacity := HashTableSizes atLeast: tally * 4 // 3.
	self growTo: newCapacity! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/14/2011 17:15'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!HashedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:30'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  __ctxInfo__! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadarray self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  array! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadtally self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  tally! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritearray: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ array := v2  ! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritetally: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ tally := v2  ! !

!HashedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
errorNoFreeSpace

	self error: 'There is no free space in this collection!!'! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	
	self subclassResponsibility! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 9/12/2011 19:01'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := Array new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
growSize
	"Answer what my next higher table size should be"

	^HashTableSizes atLeast: self capacity * 3 // 2 + 2
	! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
growTo: anInteger
	"Grow the elements array and reinsert the old elements"
	
	| oldElements |
	oldElements := array.
	array := Array new: anInteger.
	self noCheckNoGrowFillFrom: oldElements! !

!HashedCollectionL1 methodsFor: 'explorer' stamp: 'ewe 9/6/2011 17:30'!
hasContentsInExplorer

	^self notEmpty! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 1/15/2012 16:35'!
initialize: n
	"Initialize array to an array size of n"
	array := Array new: n.
	tally := 0  ! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 19:21'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."
	
	self subclassResponsibility! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 9/14/2011 11:12'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
rehash
	self growTo: self capacity! !

!HashedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or raise an error if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	self subclassResponsibility! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey hash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!HashedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
size
	^ tally! !

!HashedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!HashedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

HashedCollectionL1 subclass: #SetL1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new
	^ self basicNew
		initialize: 5;
		yourself! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: (self sizeFor: nElements)! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^ newCollection
"
	Set newFrom: {1. 2. 3}
	{1. 2. 3} as: Set
"! !

!SetL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:32'!
quickRehashAllSets  

	self deprecated: 'Use HashedCollection >> #rehashAll' on: '01 September 2010' in: 'Pharo1.2'.	
	HashedCollection rehashAll! !

!SetL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:32'!
rehashAllSets
	self deprecated: 'Use HashedCollection >> #rehashAll' on: '01 September 2010' in: 'Pharo1.2'.	
	HashedCollection rehashAll! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"

	^ HashTableSizes atLeast: nElements * 4 // 3! !

!SetL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: Set) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!SetL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 11:24'!
_postCopy
	<ctxMeta>
	super postCopy.
	
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	array := array copy! !

!SetL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject
	"Include newObject as one of the receiver's elements, but only if
	not already present. Answer newObject."

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) ifNil: [self atNewIndex: index put: newObject].
	^ newObject! !

!SetL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject withOccurrences: anInteger
	^ self add: newObject! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
array
	^ array! !

!SetL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 17:32'!
asSet
	^self! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
atRandom: aGenerator
	"Answer a random element of the receiver. Uses aGenerator which
should be kept by the user in a variable and used every time. Use
this instead of #atRandom for better uniformity of random numbers because 
	only you use the generator. Causes an error if self has no elements."
	| rand |

	self emptyCheck.
	rand := aGenerator nextInt: self size.
	self doWithIndex:[:each :ind |
		ind == rand ifTrue:[^each]].
	^ self errorEmptyCollection
! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newSet |
	newSet := Set new: self size.
	array do: [:each | each ifNotNil: [newSet add: (aBlock value: each)]].
	^ newSet! !

!SetL1 methodsFor: 'objects from disk' stamp: 'ewe 9/6/2011 17:32'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self rehash.
	"^ self"
! !

!SetL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!SetL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
copyWithout: oldElement 
	"Answer a copy of the receiver that does not contain any
	elements equal to oldElement."

	^ self copy
		remove: oldElement ifAbsent: [];
		yourself! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
do: aBlock 
	tally = 0 ifTrue: [^ self].
	array do:
		[:each |
		each ifNotNil: [aBlock value: each]]! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"

	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: element) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := Array new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!SetL1 methodsFor: 'explorer' stamp: 'ewe 9/6/2011 17:32'!
hasContentsInExplorer

	^self notEmpty! !

!SetL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
includes: anObject 
	^ (array at: (self findElementOrNil: anObject)) ~~ nil! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
initialize: n
	"Initialize array to an array size of n"
	array := Array new: n.
	tally := 0! !

!SetL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
like: anObject
	"Answer an object in the receiver that is equal to anObject,
	nil if no such object is found. Relies heavily on hash properties"

	| index |

	^(index := self scanFor: anObject) = 0
		ifFalse: [array at: index]! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject) put: anObject.
	tally := tally + 1! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :object |
			array
				at: (self scanForEmptySlotFor: object)
				put: object ] ]! !

!SetL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
occurrencesOf: anObject 
	^ (self includes: anObject) ifTrue: [1] ifFalse: [0]! !

!SetL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 12:18'!
postCopy
	<ctxMeta>
	super postCopy.
	
	array := array copy! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
rehash
	| newSelf |
	newSelf := self species new: self size.
	self do: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!SetL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
remove: oldObject ifAbsent: aBlock

	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ oldObject! !

!SetL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.
	
	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
select: aBlock 
	"Use copyEmpty instead of self species new to give subclasses a chance to initialize additional inst vars."

	"Note: this code could be moved to super"
	
	| newCollection |
	newCollection := self copyEmpty.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
size
	^ tally! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
withArray: anArray
	"private -- for use only in copy"
	"I want to get a conflict"
	array := anArray! !

Collection subclass: #HashedCollectionS1
	instanceVariableNames: 'tally array __ctxInfo__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

HashedCollectionS1 subclass: #DictionaryS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!DictionaryS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!DictionaryS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
newFrom: t1 
	| t2 |
	t2 := self new: t1 size.
	t1
		associationsDo: [:t3 | (t2 includesKey: t3 key)
				ifTrue: [self error: 'Duplicate key: ' , t3 key printString]
				ifFalse: [t2 add: t3]].
	^ t2! !

!DictionaryS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
newFromPairs: t1 
	| t2 |
	t2 := self new: t1 size / 2.
	1
		to: t1 size - 1
		by: 2
		do: [:t3 | t2
				at: (t1 at: t3)
				put: (t1 at: t3 + 1)].
	^ t2! !

!DictionaryS1 methodsFor: 'comparing' stamp: 'ewe 10/10/2012 12:01'!
= t1 
	self == t1
		ifTrue: [^ true].
	t1 isDictionary
		ifFalse: [^ false].
	self size = t1 size
		ifFalse: [^ false].
	self
		associationsDo: [:t2 | (t1
					at: t2 key
					ifAbsent: [^ false])
					= t2 value
				ifFalse: [^ false]].
	^ true! !

!DictionaryS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
_postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element value: anAssociation value].
	^ anAssociation! !

!DictionaryS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
addAll: aKeyedCollection
	aKeyedCollection == self ifFalse: [
		aKeyedCollection keysAndValuesDo: [:key :value |
			self at: key put: value]].
	^aKeyedCollection! !

!DictionaryS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:07'!
asSet
	^ SetL1 withAll: self! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
associationAt: key 
	^ self associationAt: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
associationAt: key ifAbsent: aBlock 
	"Answer the association with the given key.
	If key is not found, return the result of evaluating aBlock."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	nil == assoc ifTrue: [ ^ aBlock value ].
	^ assoc! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
associationDeclareAt: aKey
	"Return an existing association, or create and return a new one.  Needed as a single message by ImageSegment.prepareToBeSaved."

	^ self associationAt: aKey ifAbsent: [
		| existing |
		(Undeclared includesKey: aKey)
			ifTrue: 
				[existing := Undeclared associationAt: aKey.
				Undeclared removeKey: aKey.
				self add: existing]
			ifFalse: 
				[self add: aKey -> false]]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
associations
	"Answer a Collection containing the receiver's associations."
	"Suggested by l. Uzonyi"
	
	^Array new: self size streamContents: [ :stream |
		self associationsDo: [ :each | stream nextPut: each ] ]! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
associationsDo: aBlock 
	"Evaluate aBlock for each of the receiver's elements (key/value 
	associations)."

	tally = 0 ifTrue: [^ self].
	array do:
		[:each |
		each ifNotNil: [aBlock value: each]]! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
associationsSelect: t1 
	| t2 |
	t2 := self species new.
	self
		associationsDo: [:t3 | (t1 value: t3)
				ifTrue: [t2 add: t3]].
	^ t2! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: key 
	"Answer the value associated with the key."

	^ self at: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: key ifAbsent: aBlock 
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."

	^((array at: (self findElementOrNil: key)) 
			ifNil: [aBlock] 
			ifNotNil: [:assoc | assoc]) value.! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: key ifAbsentPut: aBlock 
	"Return the value at the given key. 
	If key is not included in the receiver store the result 
	of evaluating aBlock as new value."

	^ self at: key ifAbsent: [self at: key put: aBlock value]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| v |
	v := self at: key ifAbsent: [^ nil].
	^ aBlock value: v
! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: key ifPresent: oneArgBlock ifAbsent: absentBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the oneArgBlock with the value associated with the key, otherwise answer the value of absentBlock."
	
	self at: key ifPresent: [ :v | ^oneArgBlock value: v ].
	^absentBlock value! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (Association key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := self species new.
	self associationsDo:[:each |
		newCollection at: each key put: (aBlock value: each value).
	].
	^newCollection! !

!DictionaryS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
declare: t1 from: t2 
	(self includesKey: t1)
		ifTrue: [^ self].
	(t2 includesKey: t1)
		ifTrue: [self
				add: (t2 associationAt: t1).
			t2 removeKey: t1]
		ifFalse: [self add: t1 -> nil]! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
do: aBlock

	^self valuesDo: aBlock! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
errorKeyNotFound

	self error: 'key not found'! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
errorValueNotFound

	self error: 'value not found'! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: element key) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!DictionaryS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
flattenOnStream: t1 
	^ t1 writeDictionary: self! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
hasBindingThatBeginsWith: aString
	"Answer true if the receiver has a key that begins with aString, false otherwise"
	
	self keysDo:[:each | 
		(each beginsWith: aString)
			ifTrue:[^true]].
	^false! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
includes: anObject

	self do: [:each | anObject = each ifTrue: [^true]].
	^false! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
includesAssociation: anAssociation
  ^ (self   
      associationAt: anAssociation key
      ifAbsent: [ ^ false ]) value = anAssociation value
! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
includesIdentity: anObject
	"Answer whether anObject is one of the values of the receiver.  Contrast #includes: in which there is only an equality check, here there is an identity check"

	self do: [:each | anObject == each ifTrue: [^ true]].
	^ false! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
includesKey: key 
	"Answer whether the receiver has a key equal to the argument, key."
	
	self at: key ifAbsent: [^false].
	^true! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
isDictionary
	^ true! !

!DictionaryS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
keyAtIdentityValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer nil.
	Note: There can be multiple keys with the same value. Only one is returned."

	^self keyAtIdentityValue: value ifAbsent: [self errorValueNotFound]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
keyAtIdentityValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	Note: There can be multiple keys with the same value. Only one is returned."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^association key]].
	^exceptionBlock value! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
keyAtValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, signal an error."

	^self keyAtValue: value ifAbsent: [self errorValueNotFound]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
keyAtValue: t1 ifAbsent: t2 
	self
		associationsDo: [:t3 | 
			t1 = t3 value
				ifTrue: [^ t3 key].
			nil].
	^ t2 value! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
keyForIdentity: anObject
	"If anObject is one of the values of the receive, return its key, else return nil.  Contrast #keyAtValue: in which there is only an equality check, here there is an identity check"

	self associationsDo: [:assoc | assoc value == anObject ifTrue: [^ assoc key]].
	^ nil! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
keys
	"Answer an Array containing the receiver's keys."
	
	^Array new: self size streamContents: [:s| self keysDo: [:key| s nextPut: key]]! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
keysAndValuesDo: aBlock
	^self associationsDo:[:assoc|
		aBlock value: assoc key value: assoc value].! !

!DictionaryS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:08'!
keysAndValuesRemove: t1 
	| t2 |
	t2 := OrderedCollectionL1 new.
	self
		associationsDo: [:t3 | (t1 value: t3 key value: t3 value)
				ifTrue: [t2 add: t3 key]].
	t2
		do: [:t3 | self removeKey: t3]! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
keysDo: aBlock 
	"Evaluate aBlock for each of the receiver's keys."

	self associationsDo: [:association | aBlock value: association key]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
keysSortedSafely
	"Answer an Array containing the receiver's keys."
 	"Suggested by l. Uzonyi"
	
 	| sortedKeys |
 	sortedKeys := Array 
						new: self size 
						streamContents: [ :stream |
 								self keysDo: [ :each | stream nextPut: each ] ].
 	sortedKeys sort: [ :x :y |
 		"Should really be use <obj, string, num> compareSafely..."
 		((x isString and: [ y isString ])
 			or: [ x isNumber and: [ y isNumber ] ])
 			ifTrue: [ x < y ]
 			ifFalse: [ x class == y class
 				ifTrue: [ x printString < y printString ]
 				ifFalse: [ x class name < y class name ] ] ].
 	^sortedKeys! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
noCheckAdd: t1 
	self ctxReadarray
		at: (self findElementOrNil: t1 key)
		put: t1.
	self ctxWritetally: self ctxReadtally + 1! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :association |
			array
				at: (self scanForEmptySlotFor: association key)
				put: association ] ]! !

!DictionaryS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| count |
	count := 0.
	self do: [:each | anObject = each ifTrue: [count := count + 1]].
	^count! !

!DictionaryS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	super postCopy .
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
printElementsOn: aStream 
	aStream nextPut: $(.
	self size > 100
		ifTrue: [aStream nextPutAll: 'size '.
			self size printOn: aStream]
		ifFalse: [self keysSortedSafely
				do: [:key | aStream print: key;
						 nextPutAll: '->';				
						 print: (self at: key);
						 space]].
	aStream nextPut: $)! !

!DictionaryS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
printOn: aStream

	super printOn: aStream .
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]  ! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
rehash
	"Smalltalk rehash."
	| newSelf |
	newSelf := self species new: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!DictionaryS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
remove: anObject

	self shouldNotImplement! !

!DictionaryS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
remove: anObject ifAbsent: exceptionBlock

	self shouldNotImplement! !

!DictionaryS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."

	^ self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ assoc value! !

!DictionaryS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeUnreferencedKeys   "Undeclared removeUnreferencedKeys"

	^ self unreferencedKeys do: [:key | self removeKey: key].! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
select: t1 
	| t2 |
	t2 := self copyEmpty.
	self
		associationsDo: [:t3 | (t1 value: t3 value)
				ifTrue: [t2 add: t3 copy]].
	^ t2! !

!DictionaryS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
storeOn: aStream
	| noneYet |
	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new)'.
	noneYet := true.
	self associationsDo: 
			[:each | 
			noneYet
				ifTrue: [noneYet := false]
				ifFalse: [aStream nextPut: $;].
			aStream nextPutAll: ' add: '.
			aStream store: each].
	noneYet ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DictionaryS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
unreferencedKeys
	"| uk | (Time millisecondsToRun: [uk := TextConstants unreferencedKeys]) -> uk"

	^'Scanning for references . . .' 
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: Smalltalk globals classNames size * 2
		during: 
			[:bar | | currentClass n associations referencedAssociations |
			currentClass := nil.
			n := 0.
			associations := self associations asIdentitySet.
			referencedAssociations := IdentitySet new: associations size.
			self systemNavigation allSelect:
				[:m|
				m methodClass ~~ currentClass ifTrue:
					[currentClass := m methodClass.
					 bar value: (n := n + 1)].
				m literalsDo:
					[:l|
					(l isVariableBinding and: [associations includes: l]) ifTrue:
						[referencedAssociations add: l]].
				false].
			((associations reject: [:assoc | referencedAssociations includes: assoc]) collect: [:assoc| assoc key]) asSet]! !

!DictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:07'!
valueAtNewKey: t1 put: t2 atIndex: t3 declareFrom: t4 
	(t4 includesKey: t1)
		ifTrue: [self
				atNewIndex: t3
				put: ((t4 associationAt: t1)
						value: t2).
			t4 removeKey: t1]
		ifFalse: [self
				atNewIndex: t3
				put: (AssociationL1 key: t1 value: t2)]! !

!DictionaryS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
values
	"Answer a Collection containing the receiver's values."
	| out |
	out := (Array new: self size) writeStream.
	self valuesDo: [:value | out nextPut: value].
	^ out contents! !

!DictionaryS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
valuesDo: aBlock 
	"Evaluate aBlock for each of the receiver's values."

	self associationsDo: [:association | aBlock value: association value]! !

DictionaryS1 subclass: #IdentityDictionaryS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!IdentityDictionaryS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!IdentityDictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
fasterKeys
	"This was taking some time in publishing and we didn't really need a Set"
	| answer index |
	self deprecated: 'use keys. #fasterKeys
New implementation of #keys answers an Array and thus supersedes #fasterKeys both in Squeak3.11 and Pharo1.1'  on:  '9 February 2010' in: 'Pharo 1.1'.
	answer := Array new: self size.
	index := 0.
	self keysDo: [:key | answer at: (index := index + 1) put: key].
	^ answer! !

!IdentityDictionaryS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!IdentityDictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^ association key]].
	^ exceptionBlock value! !

!IdentityDictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	finish := array size.
	start := (anObject identityHash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!IdentityDictionaryS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey identityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!HashedCollectionS1 class methodsFor: 'cleanup' stamp: 'ewe 10/10/2012 12:01'!
cleanUp: aggressive
	"Rehash all instances when cleaning aggressively"

	aggressive ifTrue: [self compactAll].
! !

!HashedCollectionS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
compactAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #compactAllInstances! !

!HashedCollectionS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
compactAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each compact ]! !

!HashedCollectionS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!HashedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new
	^ self basicNew
		initialize: 5! !

!HashedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: (self sizeFor: nElements)! !

!HashedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	^self subclassResponsibility! !

!HashedCollectionS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
rehashAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #rehashAllInstances! !

!HashedCollectionS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
rehashAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each rehash ]! !

!HashedCollectionS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
rehashAllSubInstances
	"HashedCollection rehashAll"	
	self deprecated: 'Use HashedCollection rehashAll ' on: '01 September 2010' in: 'Pharo1.2'.
	self rehashAll! !

!HashedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"
	
	nElements < 4 ifTrue: [ ^5 ].
	^ HashTableSizes atLeast: nElements +1 * 4 // 3! !

!HashedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject withOccurrences: anInteger
	"Add newObject anInteger times to the receiver. Do nothing if anInteger is less than one. Answer newObject."
	
	anInteger < 1 ifTrue: [ ^newObject ].
	"I can only store an object once."
	^ self add: newObject! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
array
	^ array! !

!HashedCollectionS1 methodsFor: '*activecontext' stamp: 'ewe 10/10/2012 12:01'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!HashedCollectionS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!HashedCollectionS1 methodsFor: 'objects from disk' stamp: 'ewe 10/10/2012 12:01'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self  compact.
	"^ self"
! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
compact
	"Reduce the size of array so that the load factor will be ~75%."
	
	| newCapacity |
	newCapacity := HashTableSizes atLeast: tally * 4 // 3.
	self growTo: newCapacity! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!HashedCollectionS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  __ctxInfo__! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxReadarray self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  array! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxReadtally self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  tally! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWritearray: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ array := v2  ! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWritetally: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ tally := v2  ! !

!HashedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
errorNoFreeSpace

	self error: 'There is no free space in this collection!!'! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	
	self subclassResponsibility! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!HashedCollectionS1 methodsFor: '*activecontext' stamp: 'ewe 10/10/2012 12:01'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := Array new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
growSize
	"Answer what my next higher table size should be"

	^HashTableSizes atLeast: self capacity * 3 // 2 + 2
	! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
growTo: anInteger
	"Grow the elements array and reinsert the old elements"
	
	| oldElements |
	oldElements := array.
	array := Array new: anInteger.
	self noCheckNoGrowFillFrom: oldElements! !

!HashedCollectionS1 methodsFor: 'explorer' stamp: 'ewe 10/10/2012 12:01'!
hasContentsInExplorer

	^self notEmpty! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
initialize: n
	"Initialize array to an array size of n"
	array := Array new: n.
	tally := 0  ! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."
	
	self subclassResponsibility! !

!HashedCollectionS1 methodsFor: '*activecontext' stamp: 'ewe 10/10/2012 12:01'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
rehash
	self growTo: self capacity! !

!HashedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or raise an error if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	self subclassResponsibility! !

!HashedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey hash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!HashedCollectionS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
size
	^ tally! !

!HashedCollectionS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!HashedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

HashedCollectionS1 subclass: #SetS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!SetS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!SetS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new
	^ self basicNew
		initialize: 5;
		yourself! !

!SetS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: (self sizeFor: nElements)! !

!SetS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^ newCollection
"
	Set newFrom: {1. 2. 3}
	{1. 2. 3} as: Set
"! !

!SetS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
quickRehashAllSets  

	self deprecated: 'Use HashedCollection >> #rehashAll' on: '01 September 2010' in: 'Pharo1.2'.	
	HashedCollection rehashAll! !

!SetS1 class methodsFor: 'initialization' stamp: 'ewe 10/10/2012 12:01'!
rehashAllSets
	self deprecated: 'Use HashedCollection >> #rehashAll' on: '01 September 2010' in: 'Pharo1.2'.	
	HashedCollection rehashAll! !

!SetS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"

	^ HashTableSizes atLeast: nElements * 4 // 3! !

!SetS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: Set) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!SetS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
_postCopy
	<ctxMeta>
	super postCopy.
	
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	array := array copy! !

!SetS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject
	"Include newObject as one of the receiver's elements, but only if
	not already present. Answer newObject."

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) ifNil: [self atNewIndex: index put: newObject].
	^ newObject! !

!SetS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject withOccurrences: anInteger
	^ self add: newObject! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
array
	^ array! !

!SetS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:01'!
asSet
	^self! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!SetS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
atRandom: aGenerator
	"Answer a random element of the receiver. Uses aGenerator which
should be kept by the user in a variable and used every time. Use
this instead of #atRandom for better uniformity of random numbers because 
	only you use the generator. Causes an error if self has no elements."
	| rand |

	self emptyCheck.
	rand := aGenerator nextInt: self size.
	self doWithIndex:[:each :ind |
		ind == rand ifTrue:[^each]].
	^ self errorEmptyCollection
! !

!SetS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!SetS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newSet |
	newSet := Set new: self size.
	array do: [:each | each ifNotNil: [newSet add: (aBlock value: each)]].
	^ newSet! !

!SetS1 methodsFor: 'objects from disk' stamp: 'ewe 10/10/2012 12:01'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self rehash.
	"^ self"
! !

!SetS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!SetS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
copyWithout: oldElement 
	"Answer a copy of the receiver that does not contain any
	elements equal to oldElement."

	^ self copy
		remove: oldElement ifAbsent: [];
		yourself! !

!SetS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
do: aBlock 
	tally = 0 ifTrue: [^ self].
	array do:
		[:each |
		each ifNotNil: [aBlock value: each]]! !

!SetS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"

	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: element) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := Array new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!SetS1 methodsFor: 'explorer' stamp: 'ewe 10/10/2012 12:01'!
hasContentsInExplorer

	^self notEmpty! !

!SetS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
includes: anObject 
	^ (array at: (self findElementOrNil: anObject)) ~~ nil! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
initialize: n
	"Initialize array to an array size of n"
	array := Array new: n.
	tally := 0! !

!SetS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!SetS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
like: anObject
	"Answer an object in the receiver that is equal to anObject,
	nil if no such object is found. Relies heavily on hash properties"

	| index |

	^(index := self scanFor: anObject) = 0
		ifFalse: [array at: index]! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject) put: anObject.
	tally := tally + 1! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :object |
			array
				at: (self scanForEmptySlotFor: object)
				put: object ] ]! !

!SetS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
occurrencesOf: anObject 
	^ (self includes: anObject) ifTrue: [1] ifFalse: [0]! !

!SetS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
postCopy
	<ctxMeta>
	super postCopy.
	
	array := array copy! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
rehash
	| newSelf |
	newSelf := self species new: self size.
	self do: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!SetS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
remove: oldObject ifAbsent: aBlock

	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ oldObject! !

!SetS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.
	
	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!SetS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
select: aBlock 
	"Use copyEmpty instead of self species new to give subclasses a chance to initialize additional inst vars."

	"Note: this code could be moved to super"
	
	| newCollection |
	newCollection := self copyEmpty.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!SetS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
size
	^ tally! !

!SetS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!SetS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

!SetS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
withArray: anArray
	"private -- for use only in copy"
	"I want to get a conflict"
	array := anArray! !

!HashedCollection22 methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 15:28'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!HashedCollection22 methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 15:28'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!HashedCollection22 methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 15:28'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!Dictionary22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
_postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!Dictionary22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	super postCopy .
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!Dictionary22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
printOn: aStream

	super printOn: aStream .
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]  ! !

Magnitude subclass: #LookupKeyL1
	instanceVariableNames: 'key __ctxInfo__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

LookupKeyL1 subclass: #AssociationL1
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!AssociationL1 class methodsFor: 'instance creation' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!AssociationL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
key: newKey value: newValue
	"Answer an instance of me with the arguments as the key and value of 
	the association."

	^(super key: newKey) value: newValue! !

!AssociationL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
= anAssociation

	^ super = anAssociation and: [value = anAssociation value]! !

!AssociationL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadvalue self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  value! !

!AssociationL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritevalue: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty ].  ^ value := v2  ! !

!AssociationL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!AssociationL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 17:32'!
isSelfEvaluating
	^ self class == Association and: [self key isSelfEvaluating and: [self value isSelfEvaluating]]! !

!AssociationL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
key: aKey value: anObject 
	"Store the arguments as the variables of the receiver."

	key := aKey.
	value := anObject! !

!AssociationL1 methodsFor: 'printing' stamp: 'ewe 9/12/2011 14:28'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '-->'.
	value printOn: aStream.
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]
	! !

!AssociationL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:32'!
storeOn: aStream
	"Store in the format (key->value)"
	aStream nextPut: $(.
	key storeOn: aStream.
	aStream nextPutAll: '->'.
	value storeOn: aStream.
	aStream nextPut: $)! !

!AssociationL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
value
	"Answer the value of the receiver."

	^value! !

!AssociationL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
value: anObject 
	"Store the argument, anObject, as the value of the receiver."

	value := anObject! !

!LookupKeyL1 class methodsFor: 'instance creation' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!LookupKeyL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
key: aKey 
	"Answer an instance of me with the argument as the lookup up."

	^self basicNew key: aKey! !

!LookupKeyL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
< aLookupKey 
	"Refer to the comment in Magnitude|<."

	^key < aLookupKey key! !

!LookupKeyL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
= aLookupKey

	self species = aLookupKey species
		ifTrue: [^key = aLookupKey key]
		ifFalse: [^false]! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
canAssign

	^ true! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/14/2011 17:15'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  __ctxInfo__! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadkey self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  key! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritekey: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ key := v2  ! !

!LookupKeyL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
hash
	"Hash is reimplemented because = is implemented."

	^key hash! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 19:21'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!LookupKeyL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
isSpecialReadBinding
	"Return true if this variable binding is read protected, e.g., should not be accessed primitively but rather by sending #value messages"
	^false! !

!LookupKeyL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
isVariableBinding
	"Return true if I represent a literal variable binding"
	^true! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
key
	"Answer the lookup key of the receiver."

	^key! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
key: anObject 
	"Store the argument, anObject, as the lookup key of the receiver."

	key := anObject! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
name

	^ self key isString
		ifTrue: [self key]
		ifFalse: [self key printString]! !

!LookupKeyL1 methodsFor: '*activecontext' stamp: 'ewe 9/14/2011 11:12'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!LookupKeyL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:32'!
printOn: aStream

	key printOn: aStream! !

!LookupKeyL1 methodsFor: 'filter streaming' stamp: 'ewe 9/6/2011 17:32'!
writeOnFilterStream: aStream

	aStream write:key.! !

Magnitude subclass: #LookupKeyS1
	instanceVariableNames: 'key __ctxInfo__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

LookupKeyS1 subclass: #AssociationS1
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!AssociationS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!AssociationS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
key: newKey value: newValue
	"Answer an instance of me with the arguments as the key and value of 
	the association."

	^(super key: newKey) value: newValue! !

!AssociationS1 methodsFor: 'comparing' stamp: 'ewe 10/10/2012 12:01'!
= anAssociation

	^ super = anAssociation and: [value = anAssociation value]! !

!AssociationS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxReadvalue self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  value! !

!AssociationS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWritevalue: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty ].  ^ value := v2  ! !

!AssociationS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!AssociationS1 methodsFor: 'self evaluating' stamp: 'ewe 10/10/2012 12:01'!
isSelfEvaluating
	^ self class == Association and: [self key isSelfEvaluating and: [self value isSelfEvaluating]]! !

!AssociationS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
key: aKey value: anObject 
	"Store the arguments as the variables of the receiver."

	key := aKey.
	value := anObject! !

!AssociationS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '-->'.
	value printOn: aStream.
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]
	! !

!AssociationS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
storeOn: aStream
	"Store in the format (key->value)"
	aStream nextPut: $(.
	key storeOn: aStream.
	aStream nextPutAll: '->'.
	value storeOn: aStream.
	aStream nextPut: $)! !

!AssociationS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
value
	"Answer the value of the receiver."

	^value! !

!AssociationS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
value: anObject 
	"Store the argument, anObject, as the value of the receiver."

	value := anObject! !

!LookupKeyS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!LookupKeyS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
key: aKey 
	"Answer an instance of me with the argument as the lookup up."

	^self basicNew key: aKey! !

!LookupKeyS1 methodsFor: 'comparing' stamp: 'ewe 10/10/2012 12:01'!
< aLookupKey 
	"Refer to the comment in Magnitude|<."

	^key < aLookupKey key! !

!LookupKeyS1 methodsFor: 'comparing' stamp: 'ewe 10/10/2012 12:01'!
= aLookupKey

	self species = aLookupKey species
		ifTrue: [^key = aLookupKey key]
		ifFalse: [^false]! !

!LookupKeyS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
canAssign

	^ true! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  __ctxInfo__! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxReadkey self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  key! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWritekey: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ key := v2  ! !

!LookupKeyS1 methodsFor: 'comparing' stamp: 'ewe 10/10/2012 12:01'!
hash
	"Hash is reimplemented because = is implemented."

	^key hash! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!LookupKeyS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
isSpecialReadBinding
	"Return true if this variable binding is read protected, e.g., should not be accessed primitively but rather by sending #value messages"
	^false! !

!LookupKeyS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
isVariableBinding
	"Return true if I represent a literal variable binding"
	^true! !

!LookupKeyS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
key
	"Answer the lookup key of the receiver."

	^key! !

!LookupKeyS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
key: anObject 
	"Store the argument, anObject, as the lookup key of the receiver."

	key := anObject! !

!LookupKeyS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
name

	^ self key isString
		ifTrue: [self key]
		ifFalse: [self key printString]! !

!LookupKeyS1 methodsFor: '*activecontext' stamp: 'ewe 10/10/2012 12:01'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!LookupKeyS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
printOn: aStream

	key printOn: aStream! !

!LookupKeyS1 methodsFor: 'filter streaming' stamp: 'ewe 10/10/2012 12:01'!
writeOnFilterStream: aStream

	aStream write:key.! !

!Magnitude methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:28'!
isPrimitive ^true! !

SequenceableCollection subclass: #OrderedCollectionL1
	uses: TSortable
	instanceVariableNames: 'array firstIndex lastIndex __ctxInfo__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

OrderedCollectionL1 class
	uses: TSortable classTrait
	instanceVariableNames: ''!

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new
	^ self new: 10! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new: anInteger 
	"Create a collection with enough room allocated to contain up to anInteger elements.
	The new instance will be of size 0 (allocated room is not necessarily used)."
	
	^self basicNew setCollection: (Array new: anInteger)! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new: anInteger withAll: anObject
	^ self basicNew setContents: (Array new: anInteger withAll: anObject)! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."

	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^newCollection

"	OrderedCollection newFrom: {1. 2. 3}
	{1. 2. 3} as: OrderedCollection
	{4. 2. 7} as: SortedCollection
"! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
ofSize: n
	"Create a new collection of size n with nil as its elements.
	This method exists because OrderedCollection new: n creates an
	empty collection,  not one of size n."
	| collection |
	collection := self new: n.
	collection setContents: (collection collector).
	^ collection
! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 11:24'!
_postCopy
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	array := array copy! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 11:24'!
_postCopyFrom: startIndex to: endIndex 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject

	^self addLast: newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject after: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just succeeding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index + 1.
	^newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject afterIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just after index. Answer newObject."
	(index between: 0 and: self size) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject before: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just preceding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index.
	^newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject beforeIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just before index. Answer newObject."
	(index between: 1 and: self size+1) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index - 1.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAll: aCollection 
	"Add each element of aCollection at my end. Answer	aCollection."

	^ self addAllLast: aCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAllFirst: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the 
	receiver. Answer anOrderedCollection."

	anOrderedCollection reverseDo: [:each | self addFirst: each].
	^anOrderedCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAllFirstUnlessAlreadyPresent: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the receiver, preserving the order, but do not add any items that are already in the receiver.  Answer anOrderedCollection."

	anOrderedCollection reverseDo:
		[:each | (self includes: each) ifFalse: [self addFirst: each]].
	^ anOrderedCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAllLast: aCollection 
	"Add each element of aCollection at the end of the receiver. 
	Answer aCollection."

	aCollection do: [:each | self addLast: each].
	^aCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addFirst: newObject 
	"Add newObject to the beginning of the receiver. Answer newObject."

	firstIndex = 1 ifTrue: [self makeRoomAtFirst].
	firstIndex := firstIndex - 1.
	array at: firstIndex put: newObject.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 17:32'!
asArray
	^ (Array new: self size) replaceFrom: 1 to: self size with: array startingAt: firstIndex.! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 19:08'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
asSortedArray
	self deprecated: 'Use asArray sort' on: '01 April 2010' in: 'Pharo1.1'.
	self isSorted ifTrue: [^ self asArray].
	^ super asSortedArray! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"

	(anInteger < 1 or: [anInteger + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^ array at: anInteger + firstIndex - 1]! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
at: index ifAbsentPut: block
	"Return value at index, however, if value does not exist (nil or out of bounds) then add block's value at index (growing self if necessary)"

	| v |
	index <= self size ifTrue: [
		^ (v := self at: index)
			ifNotNil: [v]
			ifNil: [self at: index put: block value]
	].
	[self size < index] whileTrue: [self add: nil].
	^ self at: index put: block value! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."

	| index |
	index := anInteger asInteger.
	(index < 1 or: [index + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^array at: index + firstIndex - 1 put: anObject]! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: aBlock from: fromIndex to: toIndex
	"Override superclass in order to use addLast:, not at:put:."
	| result |
	(fromIndex < 1 or:[toIndex + firstIndex - 1 > lastIndex])
		ifTrue: [^self errorNoSuchElement].
	result := self species new: toIndex - fromIndex + 1.
	firstIndex + fromIndex - 1 to: firstIndex + toIndex - 1 do:
		[:index | result addLast: (aBlock value: (array at: index))].
	^ result
! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: collectBlock thenSelect: selectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection."

    | newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[: index | 
		| newElement |
		newElement := collectBlock value: ( array at: index ).
		( selectBlock value: newElement ) 
			ifTrue:[ newCollection addLast: newElement. ]
    ].
    ^ newCollection! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
collector  "Private"
	^ array! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/14/2011 17:15'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyEmpty
	"Answer a copy of the receiver that contains no elements."

	^self species new! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyFrom: startIndex to: endIndex 
	"Answer a copy of the receiver that contains elements from position
	startIndex to endIndex."

	^self shallowCopy postCopyFrom: startIndex to: endIndex! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver with replacementCollection's elements in
	place of the receiver's start'th to stop'th elements. This does not expect
	a 1-1 map from replacementCollection to the start to stop elements, so it
	will do an insert or append."

	| newOrderedCollection delta startIndex stopIndex |
	"if start is less than 1, ignore stop and assume this is inserting at the front. 
	if start greater than self size, ignore stop and assume this is appending. 
	otherwise, it is replacing part of me and start and stop have to be within my 
	bounds. "
	delta := 0.
	startIndex := start.
	stopIndex := stop.
	start < 1
		ifTrue: [startIndex := stopIndex := 0]
		ifFalse: [startIndex > self size
				ifTrue: [startIndex := stopIndex := self size + 1]
				ifFalse: 
					[(stopIndex < (startIndex - 1) or: [stopIndex > self size])
						ifTrue: [self errorOutOfBounds].
					delta := stopIndex - startIndex + 1]].
	newOrderedCollection := 
		self species new: self size + replacementCollection size - delta.
	1 to: startIndex - 1 do: [:index | newOrderedCollection add: (self at: index)].
	1 to: replacementCollection size do: 
		[:index | newOrderedCollection add: (replacementCollection at: index)].
	stopIndex + 1 to: self size do: [:index | newOrderedCollection add: (self at: index)].
	^newOrderedCollection! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and 
	includes the argument, newElement, at the end."

	| newCollection |
	newCollection := self copy.
	newCollection add: newElement.
	^newCollection! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 4 ]. ^  __ctxInfo__! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadarray self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  array! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadfirstIndex self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  firstIndex! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadlastIndex self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  lastIndex! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 4 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritearray: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ array := v2  ! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritefirstIndex: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ firstIndex := v2  ! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritelastIndex: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty ].  ^ lastIndex := v2  ! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
do: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index + 1]! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
errorConditionNotSatisfied

	self error: 'no element satisfies condition'! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
errorNoSuchElement

	self error: 'attempt to index non-existent element in an ordered collection'! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
find: oldObject
  "  This method answers an index in the range firstIndex .. lastIndex, which is meant for internal use only.
     Never use this method in your code, the methods for public use are:
        #indexOf:
        #indexOf:ifAbsent: "

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue:
			[(array at: index) = oldObject ifTrue: [^ index].
			index := index + 1].
	self errorNotFound: oldObject! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 19:01'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray := Array new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
growSize
	^ array size max: 2! !

!OrderedCollectionL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
hasContentsInExplorer

	^self notEmpty! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
insert: anObject before: spot

  "  spot is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection. 
     Never use this method in your code, it is meant for private use by OrderedCollection only.
     The methods for use are:
        #add:before:   to insert an object before another object
        #add:beforeIndex:   to insert an object before a given position. "
	| "index" delta spotIndex|
	spotIndex := spot.
	delta := spotIndex - firstIndex.
	firstIndex = 1
		ifTrue: 
			[self makeRoomAtFirst.
			spotIndex := firstIndex + delta].
	firstIndex := firstIndex - 1.
	array
		replaceFrom: firstIndex
		to: spotIndex - 2
		with: array
		startingAt: firstIndex + 1.
	array at: spotIndex - 1 put: anObject.
"	index := firstIndex := firstIndex - 1.
	[index < (spotIndex - 1)]
		whileTrue: 
			[array at: index put: (array at: index + 1).
			index := index + 1].
	array at: index put: anObject."
	^ anObject! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 19:21'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
isSorted
	"Return true if the receiver is sorted by the given criterion.
	Optimization for isSortedBy: [:a :b | a <= b]."

	| lastElm elm |
	self isEmpty ifTrue: [^ true].
	lastElm := self first.
	2 to: self size do: 
		[:index | 
		elm := self at: index.
		lastElm <= elm ifFalse: [^ false].
		lastElm := elm].
	^ true! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
isSortedBy: aBlock
	"Return true if the receiver is sorted by the given criterion."

	| lastElm elm |
	self isEmpty ifTrue: [^ true].
	lastElm := self first.
	2 to: self size do: 
		[:index | 
		elm := self at: index.
		(aBlock value: lastElm value: elm) ifFalse: [^ false].
		lastElm := elm].
	^ true! !

!OrderedCollectionL1 methodsFor: 'splitjoin' stamp: 'ewe 9/6/2011 17:32'!
join: aCollection 
	| result |
	result := self class new.
	aCollection
		do: [:each | each appendTo: result]
		separatedBy: [self appendTo: result].
	^ result! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
makeRoomAtFirst
	| delta index |
	delta := array size - self size.
	delta = 0 ifTrue: 
			[self grow.
			delta := array size - self size].
	lastIndex = array size ifTrue: [^ self]. "just in case we got lucky"
	index := array size.
	[index > delta]
		whileTrue: 
			[array at: index put: (array at: index - delta + firstIndex - 1).
			array at: index - delta + firstIndex - 1 put: nil.
			index := index - 1].
	firstIndex := delta + 1.
	lastIndex := array size! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
mergeFirst: first middle: middle last: last into: dst by: aBlock
	"Private. Merge the sorted ranges [first..middle] and [middle+1..last] 
	of the receiver into the range [first..last] of dst."

	| i1 i2 val1 val2 out |
	i1 := first.
	i2 := middle + 1.
	val1 := self at: i1.
	val2 := self at: i2.
	out := first - 1.  "will be pre-incremented"

	"select 'lower' half of the elements based on comparator"
	[(i1 <= middle) and: [i2 <= last]] whileTrue:
		[(aBlock value: val1 value: val2)
			ifTrue: [dst at: (out := out + 1) put: val1.
					val1 := self at: (i1 := i1 + 1)]
			ifFalse: [dst at: (out := out + 1) put: val2.
					i2 := i2 + 1.
					i2 <= last ifTrue: [val2 := self at: i2]]].

	"copy the remaining elements"
	i1 <= middle
		ifTrue: [dst replaceFrom: out + 1 to: last with: self startingAt: i1]
		ifFalse: [dst replaceFrom: out + 1 to: last with: self startingAt: i2]! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self copy 
		dst: self 
		by: aBlock! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
mergeSortFrom: first to: last src: src dst: dst by: aBlock
	"Private. Split the range to be sorted in half, sort each half, and 
	merge the two half-ranges into dst."

	| middle |
	first = last ifTrue: [^ self].
	middle := (first + last) // 2.
	self mergeSortFrom: first to: middle src: dst dst: src by: aBlock.
	self mergeSortFrom: middle + 1 to: last src: dst dst: src by: aBlock.
	src mergeFirst: first middle: middle last: last into: dst by: aBlock! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 15:53'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .
	array := array copy! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 12:19'!
postCopyFrom: startIndex to: endIndex 
	<ctxMeta>

	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
remove: oldObject ifAbsent: absentBlock

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[oldObject = (array at: index)
				ifTrue: 
					[self removeIndex: index.
					^ oldObject]
				ifFalse: [index := index + 1]].
	^ absentBlock value! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAll
	"remove all the elements from this collection.
	Keep same amount of storage"
	
	self setCollection: (Array new: array size)! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAllSuchThat: aBlock 
	"Remove each element of the receiver for which aBlock evaluates to true.
	The method in Collection is O(N^2), this is O(N)."

	| n |
	n := firstIndex.
	firstIndex to: lastIndex do: [:index |
	    (aBlock value: (array at: index)) ifFalse: [
			array at: n put: (array at: index).
			n := n + 1]].
	array from: n to: lastIndex put: nil.
	lastIndex := n - 1! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAt: index
	| removed |
	removed := self at: index.
	self removeIndex: index + firstIndex - 1.
	^removed! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeFirst
	"Remove the first element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| firstObject |
	self emptyCheck.
	firstObject := array at: firstIndex.
	array at: firstIndex put: nil.
	firstIndex := firstIndex + 1.
	^ firstObject! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeFirst: n
	"Remove first n object into an array"

	| list |
	list := Array new: n.
	1 to: n do: [:i |
		list at: i put: self removeFirst].
	^ list! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
removeIndex: removedIndex
  "  removedIndex is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection.
    Never use this method in your code, it is meant for private use by OrderedCollection only.
     The method for public use is:
        #removeAt: "

	array 
		replaceFrom: removedIndex 
		to: lastIndex - 1 
		with: array 
		startingAt: removedIndex+1.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeLast
	"Remove the last element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| lastObject |
	self emptyCheck.
	lastObject := array at: lastIndex.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.
	^ lastObject! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeLast: n
	"Remove last n object into an array with last in last position"

	| list |
	list := Array new: n.
	n to: 1 by: -1 do: [:i |
		list at: i put: self removeLast].
	^ list! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
resetTo: index
	firstIndex := index.
	lastIndex := firstIndex - 1! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
reverseDo: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := lastIndex.
	[index >= firstIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index - 1]! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
reversed
	"Answer a copy of the receiver with element order reversed.  "
	| newCol |
	newCol := self species new.
	self reverseDo:
		[:elem | newCol addLast: elem].
	^ newCol

"#(2 3 4 'fred') reversed"! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
select: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect into
	a new collection like the receiver, only those elements for which aBlock
	evaluates to true."

	| newCollection element |
	newCollection := self copyEmpty.
	firstIndex to: lastIndex do:
		[:index |
		(aBlock value: (element := array at: index))
			ifTrue: [newCollection addLast: element]].
	^ newCollection! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
select: selectBlock thenCollect: collectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection. "

	| newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[:index |
		| element |
		element := array at: index.
		( selectBlock value: element ) 
			ifTrue:[ newCollection addLast: ( collectBlock value: element ) ]
    ].
    ^ newCollection! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
setCollection: anArray
	array := anArray.
	self reset! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
setContents: anArray
	array := anArray.
	firstIndex := 1.
	lastIndex := array size.! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
sort
	"Sort the receiver into ascending order using the '<=' operator."

	self sort: [:a :b | a <= b]! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
sort: aSortBlock 
	"Sort this array using aSortBlock. The block should take two arguments
	and return true if the first element should preceed the second one."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	array
		mergeSortFrom: firstIndex
		to: lastIndex 
		src: array shallowCopy 
		dst: array 
		by: aSortBlock! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if the first element should preceed the second one. If aSortBlock is nil then <= is used for comparison."
	
	^self copy sort: aSortBlockOrNil! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with 
	corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result := self species new: self size.
	1 to: self size do:
		[:index | result addLast: (twoArgBlock value: (self at: index)
									value: (otherCollection at: index))].
	^ result! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (elementAndIndexBlock
			value: (array at: index)
			value: index - firstIndex + 1)].
	^ newCollection! !

SequenceableCollection subclass: #OrderedCollectionS1
	uses: TSortable
	instanceVariableNames: 'array firstIndex lastIndex __ctxInfo__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

OrderedCollectionS1 class
	uses: TSortable classTrait
	instanceVariableNames: ''!

!OrderedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!OrderedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new
	^ self new: 10! !

!OrderedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new: anInteger 
	"Create a collection with enough room allocated to contain up to anInteger elements.
	The new instance will be of size 0 (allocated room is not necessarily used)."
	
	^self basicNew setCollection: (Array new: anInteger)! !

!OrderedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new: anInteger withAll: anObject
	^ self basicNew setContents: (Array new: anInteger withAll: anObject)! !

!OrderedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."

	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^newCollection

"	OrderedCollection newFrom: {1. 2. 3}
	{1. 2. 3} as: OrderedCollection
	{4. 2. 7} as: SortedCollection
"! !

!OrderedCollectionS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
ofSize: n
	"Create a new collection of size n with nil as its elements.
	This method exists because OrderedCollection new: n creates an
	empty collection,  not one of size n."
	| collection |
	collection := self new: n.
	collection setContents: (collection collector).
	^ collection
! !

!OrderedCollectionS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
_postCopy
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	array := array copy! !

!OrderedCollectionS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
_postCopyFrom: startIndex to: endIndex 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject

	^self addLast: newObject! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject after: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just succeeding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index + 1.
	^newObject! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject afterIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just after index. Answer newObject."
	(index between: 0 and: self size) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index.
	^ newObject! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject before: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just preceding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index.
	^newObject! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
add: newObject beforeIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just before index. Answer newObject."
	(index between: 1 and: self size+1) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index - 1.
	^ newObject! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
addAll: aCollection 
	"Add each element of aCollection at my end. Answer	aCollection."

	^ self addAllLast: aCollection! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
addAllFirst: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the 
	receiver. Answer anOrderedCollection."

	anOrderedCollection reverseDo: [:each | self addFirst: each].
	^anOrderedCollection! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
addAllFirstUnlessAlreadyPresent: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the receiver, preserving the order, but do not add any items that are already in the receiver.  Answer anOrderedCollection."

	anOrderedCollection reverseDo:
		[:each | (self includes: each) ifFalse: [self addFirst: each]].
	^ anOrderedCollection! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
addAllLast: aCollection 
	"Add each element of aCollection at the end of the receiver. 
	Answer aCollection."

	aCollection do: [:each | self addLast: each].
	^aCollection! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
addFirst: newObject 
	"Add newObject to the beginning of the receiver. Answer newObject."

	firstIndex = 1 ifTrue: [self makeRoomAtFirst].
	firstIndex := firstIndex - 1.
	array at: firstIndex put: newObject.
	^ newObject! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!OrderedCollectionS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:01'!
asArray
	^ (Array new: self size) replaceFrom: 1 to: self size with: array startingAt: firstIndex.! !

!OrderedCollectionS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!OrderedCollectionS1 methodsFor: 'sorting' stamp: 'ewe 10/10/2012 12:01'!
asSortedArray
	self deprecated: 'Use asArray sort' on: '01 April 2010' in: 'Pharo1.1'.
	self isSorted ifTrue: [^ self asArray].
	^ super asSortedArray! !

!OrderedCollectionS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"

	(anInteger < 1 or: [anInteger + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^ array at: anInteger + firstIndex - 1]! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
at: index ifAbsentPut: block
	"Return value at index, however, if value does not exist (nil or out of bounds) then add block's value at index (growing self if necessary)"

	| v |
	index <= self size ifTrue: [
		^ (v := self at: index)
			ifNotNil: [v]
			ifNil: [self at: index put: block value]
	].
	[self size < index] whileTrue: [self add: nil].
	^ self at: index put: block value! !

!OrderedCollectionS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."

	| index |
	index := anInteger asInteger.
	(index < 1 or: [index + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^array at: index + firstIndex - 1 put: anObject]! !

!OrderedCollectionS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
collect: aBlock from: fromIndex to: toIndex
	"Override superclass in order to use addLast:, not at:put:."
	| result |
	(fromIndex < 1 or:[toIndex + firstIndex - 1 > lastIndex])
		ifTrue: [^self errorNoSuchElement].
	result := self species new: toIndex - fromIndex + 1.
	firstIndex + fromIndex - 1 to: firstIndex + toIndex - 1 do:
		[:index | result addLast: (aBlock value: (array at: index))].
	^ result
! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
collect: collectBlock thenSelect: selectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection."

    | newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[: index | 
		| newElement |
		newElement := collectBlock value: ( array at: index ).
		( selectBlock value: newElement ) 
			ifTrue:[ newCollection addLast: newElement. ]
    ].
    ^ newCollection! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
collector  "Private"
	^ array! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!OrderedCollectionS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
copyEmpty
	"Answer a copy of the receiver that contains no elements."

	^self species new! !

!OrderedCollectionS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
copyFrom: startIndex to: endIndex 
	"Answer a copy of the receiver that contains elements from position
	startIndex to endIndex."

	^self shallowCopy postCopyFrom: startIndex to: endIndex! !

!OrderedCollectionS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver with replacementCollection's elements in
	place of the receiver's start'th to stop'th elements. This does not expect
	a 1-1 map from replacementCollection to the start to stop elements, so it
	will do an insert or append."

	| newOrderedCollection delta startIndex stopIndex |
	"if start is less than 1, ignore stop and assume this is inserting at the front. 
	if start greater than self size, ignore stop and assume this is appending. 
	otherwise, it is replacing part of me and start and stop have to be within my 
	bounds. "
	delta := 0.
	startIndex := start.
	stopIndex := stop.
	start < 1
		ifTrue: [startIndex := stopIndex := 0]
		ifFalse: [startIndex > self size
				ifTrue: [startIndex := stopIndex := self size + 1]
				ifFalse: 
					[(stopIndex < (startIndex - 1) or: [stopIndex > self size])
						ifTrue: [self errorOutOfBounds].
					delta := stopIndex - startIndex + 1]].
	newOrderedCollection := 
		self species new: self size + replacementCollection size - delta.
	1 to: startIndex - 1 do: [:index | newOrderedCollection add: (self at: index)].
	1 to: replacementCollection size do: 
		[:index | newOrderedCollection add: (replacementCollection at: index)].
	stopIndex + 1 to: self size do: [:index | newOrderedCollection add: (self at: index)].
	^newOrderedCollection! !

!OrderedCollectionS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and 
	includes the argument, newElement, at the end."

	| newCollection |
	newCollection := self copy.
	newCollection add: newElement.
	^newCollection! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 4 ]. ^  __ctxInfo__! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxReadarray self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  array! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxReadfirstIndex self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  firstIndex! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxReadlastIndex self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  lastIndex! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 4 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWritearray: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ array := v2  ! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWritefirstIndex: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ firstIndex := v2  ! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWritelastIndex: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty ].  ^ lastIndex := v2  ! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
do: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index + 1]! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
errorConditionNotSatisfied

	self error: 'no element satisfies condition'! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
errorNoSuchElement

	self error: 'attempt to index non-existent element in an ordered collection'! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
find: oldObject
  "  This method answers an index in the range firstIndex .. lastIndex, which is meant for internal use only.
     Never use this method in your code, the methods for public use are:
        #indexOf:
        #indexOf:ifAbsent: "

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue:
			[(array at: index) = oldObject ifTrue: [^ index].
			index := index + 1].
	self errorNotFound: oldObject! !

!OrderedCollectionS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray := Array new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!OrderedCollectionS1 methodsFor: 'adding' stamp: 'ewe 10/10/2012 12:01'!
growSize
	^ array size max: 2! !

!OrderedCollectionS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
hasContentsInExplorer

	^self notEmpty! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
insert: anObject before: spot

  "  spot is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection. 
     Never use this method in your code, it is meant for private use by OrderedCollection only.
     The methods for use are:
        #add:before:   to insert an object before another object
        #add:beforeIndex:   to insert an object before a given position. "
	| "index" delta spotIndex|
	spotIndex := spot.
	delta := spotIndex - firstIndex.
	firstIndex = 1
		ifTrue: 
			[self makeRoomAtFirst.
			spotIndex := firstIndex + delta].
	firstIndex := firstIndex - 1.
	array
		replaceFrom: firstIndex
		to: spotIndex - 2
		with: array
		startingAt: firstIndex + 1.
	array at: spotIndex - 1 put: anObject.
"	index := firstIndex := firstIndex - 1.
	[index < (spotIndex - 1)]
		whileTrue: 
			[array at: index put: (array at: index + 1).
			index := index + 1].
	array at: index put: anObject."
	^ anObject! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!OrderedCollectionS1 methodsFor: 'sorting' stamp: 'ewe 10/10/2012 12:01'!
isSorted
	"Return true if the receiver is sorted by the given criterion.
	Optimization for isSortedBy: [:a :b | a <= b]."

	| lastElm elm |
	self isEmpty ifTrue: [^ true].
	lastElm := self first.
	2 to: self size do: 
		[:index | 
		elm := self at: index.
		lastElm <= elm ifFalse: [^ false].
		lastElm := elm].
	^ true! !

!OrderedCollectionS1 methodsFor: 'sorting' stamp: 'ewe 10/10/2012 12:01'!
isSortedBy: aBlock
	"Return true if the receiver is sorted by the given criterion."

	| lastElm elm |
	self isEmpty ifTrue: [^ true].
	lastElm := self first.
	2 to: self size do: 
		[:index | 
		elm := self at: index.
		(aBlock value: lastElm value: elm) ifFalse: [^ false].
		lastElm := elm].
	^ true! !

!OrderedCollectionS1 methodsFor: 'splitjoin' stamp: 'ewe 10/10/2012 12:01'!
join: aCollection 
	| result |
	result := self class new.
	aCollection
		do: [:each | each appendTo: result]
		separatedBy: [self appendTo: result].
	^ result! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
makeRoomAtFirst
	| delta index |
	delta := array size - self size.
	delta = 0 ifTrue: 
			[self grow.
			delta := array size - self size].
	lastIndex = array size ifTrue: [^ self]. "just in case we got lucky"
	index := array size.
	[index > delta]
		whileTrue: 
			[array at: index put: (array at: index - delta + firstIndex - 1).
			array at: index - delta + firstIndex - 1 put: nil.
			index := index - 1].
	firstIndex := delta + 1.
	lastIndex := array size! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!OrderedCollectionS1 methodsFor: 'sorting' stamp: 'ewe 10/10/2012 12:01'!
mergeFirst: first middle: middle last: last into: dst by: aBlock
	"Private. Merge the sorted ranges [first..middle] and [middle+1..last] 
	of the receiver into the range [first..last] of dst."

	| i1 i2 val1 val2 out |
	i1 := first.
	i2 := middle + 1.
	val1 := self at: i1.
	val2 := self at: i2.
	out := first - 1.  "will be pre-incremented"

	"select 'lower' half of the elements based on comparator"
	[(i1 <= middle) and: [i2 <= last]] whileTrue:
		[(aBlock value: val1 value: val2)
			ifTrue: [dst at: (out := out + 1) put: val1.
					val1 := self at: (i1 := i1 + 1)]
			ifFalse: [dst at: (out := out + 1) put: val2.
					i2 := i2 + 1.
					i2 <= last ifTrue: [val2 := self at: i2]]].

	"copy the remaining elements"
	i1 <= middle
		ifTrue: [dst replaceFrom: out + 1 to: last with: self startingAt: i1]
		ifFalse: [dst replaceFrom: out + 1 to: last with: self startingAt: i2]! !

!OrderedCollectionS1 methodsFor: 'sorting' stamp: 'ewe 10/10/2012 12:01'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self copy 
		dst: self 
		by: aBlock! !

!OrderedCollectionS1 methodsFor: 'sorting' stamp: 'ewe 10/10/2012 12:01'!
mergeSortFrom: first to: last src: src dst: dst by: aBlock
	"Private. Split the range to be sorted in half, sort each half, and 
	merge the two half-ranges into dst."

	| middle |
	first = last ifTrue: [^ self].
	middle := (first + last) // 2.
	self mergeSortFrom: first to: middle src: dst dst: src by: aBlock.
	self mergeSortFrom: middle + 1 to: last src: dst dst: src by: aBlock.
	src mergeFirst: first middle: middle last: last into: dst by: aBlock! !

!OrderedCollectionS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .
	array := array copy! !

!OrderedCollectionS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
postCopyFrom: startIndex to: endIndex 
	<ctxMeta>

	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
remove: oldObject ifAbsent: absentBlock

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[oldObject = (array at: index)
				ifTrue: 
					[self removeIndex: index.
					^ oldObject]
				ifFalse: [index := index + 1]].
	^ absentBlock value! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeAll
	"remove all the elements from this collection.
	Keep same amount of storage"
	
	self setCollection: (Array new: array size)! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeAllSuchThat: aBlock 
	"Remove each element of the receiver for which aBlock evaluates to true.
	The method in Collection is O(N^2), this is O(N)."

	| n |
	n := firstIndex.
	firstIndex to: lastIndex do: [:index |
	    (aBlock value: (array at: index)) ifFalse: [
			array at: n put: (array at: index).
			n := n + 1]].
	array from: n to: lastIndex put: nil.
	lastIndex := n - 1! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeAt: index
	| removed |
	removed := self at: index.
	self removeIndex: index + firstIndex - 1.
	^removed! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeFirst
	"Remove the first element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| firstObject |
	self emptyCheck.
	firstObject := array at: firstIndex.
	array at: firstIndex put: nil.
	firstIndex := firstIndex + 1.
	^ firstObject! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeFirst: n
	"Remove first n object into an array"

	| list |
	list := Array new: n.
	1 to: n do: [:i |
		list at: i put: self removeFirst].
	^ list! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
removeIndex: removedIndex
  "  removedIndex is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection.
    Never use this method in your code, it is meant for private use by OrderedCollection only.
     The method for public use is:
        #removeAt: "

	array 
		replaceFrom: removedIndex 
		to: lastIndex - 1 
		with: array 
		startingAt: removedIndex+1.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeLast
	"Remove the last element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| lastObject |
	self emptyCheck.
	lastObject := array at: lastIndex.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.
	^ lastObject! !

!OrderedCollectionS1 methodsFor: 'removing' stamp: 'ewe 10/10/2012 12:01'!
removeLast: n
	"Remove last n object into an array with last in last position"

	| list |
	list := Array new: n.
	n to: 1 by: -1 do: [:i |
		list at: i put: self removeLast].
	^ list! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
resetTo: index
	firstIndex := index.
	lastIndex := firstIndex - 1! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
reverseDo: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := lastIndex.
	[index >= firstIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index - 1]! !

!OrderedCollectionS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
reversed
	"Answer a copy of the receiver with element order reversed.  "
	| newCol |
	newCol := self species new.
	self reverseDo:
		[:elem | newCol addLast: elem].
	^ newCol

"#(2 3 4 'fred') reversed"! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
select: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect into
	a new collection like the receiver, only those elements for which aBlock
	evaluates to true."

	| newCollection element |
	newCollection := self copyEmpty.
	firstIndex to: lastIndex do:
		[:index |
		(aBlock value: (element := array at: index))
			ifTrue: [newCollection addLast: element]].
	^ newCollection! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
select: selectBlock thenCollect: collectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection. "

	| newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[:index |
		| element |
		element := array at: index.
		( selectBlock value: element ) 
			ifTrue:[ newCollection addLast: ( collectBlock value: element ) ]
    ].
    ^ newCollection! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
setCollection: anArray
	array := anArray.
	self reset! !

!OrderedCollectionS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
setContents: anArray
	array := anArray.
	firstIndex := 1.
	lastIndex := array size.! !

!OrderedCollectionS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
sort
	"Sort the receiver into ascending order using the '<=' operator."

	self sort: [:a :b | a <= b]! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
sort: aSortBlock 
	"Sort this array using aSortBlock. The block should take two arguments
	and return true if the first element should preceed the second one."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	array
		mergeSortFrom: firstIndex
		to: lastIndex 
		src: array shallowCopy 
		dst: array 
		by: aSortBlock! !

!OrderedCollectionS1 methodsFor: 'sorting' stamp: 'ewe 10/10/2012 12:01'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if the first element should preceed the second one. If aSortBlock is nil then <= is used for comparison."
	
	^self copy sort: aSortBlockOrNil! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with 
	corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result := self species new: self size.
	1 to: self size do:
		[:index | result addLast: (twoArgBlock value: (self at: index)
									value: (otherCollection at: index))].
	^ result! !

!OrderedCollectionS1 methodsFor: 'enumerating' stamp: 'ewe 10/10/2012 12:01'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (elementAndIndexBlock
			value: (array at: index)
			value: index - firstIndex + 1)].
	^ newCollection! !

!Boolean methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:27'!
isPrimitive ^true! !

ArrayedCollection variableSubclass: #ArrayL1
	instanceVariableNames: '__ctxInfo__'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'ActiveContext-Kernel'!

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceStream: nElements
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ WriteStream basicNew braceArray: (self new: nElements)
! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 1.
	array at: 1 put: a.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a with: b 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 2.
	array at: 1 put: a.
	array at: 2 put: b.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a with: b with: c 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 3.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a with: b with: c with: d
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 4.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	array at: 4 put: d.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWithNone
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ self new: 0! !

!ArrayL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 16:43'!
empty
	"A canonicalized empty Array instance."
	^ #()! !

!ArrayL1 class methodsFor: 'instance creation' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!ArrayL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 16:43'!
new: sizeRequested 
	"Answer an instance of this class with the number of indexable
	variables specified by the argument, sizeRequested.
	
	This is a shortcut (direct call of primitive, no #initialize, for performance"

	<primitive: 71>  "This method runs primitively if successful"
	^ self basicNew: sizeRequested  "Exceptional conditions will be handled in basicNew:"
! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 11:26'!
_postCopy 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
asArray
	"Answer with the receiver itself."

	^ self! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 14:55'!
asNativeArray
	<ctxMeta>
	| a|
	a := Array new: self size. 
	(1 to: self size) do: [ :i | a at: i put: (self at: i )].
	^ a.! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/13/2011 08:47'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:41'!
at: i 
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		^ super at: i.  
	]
	ifFalse: [
		^ super at: i. 
	]  
	! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:47'!
at: i put: v
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		self markOtherAsDirty .
		^ super at: i put: v. 
	]
	ifFalse: [
		^ super at: i put: v. 
	]! !

!ArrayL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 16:43'!
atWrap: index 
	"Optimized to go through the primitive if possible"
	<primitive: 60>
	^ self at: index - 1 \\ self size + 1! !

!ArrayL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 16:43'!
atWrap: index put: anObject
	"Optimized to go through the primitive if possible"
	<primitive: 61>
	^ self at: index - 1 \\ self size + 1 put: anObject! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/14/2011 17:15'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!ArrayL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 16:43'!
copyWithDependent: newElement
	self size = 0 ifTrue:[^DependentsArray with: newElement].
	^self copyWith: newElement! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  __ctxInfo__! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
elementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."

	<primitive: 128>
	otherArray class == Array ifFalse: [^ self error: 'arg must be array'].
	self size = otherArray size ifFalse: [^ self error: 'arrays must be same size'].
	(self anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	(otherArray anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	self with: otherArray do:[:a :b| a == b ifTrue:[^self error:'can''t become yourself']].

	"Must have failed because not enough space in forwarding table (see ObjectMemory-prepareForwardingTableForBecoming:with:twoWay:).  Do GC and try again only once"
	(Smalltalk bytesLeft: true) = Smalltalk primitiveGarbageCollect
		ifTrue: [^ self primitiveFailed].
	^ self elementsExchangeIdentityWith: otherArray! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
elementsForwardIdentityTo: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 72>
	self primitiveFailed! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
elementsForwardIdentityTo: otherArray copyHash: copyHash
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 249>
	self primitiveFailed! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 19:08'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 16:44'!
globalize: aUuuid
	<ctxMeta>
	^ super globalize: aUuuid   ! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
hasLiteral: literal
	"Answer true if literal is identical to any literal in this array, even 
	if imbedded in further array structure. This method is only intended 
	for private use by CompiledMethod hasLiteralSymbol:"

	1 to: self size do: [:index |  
		| lit |
		(lit := self at: index) == literal ifTrue: [^ true].
		(lit class == Array and: [lit hasLiteral: literal]) ifTrue: [^ true]].
	^ false! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
hasLiteralSuchThat: testBlock
	"Answer true if testBlock returns true for any literal in this array, even if imbedded in 	further Arrays or CompiledMethods.  This method is only intended for private use by 	CompiledMethod 	hasLiteralSuchThat:"
	| lit |
	1 to: self size do: [:index |
		(testBlock value: (lit := self at: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!ArrayL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 16:43'!
isArray
	^true! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 19:21'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!ArrayL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 16:43'!
isLiteral
	^self class == Array and: [self allSatisfy: [:each | each isLiteral]]! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!ArrayL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 16:43'!
isSelfEvaluating
	^ (self allSatisfy: [:each | each isSelfEvaluating]) and: [self class == Array]! !

!ArrayL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 16:43'!
literalEqual: other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	self with: other do: [:e1 :e2 |
		(e1 literalEqual: e2) ifFalse: [^ false]].
	^ true! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 09:48'!
migrateToNext
	<ctxMeta>
	| clone |
	clone := ( Array22 new: self size ) globalize: self uuid..
	clone dirty: true.
	self nextMe: clone.
	clone prevMe: self.! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 16:43'!
migrateToPrev
	<ctxMeta>
	| clone |
	clone :=  (self species  new: self size) globalize: self uuid..
	clone dirty: true.
	self prevMe: clone.
	clone nextMe: self.! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 15:53'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 16:43'!
primAt: i 
	<ctxMeta>
	^ super at: i.  
	! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 16:43'!
primAt: i put: v
	<ctxMeta>
	^ super at: i put: v! !

!ArrayL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 16:43'!
printAsLiteralFormOn: aStream
	aStream nextPut: $#.
	self printElementsOn: aStream
! !

!ArrayL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 16:43'!
printAsSelfEvaluatingFormOn: aStream

	aStream nextPut: ${.
	self do: [:el | el storeOn: aStream] separatedBy: [ aStream nextPutAll: '. '].
	aStream nextPut: $}! !

!ArrayL1 methodsFor: 'printing' stamp: 'ewe 9/12/2011 14:30'!
printOn: aStream
	self isLiteral ifTrue: [self printAsLiteralFormOn: aStream. ^ self].
	self isSelfEvaluating ifTrue: [self printAsSelfEvaluatingFormOn: aStream. ^ self].

	super printOn: aStream.
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
refersToLiteral: literal 
	"Answer true if literal is identical to any literal in this array, even if imbedded in further array structures or closure methods"
	1 
		to: self size
		do: 
			[ :index | 
			| lit |
			(lit := self at: index) == literal ifTrue: [ ^ true ].
			(lit refersToLiteral: literal) ifTrue: [ ^ true ] ].
	^ false! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if 
the first element should preceed the second one. If aSortBlock is nil then <= is used for 
comparison."
	
	^self copy sort: aSortBlockOrNil! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:03'!
species 
	<ctxMeta>
	^ ArrayL1   ! !

!ArrayL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 16:43'!
storeOn: aStream 
	"Use the literal form if possible."

	self isLiteral
		ifTrue: 
			[aStream nextPut: $#; nextPut: $(.
			self do: 
				[:element | 
				element storeOn: aStream.
				aStream space].
			aStream nextPut: $)]
		ifFalse: [super storeOn: aStream]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:43'!
synchronize
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			ContextStatistics track: self . 
			1 to: self size  do: [ :i |
				| p |
				p := self prevMe primAt: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToNextIfNecessary .
					self primAt: i put: p nextMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					self primAt: i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]   
		] 
		ifNil: [
			1 to: self size do: [ :i |
				| n |
				n := self nextMe primAt: i.   
				( n isPrimitive not )  ifTrue: [
					"lazy migration after update"
					n migrateToPrevIfNecessary .
					self primAt: i put: n prevMe.
					"Transcript show: ( self uuid, '.' , field, ' := ', n prev asString ); cr."
				] ifFalse: [
					self primAt: i put: n.  
					"Transcript show: ( self uuid, '.' , field, ' := ', n asString ); cr."
				]. 
			]   
		].! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 10:47'!
synchronizeIfNecessary 
	<ctxMeta>
	self dirty ifTrue: [
		self synchronize.
		self dirty: false.
	]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:43'!
synchronizeIfNecessary: index
	<ctxMeta>
	"We use 1 and not i because the array in context info might not be long enoug"
	(self dirtyBit: 1) ifTrue: [
		self synchronize. 
		self dirtyBit: 1 set: false.
	]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 16:54'!
traverseAndDo: aBlock exclude: visited globalize: doGlobalize
	<ctxMeta>
	
	| infPrev infNext prev next |	
	
	self isPrimitive ifTrue: [ ^ self ].  
	doGlobalize ifTrue: [ self globalize ].
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	1 to: self size  do:  [ :i | ( self primAt: i  ) traverseAndDo: aBlock exclude:  visited globalize: doGlobalize  ].! !

ArrayedCollection variableSubclass: #ArrayS1
	instanceVariableNames: '__ctxInfo__'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'ActiveContext-Kernel'!

!ArrayS1 class methodsFor: 'brace support' stamp: 'ewe 10/10/2012 12:01'!
braceStream: nElements
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ WriteStream basicNew braceArray: (self new: nElements)
! !

!ArrayS1 class methodsFor: 'brace support' stamp: 'ewe 10/10/2012 12:01'!
braceWith: a
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 1.
	array at: 1 put: a.
	^ array! !

!ArrayS1 class methodsFor: 'brace support' stamp: 'ewe 10/10/2012 12:01'!
braceWith: a with: b 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 2.
	array at: 1 put: a.
	array at: 2 put: b.
	^ array! !

!ArrayS1 class methodsFor: 'brace support' stamp: 'ewe 10/10/2012 12:01'!
braceWith: a with: b with: c 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 3.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	^ array! !

!ArrayS1 class methodsFor: 'brace support' stamp: 'ewe 10/10/2012 12:01'!
braceWith: a with: b with: c with: d
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 4.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	array at: 4 put: d.
	^ array! !

!ArrayS1 class methodsFor: 'brace support' stamp: 'ewe 10/10/2012 12:01'!
braceWithNone
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ self new: 0! !

!ArrayS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
empty
	"A canonicalized empty Array instance."
	^ #()! !

!ArrayS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!ArrayS1 class methodsFor: 'instance creation' stamp: 'ewe 10/10/2012 12:01'!
new: sizeRequested 
	"Answer an instance of this class with the number of indexable
	variables specified by the argument, sizeRequested.
	
	This is a shortcut (direct call of primitive, no #initialize, for performance"

	<primitive: 71>  "This method runs primitively if successful"
	^ self basicNew: sizeRequested  "Exceptional conditions will be handled in basicNew:"
! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
_postCopy 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..! !

!ArrayS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:01'!
asArray
	"Answer with the receiver itself."

	^ self! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
asNativeArray
	<ctxMeta>
	| a|
	a := Array new: self size. 
	(1 to: self size) do: [ :i | a at: i put: (self at: i )].
	^ a.! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
at: i 
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		^ super at: i.  
	]
	ifFalse: [
		^ super at: i. 
	]  
	! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
at: i put: v
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		self markOtherAsDirty .
		^ super at: i put: v. 
	]
	ifFalse: [
		^ super at: i put: v. 
	]! !

!ArrayS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
atWrap: index 
	"Optimized to go through the primitive if possible"
	<primitive: 60>
	^ self at: index - 1 \\ self size + 1! !

!ArrayS1 methodsFor: 'accessing' stamp: 'ewe 10/10/2012 12:01'!
atWrap: index put: anObject
	"Optimized to go through the primitive if possible"
	<primitive: 61>
	^ self at: index - 1 \\ self size + 1 put: anObject! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
contextInfo: value
	 __ctxInfo__ := value isNil not..
	super contextInfo: value.! !

!ArrayS1 methodsFor: 'copying' stamp: 'ewe 10/10/2012 12:01'!
copyWithDependent: newElement
	self size = 0 ifTrue:[^DependentsArray with: newElement].
	^self copyWith: newElement! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  __ctxInfo__! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ __ctxInfo__ := v2  ! !

!ArrayS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:01'!
elementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."

	<primitive: 128>
	otherArray class == Array ifFalse: [^ self error: 'arg must be array'].
	self size = otherArray size ifFalse: [^ self error: 'arrays must be same size'].
	(self anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	(otherArray anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	self with: otherArray do:[:a :b| a == b ifTrue:[^self error:'can''t become yourself']].

	"Must have failed because not enough space in forwarding table (see ObjectMemory-prepareForwardingTableForBecoming:with:twoWay:).  Do GC and try again only once"
	(Smalltalk bytesLeft: true) = Smalltalk primitiveGarbageCollect
		ifTrue: [^ self primitiveFailed].
	^ self elementsExchangeIdentityWith: otherArray! !

!ArrayS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:01'!
elementsForwardIdentityTo: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 72>
	self primitiveFailed! !

!ArrayS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:01'!
elementsForwardIdentityTo: otherArray copyHash: copyHash
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 249>
	self primitiveFailed! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
globalize: aUuuid
	<ctxMeta>
	^ super globalize: aUuuid   ! !

!ArrayS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
hasLiteral: literal
	"Answer true if literal is identical to any literal in this array, even 
	if imbedded in further array structure. This method is only intended 
	for private use by CompiledMethod hasLiteralSymbol:"

	1 to: self size do: [:index |  
		| lit |
		(lit := self at: index) == literal ifTrue: [^ true].
		(lit class == Array and: [lit hasLiteral: literal]) ifTrue: [^ true]].
	^ false! !

!ArrayS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
hasLiteralSuchThat: testBlock
	"Answer true if testBlock returns true for any literal in this array, even if imbedded in 	further Arrays or CompiledMethods.  This method is only intended for private use by 	CompiledMethod 	hasLiteralSuchThat:"
	| lit |
	1 to: self size do: [:index |
		(testBlock value: (lit := self at: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!ArrayS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
isArray
	^true! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__! !

!ArrayS1 methodsFor: 'testing' stamp: 'ewe 10/10/2012 12:01'!
isLiteral
	^self class == Array and: [self allSatisfy: [:each | each isLiteral]]! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:01'!
isPrimitive ^ false! !

!ArrayS1 methodsFor: 'self evaluating' stamp: 'ewe 10/10/2012 12:01'!
isSelfEvaluating
	^ (self allSatisfy: [:each | each isSelfEvaluating]) and: [self class == Array]! !

!ArrayS1 methodsFor: 'comparing' stamp: 'ewe 10/10/2012 12:01'!
literalEqual: other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	self with: other do: [:e1 :e2 |
		(e1 literalEqual: e2) ifFalse: [^ false]].
	^ true! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
migrateToNext
	<ctxMeta>
	| clone |
	clone := ( Array22 new: self size ) globalize: self uuid..
	clone dirty: true.
	self nextMe: clone.
	clone prevMe: self.! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
migrateToPrev
	<ctxMeta>
	| clone |
	clone :=  (self species  new: self size) globalize: self uuid..
	clone dirty: true.
	self prevMe: clone.
	clone nextMe: self.! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
primAt: i 
	<ctxMeta>
	^ super at: i.  
	! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
primAt: i put: v
	<ctxMeta>
	^ super at: i put: v! !

!ArrayS1 methodsFor: 'self evaluating' stamp: 'ewe 10/10/2012 12:01'!
printAsLiteralFormOn: aStream
	aStream nextPut: $#.
	self printElementsOn: aStream
! !

!ArrayS1 methodsFor: 'self evaluating' stamp: 'ewe 10/10/2012 12:01'!
printAsSelfEvaluatingFormOn: aStream

	aStream nextPut: ${.
	self do: [:el | el storeOn: aStream] separatedBy: [ aStream nextPutAll: '. '].
	aStream nextPut: $}! !

!ArrayS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
printOn: aStream
	self isLiteral ifTrue: [self printAsLiteralFormOn: aStream. ^ self].
	self isSelfEvaluating ifTrue: [self printAsSelfEvaluatingFormOn: aStream. ^ self].

	super printOn: aStream.
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]! !

!ArrayS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
refersToLiteral: literal 
	"Answer true if literal is identical to any literal in this array, even if imbedded in further array structures or closure methods"
	1 
		to: self size
		do: 
			[ :index | 
			| lit |
			(lit := self at: index) == literal ifTrue: [ ^ true ].
			(lit refersToLiteral: literal) ifTrue: [ ^ true ] ].
	^ false! !

!ArrayS1 methodsFor: 'private' stamp: 'ewe 10/10/2012 12:01'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!ArrayS1 methodsFor: 'converting' stamp: 'ewe 10/10/2012 12:01'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if 
the first element should preceed the second one. If aSortBlock is nil then <= is used for 
comparison."
	
	^self copy sort: aSortBlockOrNil! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:03'!
species 
	<ctxMeta>
	^ ArrayL1   ! !

!ArrayS1 methodsFor: 'printing' stamp: 'ewe 10/10/2012 12:01'!
storeOn: aStream 
	"Use the literal form if possible."

	self isLiteral
		ifTrue: 
			[aStream nextPut: $#; nextPut: $(.
			self do: 
				[:element | 
				element storeOn: aStream.
				aStream space].
			aStream nextPut: $)]
		ifFalse: [super storeOn: aStream]! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
synchronize
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			ContextStatistics track: self . 
			1 to: self size  do: [ :i |
				| p |
				p := self prevMe primAt: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToNextIfNecessary .
					self primAt: i put: p nextMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					self primAt: i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]   
		] 
		ifNil: [
			1 to: self size do: [ :i |
				| n |
				n := self nextMe primAt: i.   
				( n isPrimitive not )  ifTrue: [
					"lazy migration after update"
					n migrateToPrevIfNecessary .
					self primAt: i put: n prevMe.
					"Transcript show: ( self uuid, '.' , field, ' := ', n prev asString ); cr."
				] ifFalse: [
					self primAt: i put: n.  
					"Transcript show: ( self uuid, '.' , field, ' := ', n asString ); cr."
				]. 
			]   
		].! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
synchronizeIfNecessary 
	<ctxMeta>
	self dirty ifTrue: [
		self synchronize.
		self dirty: false.
	]! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
synchronizeIfNecessary: index
	<ctxMeta>
	"We use 1 and not i because the array in context info might not be long enoug"
	(self dirtyBit: 1) ifTrue: [
		self synchronize. 
		self dirtyBit: 1 set: false.
	]! !

!ArrayS1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:01'!
traverseAndDo: aBlock exclude: visited globalize: doGlobalize
	<ctxMeta>
	
	| infPrev infNext prev next |	
	
	self isPrimitive ifTrue: [ ^ self ].  
	doGlobalize ifTrue: [ self globalize ].
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	1 to: self size  do:  [ :i | ( self primAt: i  ) traverseAndDo: aBlock exclude:  visited globalize: doGlobalize  ].! !

!UUID methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:31'!
isPrimitive ^true! !

!Process methodsFor: '*activecontext' stamp: 'ewe 9/7/2011 15:35'!
terminate 
	"Stop the process that the receiver represents forever.  Unwind to execute pending ensure:/ifCurtailed: blocks before terminating."

	| ctxt unwindBlock oldList |
	
	self environmentRemoveKey: #activeContext ifAbsent: [].    
		
	self isActiveProcess 
		ifTrue: [
			ctxt := thisContext.
			[ ctxt := ctxt findNextUnwindContextUpTo: nil.
			ctxt isNil ] whileFalse: 
				[ (ctxt tempAt: 2) ifNil:
					[ ctxt tempAt: 2 put: nil.
					unwindBlock := ctxt tempAt: 1.
					thisContext terminateTo: ctxt.
					unwindBlock value ]].
			thisContext terminateTo: nil.
			self suspend ]
		 ifFalse: [
			"Always suspend the process first so it doesn't accidentally get woken up"
			 oldList := self suspend.
			suspendedContext ifNotNil:[
				"Figure out if we are terminating the process while waiting in Semaphore>>critical:
				In this case, pop the suspendedContext so that we leave the ensure: block inside
				Semaphore>>critical: without signaling the semaphore."
				(oldList class == Semaphore and:[
					suspendedContext method == (Semaphore compiledMethodAt: #critical:)]) ifTrue:[
						suspendedContext := suspendedContext home.].
					
			  "If we are terminating a process halfways through an unwind, try to complete that unwind block first."
				(suspendedContext findNextUnwindContextUpTo: nil) ifNotNil: [ :outer |
				(suspendedContext findContextSuchThat: [ :c | c closure == (outer tempAt: 1)]) 
					ifNotNil: [ :inner |
						 "This is an unwind block currently under evaluation"
						suspendedContext runUntilErrorOrReturnFrom: inner ]].		
			ctxt := self popTo: suspendedContext bottomContext.
			ctxt == suspendedContext bottomContext ifFalse: [
				self debug: ctxt title: 'Unwind error during termination']] ].
! !

!Set22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
_postCopy
	<ctxMeta>
	super postCopy.
	
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	array := array copy! !

!Set22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
postCopy
	<ctxMeta>
	super postCopy.
	
	array := array copy! !

Notification subclass: #CurrentContextNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!OrderedCollection22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
_postCopy
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	array := array copy! !

!OrderedCollection22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
_postCopyFrom: startIndex to: endIndex 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo dirty: false.
	self contextInfo uuid: UUID new..
	
	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollection22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!OrderedCollection22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!OrderedCollection22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .
	array := array copy! !

!OrderedCollection22 methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 15:28'!
postCopyFrom: startIndex to: endIndex 
	<ctxMeta>

	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:54'!
allClassSideInstanceVariablesNames 
	| current vars |
	"Even if first-class, classes are special and we don't want to contextual things beyond object"
	current := self .
	vars := #().
	[ current = Object class or: [ current = ProtoObject class ]] whileFalse: [
		vars := current classSideInstanceVariablesNames  , vars.
		current := current superclass. 
	].
	^ vars.! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:54'!
allClassVariablesNames 
	| current vars |
	"Even if first-class, classes are special and we don't want to contextual things beyond object"
	current := self .
	vars := #().
	[ current = Object class or: [ current = ProtoObject class ]] whileFalse: [
		vars := current classVariablesNames  , vars.
		current := current superclass. 
	].
	^ vars.! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/26/2012 17:51'!
allContextualInstVarNames 
	| a |
	a := OrderedCollection new.
	a addAll:  self allClassVariablesNames.
	a addAll: self allClassSideInstanceVariablesNames.
	^ a! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:56'!
classSideInstanceVariablesNames  
	^self instVarNames! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:55'!
classVariablesNames 
	^self classPool keys. ! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/1/2011 16:15'!
compilerClass 

	(  CurrentContext contextualClasses includes: self  ) ifTrue: [
		Transcript show:( 'Contextual compiler for ',  self asString  ); cr.
		  ^OptimizedContextualCompiler 
	].
	(  CurrentContext normalizedClasses includes: self  ) ifTrue: [
		Transcript show:( 'Normalized compiler for ',  self asString  ); cr.
		  ^NormalizedCompiler.
	].
	^ super compilerClass .! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:53'!
contextualInstVarNames  
	| a |
	a := OrderedCollection new.
	a addAll:  self classVariablesNames.
	a addAll: self classSideInstanceVariablesNames.
	^ a! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:38'!
indexOfContextualInstVar: aName
	( self allClassVariablesNames includes: aName ) ifTrue: [
		^ -1. 
	].
	^ self allClassSideInstanceVariablesNames indexOf: aName  .
! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:06'!
isContextualClassVar: varName
	^ self allContextualInstVarNames includes: varName  ! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:05'!
isContextualInstVar: varName
	^ self allContextualInstVarNames includes: varName ! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 13:34'!
isPrimitive ^true! !

!Stream methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:31'!
isPrimitive ^true! !

!Array methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 09:36'!
_globalize: uuid
	self isPrimitive ifTrue: [
		^ self. 
	].   
	self isCtxGlobal ifFalse: [   
		
		"Transcript show: ( 'Globalize ', self class , '@', self identityHash  ) ; cr."
				
		self contextInfo: ContextualInfo new.
		self contextInfo global: true.
		self contextInfo dirty: false.
		self contextInfo uuid: uuid..

		(self class = self optimizedClass) ifFalse: [
			| n |
			n := self optimizedClass new: self size.
			self flag: 'Don''t know why we need to instantiate the class--might cause problems'.
			1 to: self size  do: [ :i | 
				"Transcript show: ( 'Copy item ', i asString , ' of array  ', (self at: i) asString  ) ; cr. "
				 n primAt: i put: (self at: i) globalize ].
			self become: n. 
			"Transcript show: ( 'Change class of object to ', self optimizedClass name ) ; cr."
		] ifTrue: [
			self error: 'Array should be optimized'.
		].
	
	].
	^ self.
! !

!Array methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 14:58'!
asNativeArray 
	^ self.! !

!Array methodsFor: '*ActiveContext' stamp: 'ewe 1/16/2012 08:58'!
fillWith: aValue
	(1 to: self size ) do: [ :i | self at: i put: aValue ].! !

RBProgramNodeVisitor subclass: #BaseProgramNodeVisitor
	instanceVariableNames: 'compiledClass skipClassResolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:07'!
acceptAssignmentNode: anAssignmentNode

	| name |
	name := anAssignmentNode variable name.
	
	( name = '__ctxInfo__' ) ifTrue: [
		^ super acceptAssignmentNode: anAssignmentNode .
	].
	
	(compiledClass isContextualInstVar: name ) ifTrue: 	 
	[
		"Transcript show: ('Replace write ', anAssignmentNode  variable  name); cr."
		self replaceInstVarWrite: anAssignmentNode .
	]
	ifFalse: 
	[
		(compiledClass class isContextualClassVar: name  ) ifTrue: [
			"Transcript show: ('Replace class var resolution ',   name); cr. "
			self replaceClassVarWrite: anAssignmentNode . 
		] ifFalse: [		
			"Transcript show: ('Don''t replace write ', anAssignmentNode  variable  name); cr."
			super acceptAssignmentNode: anAssignmentNode .
		]
	]! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:50'!
acceptMethodNode: methodNode 
	(  (methodNode name beginsWith: 'ctxRead'  ) or: 
	   [ (methodNode name beginsWith: 'ctxWrite' ) or: 
	    [ (methodNode pragmas select: [ :p | p selector = #ctxMeta ] ) size = 1]]  ) ifTrue: [		
		^ RBProgramNodeVisitor new visitNode: methodNode.
	] ifFalse: [
		^ super acceptMethodNode: methodNode 
	  ].  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:10'!
acceptVariableNode: aVariableNode

| name |

	name := aVariableNode name.

	({ '__ctxInfo__' . 'self' . 'super' . 'CurrentContext' } includes: name ) ifTrue: [
		^ super acceptVariableNode: aVariableNode . 
	].

	"Transcript show: ('Var read ',   name); cr."
	(compiledClass isContextualInstVar:  name )
	ifTrue: 	 
	[	
		"Transcript show: ('Replace read ',   name); cr."
		self replaceInstVarRead: aVariableNode .
	]
	ifFalse: 
	[
	  	(compiledClass class isContextualClassVar: name  ) ifTrue: [
			"Transcript show: ('Replace class var resolution ',   name); cr. "
			self replaceClassVarRead: aVariableNode . 
		] ifFalse: [
			(( name first isUppercase ) and: [skipClassResolution not]  ) ifTrue: [ 
				"Transcript show: ('Replace class resolution ',   name); cr. "
				self replaceClassResolution: aVariableNode . 
			]
			ifFalse: [
				"Transcript show: ('Don''t replace read ',   name); cr."
				super acceptVariableNode: aVariableNode . 
			].
		]
	]! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:48'!
compiledClass: class
	compiledClass := class.! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:48'!
initialize 
	skipClassResolution := false.! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:51'!
replaceClassResolution: aVariableNode

		^ super acceptVariableNode: aVariableNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:51'!
replaceClassVarRead: aVariableNode

		^ super acceptVariableNode: aVariableNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:52'!
replaceClassVarWrite: anAssignmentNode

	^ super acceptAssignmentNode: anAssignmentNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:52'!
replaceInstVarRead: aVariableNode

	^ super acceptVariableNode: aVariableNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:52'!
replaceInstVarWrite: anAssignmentNode

	^ super acceptAssignmentNode: anAssignmentNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:49'!
skipClassResolution
	skipClassResolution := true.! !

BaseProgramNodeVisitor subclass: #ContextualProgramNodeVisitor
	uses: TClassResolution + TRegularAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

ContextualProgramNodeVisitor class
	uses: TClassResolution classTrait + TRegularAccessors classTrait
	instanceVariableNames: ''!

ContextualProgramNodeVisitor subclass: #OptimizedContextualProgramNodeVisitor
	uses: TOptimizedAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

OptimizedContextualProgramNodeVisitor class
	uses: TOptimizedAccessors classTrait
	instanceVariableNames: ''!

BaseProgramNodeVisitor subclass: #NormalizedProgramNodeVisitor
	uses: TOptimizedAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

NormalizedProgramNodeVisitor class
	uses: TOptimizedAccessors classTrait
	instanceVariableNames: ''!

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 14:37'!
allContextualInstVarNames
	^ self allInstVarNames.
! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:55'!
contextualInstVarNames
	^ self instVarNames.
! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:37'!
indexOfContextualInstVar: aName
	^ self allContextualInstVarNames indexOf: aName  .
! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:06'!
isContextualClassVar: varName
	^ self allContextualInstVarNames includes: varName  ! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:05'!
isContextualInstVar: varName
	^ self allContextualInstVarNames includes: varName ! !

!ProtoObject methodsFor: '*activecontext' stamp: 'ewe 8/8/2011 10:15'!
pointersFrom
	^ self pointersFromExclude: OrderedCollection new.  ! !

!ProtoObject methodsFor: '*activecontext' stamp: 'ewe 8/8/2011 10:39'!
pointersFromExclude: visited
	| sub bypassClasses |
	bypassClasses := { SmallInteger . MethodDictionary }.
	sub := OrderedCollection new.
	visited add: self. 

	( self isClass ) ifTrue: [
		| v |
		v:= self classPool.
		Transcript show: 'Add ',  v ; cr.  sub add: v ; addAll:  ( v pointersFromExclude: visited).
		^ sub. 
	]
.
	1 to: self class instSize do:
		[ :i | | v | v := self instVarAt: i.
		 ((  visited includes: v ) or: [ bypassClasses includes: v class ]) ifFalse: [ Transcript show: 'Add ',  v ; cr.  sub add: v ; addAll:  ( v pointersFromExclude: visited) ] ].
	1 to: self basicSize do:
		[ :i | | v | v := self basicAt: i.
		( (  visited includes: v ) or: [ bypassClasses includes: v class]) ifFalse: [ Transcript show: 'Add ',  v ; cr.  sub  add: v ; addAll:   ( v pointersFromExclude: visited) ]  ].
	^ sub. ! !

TestCase subclass: #BasicTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
setUp
	ctx1 := Context new.
	ctx2 := Context ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/26/2011 12:47'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	
	"Release object globalized manually"
	Example allSubInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	Counter  allInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	
	Singleton1 instance: nil.
	Singleton2 instance: nil.
	ContextInfoBinding instance unbind: Singleton1.
	ContextInfoBinding instance unbind: Singleton2.

	"In case the current context (the process of the running test) has been set"
	CurrentContext instance: nil.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testA1A2AreClean

	| a1 a2 |
	
	a1 := Example newGlobal..
	a2 := Example newGlobal.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	self assert: a1 dirty .
	self assert: a2 dirty not.
	 
	a1 f: 'hello'.
	
	self assert: a1 dirty not.
	self assert: a2 dirty.
	
	a2 f. 
	
	self assert: a1 dirty not.
	self assert: a2 dirty not.
	
	a2 f: 'hello'. 
	
	self assert: a1  dirty .
	self assert: a2 dirty not.! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testConcurrentCounterFake

	| a1 a2 b1 b2 |
	
	a1 := Counter newGlobal..
	a2 := Counter newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	a1 increment.
	a1 increment.
	
	self assert: (a1 value = 2  ).
	self assert: (a2 value = 2 ).

	a2 increment .
	a2 increment .
	
	self assert: (a1 value = 4  ).
	self assert: (a2 value = 4 ).
	
	a1 increment .
	a2 increment .
	
	self assert: (a1 value = 6  ).
	self assert: (a2 value = 6 ).! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testXDirtyObjectsAreA1B2

	| a1 a2 b1 b2 |
	
	a1 := Example newGlobal..
	a2 := Example newGlobal.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	b1 := Example newGlobal.
	b2 := Example newGlobal.
	
	b1 nextMe: b2.
	b2 prevMe: b1.
	b2 dirty: true.
	b1 dirty: false.
	
	a2 instVarNamed: 'f' put: b2.
	b1 instVarNamed: 'f' put:   'hello'.
	
	self assert: ( a1 f = b1 ).
	self assert: ( a1 f f = 'hello').! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testXDirtyObjectsAreA2B1

	| a1 a2 b1 b2 |
	
	a1 := Example  newGlobal.
	a2 := Example newGlobal.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true.
	a1 dirty: false.
	
	b1 := Example newGlobal.
	b2 := Example newGlobal.
	
	b1 nextMe: b2.
	b2 prevMe: b1.
	b2 dirty: false.
	b1 dirty: true.
	
	a1 instVarNamed: 'f' put: b1.
	b2 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a2 f = b2 ).
	self assert: ( a2 f f = 'hello').! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 14:48'!
testXInheritance
	self flag: 'todo'.! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testXLazyMigrationOldToNew

	| a1 a2 b1 |
	
	a1 := Example  newGlobal.
	a2 := Example newGlobal.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b1 := Example newGlobal.
	
	b1 dirty: false.
	
	a1 instVarNamed: 'f'  put:  b1.
	b1 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a2 f isNil not ).
	self assert: ( a2 f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testXLazyMigrationOldToNewWithMany

	| a1 a2 b1 c1 d1 |
	
	a1 := Example newGlobal.
	a2 := Example newGlobal.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b1 := Example newGlobal.	
	b1 dirty: false.	
	a1 instVarNamed: 'f' put:   b1.
	
	c1 := Example newGlobal.	
	c1 dirty: false.	
	b1 instVarNamed: 'f' put:   c1.
	
	d1 := Example newGlobal.	
	d1 dirty: false.	
	c1 instVarNamed: 'f' put:   d1.
	d1 instVarNamed: 'f' put:   'hello'.
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 nextMe isNil ).
	self assert: ( c1 nextMe isNil ).
	self assert: ( d1 nextMe isNil ).
			
	self assert: ( a2 f isNil not ).  "triggers lazy mig"
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 nextMe isNil not ).
	self assert: ( c1 nextMe isNil ).
	self assert: ( d1 nextMe isNil ).
	
	self assert: ( a2 f f isNil not ).  "triggers lazy mig"
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 nextMe isNil not ).
	self assert: ( c1 nextMe isNil not ).
	self assert: ( d1 nextMe isNil ).
	
	self assert: ( a2 f f f isNil not ).  "triggers lazy mig"
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 nextMe isNil not ).
	self assert: ( c1 nextMe isNil not ).
	self assert: ( d1 nextMe isNil not ).
	
	self assert: ( a2 f f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testXLocalBecomeGlobalNew

	| a1 a2 b1 b2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b2 := Example newLocal: 'b2'.
	
	b2 f: 'hello'.
	self assert: ( b2 isCtxGlobal not).

	a2 f: b2.
	self assert: (b2 isCtxGlobal ).  
	b1:= a1 f.
	self assert: ( b1 f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testXLocalBecomeGlobalOld

	| a1 a2 b1 b2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b1 := Example newLocal: 'b1'.
	
	b1 f: 'hello'.
	self assert: ( b1 isCtxGlobal not).

	a1 f: b1.
	self assert: (b1 isCtxGlobal ).  
	b2:= a2 f. 
	self assert: ( b2 f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testXLocalBecomeGlobalWithMany2New

	| a1 a2 b2 c2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b2 := Example newLocal: 'b2'.
	b2 f: 'hello'.
	a2 f: b2.
	
	self assert: ( a1 f f = 'hello' ). 
	self assert: (b2 isCtxGlobal ).
	
	c2 := Example newLocal: 'c2'.
	c2 f: 'hello'.
	b2 f: c2.
	self assert: (c2 isCtxGlobal ).
	
	self assert: ( a1 f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testXLocalBecomeGlobalWithMany2Old

	| a1 a2 b1 c1 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b1 := Example newLocal: 'b1'.
	b1 f: 'hello'.
	a1 f: b1.
	
	self assert: ( a2 f f = 'hello' ). 
	self assert: (b1 isCtxGlobal ).
	 
	c1 := Example newLocal: 'c1'.
	c1 f: 'hello'.
	b1 f: c1.
	self assert: (c1 isCtxGlobal ).
	
	self assert: ( a2 f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testXLocalBecomeGlobalWithManyNew

	| a1 a2 b2 c2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b2 := Example newLocal: 'b2'.
	
	c2 := Example newLocal: 'c2'.
	c2 f: 'hello'.
	b2 f: c2.
	
	a2 f: b2.
	self assert: b2 isCtxGlobal..
	self assert: c2 isCtxGlobal .    
	self assert: ( a1 f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testXLocalBecomeGlobalWithManyOld

	| a1 a2 b1 c1 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b1 := Example newLocal: 'b1'.
	
	c1 := Example newLocal: 'c1'.
	c1 f: 'hello'.
	b1 f: c1.
	
	a1 f: b1.
	self assert: b1 isCtxGlobal..
	self assert: c1 isCtxGlobal .    
	self assert: ( a2 f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testXNewContextIsDirty

	| a1 a2 b1 b2 |
	
	a1 := Example  newGlobal: 'a1'. 
	a2 :=  Example  newGlobal: 'a2'. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true.
	a1 dirty: false.
	
	b1 :=  Example  newGlobal: 'b1'. 
	b2 :=  Example  newGlobal: 'b2'. 
	
	b1 nextMe: b2.
	b2 prevMe: b1.
	b2 dirty: true.
	b1 dirty: false.
	
	a1 instVarNamed: 'f' put:  b1.
	b1 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a2 f = b2 ).
	self assert: ( a2 f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testXOldContextIsDirty

	| a1 a2 b1 b2 |
	
	a1 := Example  newGlobal: 'a1'. 
	a2 :=  Example  newGlobal: 'a2'. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	b1 :=  Example  newGlobal: 'b1'. 
	b2 :=  Example  newGlobal: 'b2'. 
	
	b1 nextMe: b2.
	b2 prevMe: b1.
	b2 dirty: false.
	b1 dirty: true.
	
	a2 instVarNamed: 'f' put:  b2. 
	b2 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a1 f = b1 ).
	self assert: ( a1 f f = 'hello').! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testXTwoCycles

	| a1 a2 b1 a3 |
	
	a1 := Example  newGlobal.
	a1 dirty: false.
	
	b1 := Example  newGlobal.
	b1 dirty: false.
	
	a1 instVarNamed: 'f' put:    b1.
	b1 instVarNamed: 'f' put:   'hello'.
	
	a1 migrateToNext .
	a2 := a1 nextMe. 
	
	self assert: ( a2 f isNil not ).
	self assert: ( a2 f f = 'hello' ). 
	
	"we simulate the end of the 1st cycle"
	a2 prevMe: nil.
	( a2 instVarNamed: 'f' )  prevMe: nil. 

	a2 migrateToNext .
	a3 := a2 nextMe. 
	
	self assert: ( a3 f isNil not ).
	self assert: ( a3 f f = 'hello' ). ! !

TestCase subclass: #BrokenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!BrokenTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testSingleton

	|  cls a  |
	
	BaseContextualObject subclass: #SingletonTest
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'.
	
	cls := Smalltalk at: #SingletonTest.
	cls globalize.
	
	self assert:  cls isCtxGlobal .
	
	cls compile: 'instance: anObject  Instance := anObject' .
	a := Example new.
	
	self assert: a isCtxGlobal not.
	cls instance: a.
	
	self assert: a isCtxGlobal .    ! !

TestCase subclass: #ClassMigrationTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
setUp
	ctx1 := Page1Context new.
	ctx2 := Page2Context ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	
	Page1 globalize: #Page..
	Page2 globalize: #Page..
	Page1 nextMe: Page2.
	Page2 prevMe: Page1.
	ctx1 bind: #Page to: Page1.
	ctx2 bind: #Page to: Page2.
	
	HtmlPage1 globalize: #HtmlPage..
	HtmlPage2 globalize: #HtmlPage..
	HtmlPage1 nextMe: HtmlPage2.
	HtmlPage2 prevMe: HtmlPage1. 
	ctx1 bind: #HtmlPage to: HtmlPage1.
	ctx2 bind: #HtmlPage to: HtmlPage2.! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	
	"Release object globalized manually"
	{ Page1 . Page2 . HtmlPage1 . HtmlPage2 } do: [ :cls |
		cls allInstances do: [ :o | ContextInfoBinding instance unbind: o ].
		ContextInfoBinding instance unbind: cls.
	].

	"In case the current context (the process of the running test) has been set"
	CurrentContext instance: nil.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:58'!
testHtmlPageInstanceMigration

	ctx1 do: [
		| p1 |
		p1 := ( ctx1 resolveClass: #HtmlPage ) new.
		p1 name: 'TestPage'.
		p1 html: '<header>h</header><body>b</body>'.
		self assert: p1 class = HtmlPage1.
		ctx2 do: [ :p2 |
			self assert: p2 class = HtmlPage2. 
			self assert: p2 name = 'TestPage'.
			self assert: p2 header = '<header>h</header>'.
			self assert: p2 body = '<body>b</body>'.
		] with: p1..
	].
! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 12:28'!
testPageClassMigration

	ctx1 do: [
		| p1 |
		p1 := ( ctx1 resolveClass: #Page ).
		self assert: p1 = Page1.
		ctx2 do: [ :p2 |
			self assert: p2 = Page2. 	
		] with: p1..
	].
! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:12'!
testPageInstanceMigration

	ctx1 do: [
		| p1 |
		p1 := ( ctx1 resolveClass: #Page ) new.
		p1 name: 'TestPage'.
		self assert: p1 class = Page1.
		ctx2 do: [ :p2 |
			self assert: p2 class = Page2. 	
			self assert: p2 name = 'TestPage'.
		] with: p1..
	].
! !

TestCase subclass: #ContextCoexistenceTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
setUp
	ctx1 := Context new.
	ctx2 := Context ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/26/2011 12:47'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	
	"Release object globalized manually"
	Example allSubInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	Counter  allInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	
	Singleton1 instance: nil.
	Singleton2 instance: nil.
	ContextInfoBinding instance unbind: Singleton1.
	ContextInfoBinding instance unbind: Singleton2.

	"In case the current context (the process of the running test) has been set"
	CurrentContext instance: nil.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 09:40'!
testClassLocalBecomesGlobalNew

	| a1 a2 a  |
	
	Singleton1 globalize: #Singleton..
	Singleton2 globalize: #Singleton..
	
	Singleton1 nextMe: Singleton2.
	Singleton2 prevMe: Singleton1.
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example newGlobal..
	a2 := Example newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	CurrentContext instance: ctx1.
	a1 := Example new.
	a1 register. 
	 
	"self assert: a1 isCtxGlobal."
	self assert: (Singleton1 ctxInstVarNamed: 'Instance' ) = a1.    
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty.    
	
	CurrentContext instance: ctx2.
	a2 := Singleton2 instance.
	
	self assert: a2 isCtxGlobal.
	self assert: (a2 = a1) not.      
	self assert: a2 isRegistered.
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 09:40'!
testClassLocalBecomesGlobalOld

	| a1 a2 a  |
	
	Singleton1 globalize: #Singleton..
	Singleton2 globalize: #Singleton..
	
	Singleton1 nextMe: Singleton2.
	Singleton2 prevMe: Singleton1.
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example newGlobal..
	a2 := Example newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	CurrentContext instance: ctx2.
	a2 := Example new.
	a2 register. 
	 
	"self assert: a2 isCtxGlobal."
	self assert: (Singleton2 ctxInstVarNamed: 'Instance' ) = a2.    
	self assert: Singleton2 dirty not.       
	self assert: Singleton1 dirty.    
	
	CurrentContext instance: ctx1.
	a1 := Singleton1 instance.
	
	self assert: a1 isCtxGlobal.
	self assert: (a2 = a1) not.      
	self assert: a1 isRegistered.
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testClassResolutionContextDo

	| a1 a2 a  |
	
	Singleton1 globalize: #Singleton..
	Singleton2 globalize: #Singleton..
	
	Singleton1 nextMe: Singleton2.
	Singleton2 prevMe: Singleton1.
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example newGlobal..
	a2 := Example newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	ctx1 do: [ a1 register. ].

	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty.    
	
	ctx2 do: [ self assert: a2 isRegistered ].
	
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testClassResolutionManual

	| a1 a2 a  |
	
	Singleton1 globalize: #Singleton..
	Singleton2 globalize: #Singleton..
	
	Singleton1 nextMe: Singleton2.
	Singleton2 prevMe: Singleton1.
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example newGlobal..
	a2 := Example newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	CurrentContext instance: ctx1.
	( CurrentContext instance resolveClass: #Singleton )  instance: a1. 
	
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty.    
	
	CurrentContext instance: ctx2.
	a := ( CurrentContext instance resolveClass: #Singleton )  instance. 
	
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty not.
	self assert: (a = a2).
	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testClassResolutionRegister

	| a1 a2 a  |
	
	Singleton1 globalize: #Singleton..
	Singleton2 globalize: #Singleton..
	
	Singleton1 nextMe: Singleton2.
	Singleton2 prevMe: Singleton1.
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example newGlobal..
	a2 := Example newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	CurrentContext instance: ctx1.
	a1 register.  
	
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty.    
	
	CurrentContext instance: ctx2.
	self assert: a2 isRegistered.
	
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
testConcurrentCounter

	| a1 a2 b1 b2 sem1 sem2 sem3  |
	
	
	a1 := Counter newGlobal..
	a2 := Counter newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	sem1 := Semaphore new.
	sem2 := Semaphore new.
	sem3 := Semaphore forMutualExclusion.
	
	[ 
		CurrentContext instance: ctx1.  
		sem3 critical: [  a1 increment ]. 
		sem3 critical: [  a1 increment ]. 
		 sem1 signal. 
	] fork.

	[ 
		CurrentContext instance: ctx2.  
		sem3 critical: [  a2  increment ]. 
		sem3 critical: [  a2 increment ]. 
		 sem2 signal. 
	] fork.
	
	sem2  wait. 
	sem1  wait.

	self assert: (a1 value = 4  ).
	self assert: (a2 value = 4 ).! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testContextCloseover

	ctx1 do: [ | a1 |
			a1 := Example  newLocal.
			a1 f: 3.
			self assert: a1 isCtxGlobal not.
			ctx2 do: [ :a2 |				
					self assert: a1 isCtxGlobal.
					self assert: a2 isCtxGlobal .
					self assert: ( a1 = a2 ) not.
					self assert: a1 uuid = a2 uuid .      
					self assert: a2 f = 3.  
					a2 f: 4.
				] with: a1.
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 global size = 1.
	self assert: ctx2 global size = 1.
	! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/18/2011 10:39'!
testContextCloseoverDirty
	  
	ctx1 do: [ | a1 |
			a1 := Example  newLocal.
			a1 f: 3.
			ctx2 do: [ :a2 |				
					self assert: ctx1 global dirty not.
					self assert: ctx2 global dirty not.  
					a2 f: 4.
				] with: a1.
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 global size = 1.
	self assert: ctx2 global size = 1.
	! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/18/2011 10:39'!
testContextCloseoverSelf
	  
	ctx1 do: [ | a1 |
			a1 := Example  newLocal.
			a1 f: 3.
		
			a1 do: [ :a2 |				
					self assert: ctx1 global dirty not.
					self assert: ctx2 global dirty not.  
					a2 f: 4.
				] withSelfIn: ctx2. .
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 global size = 1.
	self assert: ctx2 global size = 1.
	! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 08:59'!
testContextReenter
	  
	ctx1 do: [ | a1 |
			a1 := Example  newLocal.
			a1 f: 3.
			self assert: a1 isCtxGlobal not.
			ctx1 do: [ :a2 |				
					self assert: a1 isCtxGlobal not.
					self assert: a2 isCtxGlobal not..
					self assert: a1 = a2.   
					self assert: a2 f = 3.  
					a2 f: 4.
				] with: a1.
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 global size = 0.
	! !

TestCase subclass: #GarbageCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
_testWeakGarbage

	|  weak o1 o2 inf1 inf2  |
	
	weak:= WeakIdentityKeyDictionary new. 
	 
	o1 := Object new.
	o2 := Object new. 
	
	inf1 := ContextualInfo new.
	inf2 := ContextualInfo new.
	
	inf1 nextMe: o2.
	inf2 prevMe: o1.
	
	weak at: o1 put: inf1.
	weak at: o2 put: inf2. 
	
	o1 := nil.
	o2 := nil.
	inf1 := nil.
	inf2 := nil.
	
	weak finalizeValues .
	Smalltalk garbageCollect.
	
	weak finalizeValues .
	Smalltalk garbageCollect.
	
	self halt. 
	self assert: weak keys size > 0. 
	! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:03'!
countArray
	^ ArrayL1 allInstances size! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:07'!
countAssociation
	^  AssociationL1 allInstances size.! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/16/2011 14:51'!
countBindKey
	^ ContextInfoBinding instance binding keys size! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/16/2011 14:51'!
countBinding
	^ ContextualInfo allSubInstances size.! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/16/2011 13:31'!
countContext
	^  Context allSubInstances size. ! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:04'!
countDictionary
	^  DictionaryL1  allInstances size! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/26/2011 12:47'!
countExample
 ^ Example allSubInstances size! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/16/2011 14:19'!
gc
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect.! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 18:31'!
testCreateAndGarbageAll

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	countExample := self countExample.
	countBindKey := self countBindKey..  
	countBinding := self countBinding.
	countCtx := self countContext .. 
	countDict := self countDictionary..
	countArray := self countArray ..
	countAssoc := self countAssociation .

	ctx1 := Context new.
	"A dictionary has an internal array as well"
	self assert: self countDictionary = (countDict + 1). 
	"self assert: self countBinding = (countBinding +2).    
	self assert: self countBindKey  = (countBindKey + 2). "
			
	ctx2 := Context ancestor: ctx1.
	self assert: self countDictionary = (countDict + 2). 
	"self assert: self countBinding = (countBinding +4).  
	self assert: self countBindKey  = (countBindKey + 4). "
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 |
			a1 := Example  newLocal.
			a1 f: 3.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			"self assert: self countBinding = (countBinding + 4).  
			self assert: self countBindKey  = (countBindKey + 4). "
			self assert: self countExample = (countExample + 1).
		
			ctx2 do: [ :a2 |		 
					a2 f: 4.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a2 isCtxGlobal.
					"self assert: self countBinding = (countBinding + 4 + 2).   binding instances might not be acurate unless with force GC"
					"self assert: self countBindKey  = (countBindKey + 6 + 2). "
					self assert: self countExample = (countExample + 2).
				] with: a1.
			self assert: a1 f = 4.   
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
		].
	
	ctx1 release.
	
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self gc.
	self gc. "we need two cycles to GC weak reference correctly?"
	self gc. "maybe three?"
	
	"Everything should have been GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	self assert: self countBinding =  countBinding . 
	self assert: self countBindKey  =  countBindKey.  
	
	"Few more sanity checks"
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 18:31'!
testCreateAndGarbageCyclic

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	countExample := self countExample.
	countBindKey := self countBindKey..  
	countBinding := self countBinding.
	countCtx := self countContext .. 
	countDict := self countDictionary..
	countArray := self countArray ..
	countAssoc := self countAssociation .
		
	ctx1 := Context new.
	"A dictionary has an internal array as well"
	self assert: self countDictionary = (countDict + 1). 
"	self assert: self countBinding = (countBinding +2).    
	self assert: self countBindKey  = (countBindKey + 2). "
			
	ctx2 := Context ancestor: ctx1.
	self assert: self countDictionary = (countDict + 2). 
	"self assert: self countBinding = (countBinding +4).  
	self assert: self countBindKey  = (countBindKey + 4). "
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 a11  |
			a1 := Example  newLocal.
			a11 := Example newLocal.
			a11 f: a1.
			a1 f: a11.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			self assert: self countExample = (countExample + 2).
		
			ctx2 do: [ :a2 |
					| a21 |		 
					a21 := a2 f.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a21 isCtxGlobal.
					self assert: self countExample = (countExample + 4).
				] with: a1.
			self assert: a1 f = a11.   
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
			a11 := nil.
		].
	
	ctx1 release.
	
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self gc.
	self gc. "we need two cycles to GC weak reference correctly?"
	
	"Everything should have been GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	self assert: self countBinding =  countBinding . 
	self assert: self countBindKey  =  countBindKey.  
	
	"Few more sanity checks"
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 11:30'!
testCreateAndGarbageOne

	|  ctx1 countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	countExample := self countExample.
	countBindKey := self countBindKey..  
	countBinding := self countBinding.
	countCtx := self countContext .. 
	countDict := self countDictionary..
	countArray := self countArray ..
	countAssoc := self countAssociation .
	
	self assert: Singleton1 isCtxGlobal not. 
	
	ctx1 := Context new.
	self assert: self countDictionary = (countDict + 1). 
	
	"Singleton1 was globalized and bound to #Singleton".
	ctx1 bind: #Singleton to: Singleton1 .
	"self assert: Singleton1 isCtxGlobal."
	"The global dictionary in the context has 3 additional object (array/assoc)"
	"self assert: self countBinding =( countBinding + 4). 
	self assert: self countBindKey  = (countBindKey + 4). "
	
	ctx1 do: [
		| o |
		o := Example newLocal. 
		" Object is local"
		self assert: o isCtxGlobal not.
		"self assert: self countBinding = (countBinding + 4).  
		self assert: self countBindKey  = (countBindKey + 4). "
		self assert: self countExample = (countExample + 1).
		
		( ctx1 resolveClass: #Singleton ) instance: o.
		" Object is global"	
		"self assert: o isCtxGlobal."
		"self assert: self countBinding = (countBinding + 4 + 1). 
		self assert: self countBindKey  = (countBindKey + 4 + 1).  "	 			
		self assert: self countExample = (countExample + 1).
		
		"Release the global ref"
		( ctx1 resolveClass: #Singleton ) instance: nil.
		
		"Superfluous. To be really sure object can be GC'ed 
		even if tmp var o is moved out of the closure"
		o := nil. 
	].	
	
	ctx1 := nil.
	self gc.
	self gc. "we need two cycles to GC weak reference correctly?"
	
	"The context, the global dictionary, the object should be GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	
	"The binding should have been GC'ed as well because it uses a weak key"
	"self assert: self countBinding = (countBinding + 1). 
	self assert: self countBindKey  = (countBindKey + 1).  "
	
	"Now we un-globalize the class manually"
	ContextInfoBinding instance binding removeKey: Singleton1 ifAbsent: [ self fail ].
	self gc.
	  
	self assert: self countBinding = countBinding. 
	self assert: self countBindKey  = countBindKey.  
	
	"Few more sanity checks"
	self assert: self countDictionary = countDict.
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 11:37'!
testCreateAndGarbageOneTwo

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	countExample := self countExample.
	countBindKey := self countBindKey..  
	countBinding := self countBinding.
	countCtx := self countContext .. 
	countDict := self countDictionary..
	countArray := self countArray ..
	countAssoc := self countAssociation .
		
	ctx1 := Context new.
	"A dictionary has an internal array as well"
	self assert: self countDictionary = (countDict + 1). 
	"self assert: self countBinding = (countBinding +2).    
	self assert: self countBindKey  = (countBindKey + 2). "
			
	ctx2 := Context ancestor: ctx1.
	self assert: self countDictionary = (countDict + 2). 
	"self assert: self countBinding = (countBinding +4).  
	self assert: self countBindKey  = (countBindKey + 4). "
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 |
			a1 := Example  newLocal.
			a1 f: 3.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			"self assert: self countBinding = (countBinding + 4).  
			self assert: self countBindKey  = (countBindKey + 4). "
			self assert: self countExample = (countExample + 1).
		
			ctx2 do: [ :a2 |		 
					a2 f: 4.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a2 isCtxGlobal.
					"self assert: self countBinding = (countBinding + 4 + 2).   binding instances might not be acurate unless with force GC"
					"self assert: self countBindKey  = (countBindKey + 6 + 2). "
					self assert: self countExample = (countExample + 2).
				] with: a1.
			self assert: a1 f = 4.   
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
		].
	
	ctx2 releaseAncestor.
	ctx1 := nil.

	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self gc.
	self gc. "we need two cycles to GC weak reference correctly?"
	
	"First ctx have been GC'ed"
	self assert: self countContext = (countCtx+1) .
	self assert: self countDictionary = (countDict+1). 
	self assert: self countExample = (countExample+1) .
	self assert: self countBinding =  (countBinding+4). 
	self assert: self countBindKey  =  (countBindKey+4).  
	
	"Now GC the 2nd one"
	ctx2 := nil.
	
	self gc.
	self gc. "we need two cycles to GC weak reference correctly?"
	
	"Everything should have been GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	self assert: self countBinding =  countBinding . 
	self assert: self countBindKey  =  countBindKey.  
	
	"Few more sanity checks"
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 11:23'!
testCreateAndGarbageUnreferenced

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	

	countExample := self countExample.
		
	ctx1 := Context new.
	ctx2 := Context ancestor: ctx1.
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 a11 a11bis  |
			a1 := ExampleA  newLocal.
			a11 := ExampleB newLocal.
			a1 f: a11.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			self assert: self countExample = (countExample + 2).
		
			ctx2 do: [ :a2 |
					| a21 |		 
					a21 := a2 f.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a21 isCtxGlobal.
					self assert: self countExample = (countExample + 4).
					
					"Now we replace the nested example"
					a21 := ExampleC newLocal. 
					a2 f: a21.
					self assert: self countExample = (countExample + 5).
					
				] with: a1.
			
			a11bis := a1 f.

			self assert: ( a11bis isNil not and: [ (a11bis = a11) not ] ).
			self assert: self countExample = (countExample + 6).
			
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
			a11 := nil.
			a11bis := nil.
		].
	
	ctx1 release.
	
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self gc.
	self gc. "we need two cycles to GC weak reference correctly?"

	"Everything should have been GC'ed, except the detached example"
	self assert: self countExample = (countExample + 2)
	
	"Now we garbage exampleB".
	ExampleB allInstances do: [ :o | o nextMe: nil ; prevMe: nil. ].
	self gc.
	self gc.
	self assert: self countExample = (countExample )! !

!GarbageCollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/18/2011 16:14'!
testWeakGarbage2

	|  weak o1 o2 inf1 inf2  |
	
	weak:= WeakIdentityKeyDictionary new. 
	 
	o1 := Example newLocal.
	o2 := Example newLocal.. 
	
	o1 f: o2.
	o2 f: o1.

	weak at: o1 put: #o1.
	weak at: o2 put: #o2.
		
	o1 := nil.
	o2 := nil.

	weak finalizeValues .
	Smalltalk garbageCollect.
	
	weak finalizeValues .
	Smalltalk garbageCollect.
	
	self assert: weak keys size = 0. 
	! !

TestCase subclass: #KernelTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/18/2011 11:01'!
_testClassSideResolution
	self assert: ( WebMessage statusCodeAt: 303 ) = 'See Other'.
	! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/18/2011 11:01'!
_testClassSideResolutionInheritance
	self assert: ( WebRequest statusCodeAt: 303 ) = 'See Other'.
	! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
setUp
	ctx1 := Context new.
	ctx2 := Context ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	
	"Release object globalized manually"
	Example allInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	Counter  allInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	
	Singleton1 instance: nil.
	Singleton2 instance: nil.
	ContextInfoBinding instance unbind: Singleton1.
	ContextInfoBinding instance unbind: Singleton2.

	"In case the current context (the process of the running test) has been set"
	CurrentContext instance: nil.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:03'!
testArray

	| a1 a2 b1 b2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b2 := ArrayL1 new: 3.
	b2 at: 1 put: 'a'.
	b2 at: 2 put: 'b'.
	b2 at: 3 put: 'c'.
	self assert: ( b2 isCtxGlobal not).
	
	a2 f: b2.
	"self assert: (b2 isCtxGlobal ).  "
	Transcript show: 'access f' ; cr.
	b1:= a1 f.
	Transcript show: 'end access f' ; cr.
	self assert: (  (b1 at: 3) = 'c' )..
	self assert: b1 class = ArrayL1. ! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 17:24'!
testBlockClosure

	| a1 a2 b1 b2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b1 := [ a1 identityHash ].
	self assert: ( b1 isCtxGlobal not).
	self assert: ( b1 value = a1 identityHash ).
	
	a1 f: b1. 
	"self assert: (b1 isCtxGlobal ).  "
	self assert: ( b1 value = a1 identityHash ).
	b2:= a2 f. 
	self assert: ( b2 value = a2 identityHash ).! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/29/2011 17:20'!
testBlockClosureMapClass

	self flag: 'Test that the closure''s class is mapped to the new version of the class'! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 10:02'!
testBlockClosureNoVar

	| a1 a2 b1 b2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b1 := [ 42 ].
	self assert: ( b1 isCtxGlobal not).
	self assert: ( b1 value = 42 ).
	
	a1 f: b1. 
	"self assert: (b1 isCtxGlobal ).  "
	self assert: ( b1 value = 42 ).
	b2:= a2 f. 
	self assert: ( b2 value = 42 ).! !

!KernelTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:04'!
testCollection 

	| a1 a2 b1 b2 |
	
	a1 := Example newGlobal: 'a1'.
	a2 := Example newGlobal: 'a2'.
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: true. "the newest in the root is flagged as dirty"
	a1 dirty: false.
	
	b2 := DictionaryL1 new.
	b2 at: #f put: 'hello'. 
	self assert: ( b2 isCtxGlobal not).
	
	a2 f: b2.
	"self assert: (b2 isCtxGlobal ).  "
	Transcript show: 'access f' ; cr.
	b1:= a1 f.
	Transcript show: 'end access f' ; cr.
	self assert: (  (b1 at: #f) = 'hello' )..! !

!LookupKey22 methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 15:28'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := false .! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 15:46'!
canonicalName 
	^ self trimDigitRight: self name  ! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 14:35'!
contextInfo
	^__ctxInfo__! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 14:35'!
contextInfo: info
	__ctxInfo__ := info! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 14:36'!
isCtxGlobal 
	^ __ctxInfo__ isNil not. ! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 15:45'!
trimDigitRight: aString
	(aString last isDigit ) ifTrue: [
		^ self trimDigitRight: (aString copyFrom: 1 to: aString size - 1) asSymbol.
	].
	^ aString. ! !

Object subclass: #BaseContextualObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:41'!
beep
	Transcript show: 'beep' ! !

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:41'!
newGlobal
	| n |
	n := self  new. 
	^ n globalize . ! !

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:41'!
newGlobal: uuid
	| n |
	n := self  new.
	"n uuid: uuid. "
	^ n globalize . ! !

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:41'!
newLocal
	^ self new.. ! !

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:41'!
newLocal: uuid
	| n |
	n := self new. 
	"n uuid: uuid ." 
	^ n  ! !

!BaseContextualObject methodsFor: 'accessing' stamp: 'ewe 5/19/2011 18:02'!
asString 
	^ self contextInfo isNil ifFalse: [ self contextInfo uuid ]. ! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 18:02'!
beep Transcript show: 'beep'    ! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:52'!
uuid
	^ self contextInfo uuid. ! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:50'!
uuid: u
	self contextInfo uuid: u. ! !

BaseContextualObject subclass: #ClassVars
	instanceVariableNames: 'instVar'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

ClassVars class
	instanceVariableNames: 'classSideInstVar'!

ClassVars class
	instanceVariableNames: 'classSideInstVar'!

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadClassVar self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 ]. ^  ClassVar! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadclassSideInstVar self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  classSideInstVar! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteClassVar: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 . self markOtherAsDirty ].  ^ ClassVar := v2  ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteclassSideInstVar: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ classSideInstVar := v2  ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 16:42'!
readClassSideInstVar
	classSideInstVar := 42. ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 16:41'!
readClassVar
	ClassVar := 42. ! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadinstVar self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  instVar! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteinstVar: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ instVar := v2  ! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 16:42'!
readClassVar
	ClassVar := 42. ! !

ClassVars subclass: #SubClassVars
	instanceVariableNames: 'instVarSub'
	classVariableNames: 'ClassVarSub'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

SubClassVars class
	instanceVariableNames: 'classSideInstVarSub'!

SubClassVars class
	instanceVariableNames: 'classSideInstVarSub'!

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadClassVarSub self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 ]. ^  ClassVarSub! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadclassSideInstVarSub self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  classSideInstVarSub! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteClassVarSub: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 . self markOtherAsDirty ].  ^ ClassVarSub := v2  ! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteclassSideInstVarSub: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ classSideInstVarSub := v2  ! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!SubClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadinstVarSub self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  instVarSub! !

!SubClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteinstVarSub: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ instVarSub := v2  ! !

!SubClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

BaseContextualObject subclass: #Counter
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Counter class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:59'!
beep  Transcript show: 'beep'        ! !

!Counter class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Counter methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadvalue self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  value! !

!Counter methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritevalue: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ value := v2  ! !

!Counter methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 13:44'!
increment
	value := value + 1.
	Transcript show: ('counter is now ', value asString ) ; cr.! !

!Counter methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 16:12'!
initialize 
	super initialize .
	value := 0. ! !

!Counter methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Counter methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:51'!
value
	^ value   ! !

BaseContextualObject subclass: #Example
	instanceVariableNames: 'f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Example class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadf self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  f! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritef: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ f := v2  ! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 7/7/2011 15:49'!
do: aBlock withSelfIn: aContext

^ aContext do: aBlock with: self. ! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 10:20'!
f 
	^f    ! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 10:20'!
f: v
f:= v.  ! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:01'!
isRegistered
	^ Singleton instance = self.! !

!Example methodsFor: 'as yet unclassified' stamp: 'ewe 7/5/2011 14:29'!
register
	Singleton  instance: self.    ! !

Example subclass: #ExampleA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleA class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!ExampleA methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

Example subclass: #ExampleB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleB class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!ExampleB methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

Example subclass: #ExampleC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleC class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!ExampleC methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

BaseContextualObject subclass: #Page1
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

Page1 subclass: #HtmlPage1
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!HtmlPage1 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadhtml self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  html! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritehtml: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ html := v2  ! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:09'!
html
	^ html! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:09'!
html: value
	html := value.! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Page1 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Page1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadname self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  name! !

!Page1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritename: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ name := v2  ! !

!Page1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Page1 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:13'!
name
	^ name! !

!Page1 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:09'!
name: anObject
	name := anObject! !

BaseContextualObject subclass: #Page2
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

Page2 subclass: #HtmlPage2
	instanceVariableNames: 'body header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!HtmlPage2 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
body
	^ body! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
body: value
	body := value.! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadbody self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  body! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadheader self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  header! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritebody: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty ].  ^ body := v2  ! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteheader: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty ].  ^ header := v2  ! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
header
	^ header ! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
header: value
	header := value! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Page2 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Page2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadname self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  name! !

!Page2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWritename: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty ].  ^ name := v2  ! !

!Page2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Page2 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:14'!
name
	^ name! !

!Page2 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:09'!
name: anObject
	name := anObject! !

BaseContextualObject subclass: #Singleton1
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadInstance self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 ]. ^  Instance! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteInstance: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 . self markOtherAsDirty ].  ^ Instance := v2  ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 10:08'!
instance
	^ Instance       ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 10:08'!
instance: anObject
	Instance:= anObject . ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Singleton1 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Singleton1 methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 09:35'!
isTheSingleton
	^ Instance = self. ! !

BaseContextualObject subclass: #Singleton2
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadInstance self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 ]. ^  Instance! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteInstance: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 . self markOtherAsDirty ].  ^ Instance := v2  ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 10:00'!
instance
	^ Instance       ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 14:56'!
instance: anObject
	 Instance:= anObject .   ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Singleton2 methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!Singleton2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 09:48'!
isTheSingleton
	^ Instance = self.! !

BaseContextualObject subclass: #SingletonTest
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!SingletonTest class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxReadInstance self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 ]. ^  Instance! !

!SingletonTest class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
ctxWriteInstance: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: -1 . self markOtherAsDirty ].  ^ Instance := v2  ! !

!SingletonTest class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!SingletonTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/21/2012 15:23'!
instance: anObject  Instance := anObject! !

!SingletonTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:36'!
isPrimitive ^ false! !

!SingletonTest methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 16:29'!
testLazyClassMigration

	| ctx1 ctx2 a1 a2 a  |
	
	ctx1 := Context new.
	ctx2 := SingletonContext ancestor: ctx1.  
	
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	
	ctx1 bind: #Singleton to: Singleton1.
	Singleton2 globalize: #Singleton2. 
	
	a1 := Example newGlobal..
	a2 := Example newGlobal. 
	
	a1 nextMe: a2.
	a2 prevMe: a1.
	a2 dirty: false.
	a1 dirty: true.
	
	CurrentContext instance: ctx2.
	a2 := Example new.
	a2 register. 
	 
	"self assert: a2 isCtxGlobal."
	self assert: (Singleton2 ctxInstVarNamed: 'Instance' ) = a2.    
	self assert: Singleton2 dirty not.       
	self assert: Singleton1 dirty.    
	
	CurrentContext instance: ctx1.
	a1 := Singleton1 instance.
	
	self assert: a1 isCtxGlobal.
	self assert: (a2 = a1) not.      
	self assert: a1 isRegistered.
	self assert: Singleton1 dirty not.       
	self assert: Singleton2 dirty not.

		"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	
	"Release object globalized manually"
	Example allSubInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	Counter  allInstances do: [ :o | ContextInfoBinding instance unbind: o ].
	
	Singleton1 instance: nil.
	Singleton2 instance: nil.
	ContextInfoBinding instance unbind: Singleton1.
	ContextInfoBinding instance unbind: Singleton2.

	"In case the current context (the process of the running test) has been set"
	CurrentContext instance: nil.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect.
	
	ContextInfoBinding instance binding finalizeValues.
	Smalltalk garbageCollect
	
	   ! !

Object subclass: #ClassesUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Utils'!

!ClassesUtils class methodsFor: 'backup-restore' stamp: 'ewe 9/26/2011 15:57'!
backupMethodsFor: aClass

	aClass methodDict values do: [ :m |
		| src |
		src := m getSource. 
		(src first = $_ or: [ (src beginsWith: 'ctx'  ) ] ) ifFalse: [	
				 ( src first  isAlphaNumeric  ) ifTrue: [ aClass compile: '_' , src  ]
			].
		]! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/28/2012 15:41'!
classesMetaOfKernelNext
	^ self classesOfKernelNext collect: [ :c | c class ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/28/2012 15:41'!
classesMetaOfKernelPrev
	^ self classesOfKernelPrev collect: [ :c | c class ]! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/28/2012 15:40'!
classesOfKernelNext
	|  base col |
	col := OrderedCollection new. 
	base := 
	{ HashedCollection22 .
	  OrderedCollection22 .
	  LookupKey22 .  
	  Array22 } .  
	
	base do: [ :cls |
		col  add: cls . 
		col addAll: cls  allSubclasses.
	].
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 10/10/2012 12:08'!
classesOfKernelPrev
	|  base col |
	col := OrderedCollection new. 
	base := 
	{ HashedCollectionL1 .
	  OrderedCollectionL1 .
	  LookupKeyL1 .  
	  ArrayL1 } . 
	
	base do: [ :cls |
		col  add: cls . 
		col addAll: cls  allSubclasses.
	].
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/21/2012 15:58'!
classesOfTests
	|  base col |
	col := OrderedCollection new. 
	base := 
	{ BaseContextualObject } .
	
	base do: [ :cls |
		col  add: cls . 
		col addAll: cls  allSubclasses.
		col  add: cls class  . 
		col addAll: cls class  allSubclasses.
	].
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/6/2011 13:21'!
copyClass: oldClass as: newName 
	| oldDefinition newDefinition |
	(oldClass environment hasClassNamed: newName) 
		ifTrue: [^ self error: newName , ' already exists'].
	oldDefinition := oldClass definition.
	newDefinition := oldDefinition 
				copyReplaceAll: '#' , oldClass name asString
				with: '#' , newName asString.
	^ Cursor wait showWhile: 
			[| newClass |
			newClass := Compiler evaluate: newDefinition logged: true.
			oldClass class instVarNames
				do: [ :each | newClass class addInstVarNamed: each ].
			newClass copyAllCategoriesFrom: oldClass.
			newClass class copyAllCategoriesFrom: oldClass class.
			newClass]! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/28/2012 11:56'!
copyClassAndSubclassOf: class suffix: suffix
	| o |
	o := OrderedCollection new.
	o add: class.
	o addAll: class allSubclasses .
	self copyClasses: o suffix: suffix .! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 10/10/2012 12:00'!
copyClasses: unordered suffix: suffix

	| ordered map  |
	ordered  := self orderClasses: unordered.
	 map := Dictionary new.
	ordered do: [ :cls | | cls2 pk2 |
		cls2 := self copyClass: cls  as: cls canonicalName , suffix.
		pk2 := self packageName:  cls  package packageName withSuffix:  suffix.  
		map at: cls put: cls2. 
		cls2 superclass removeSubclass: cls2 . 
		cls2 superclass: ( map at: cls2 superclass ifAbsent: [ cls2 superclass ]).	
		cls2 superclass addSubclass: cls2. 
		cls2 class superclass removeSubclass: cls2 class . 
		cls2 class superclass: ( map at: cls2 superclass ifAbsent: [ cls2 superclass ]) class.	
		cls2 class superclass addSubclass: cls2 class . 
		cls2 environment organization classify: cls2 name under: pk2	
		 ].
	! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/22/2011 09:10'!
copyPackage: packageName suffix: suffix

	self copyClasses: ( (PackageInfo named: packageName ) classes) suffix: suffix .! !

!ClassesUtils class methodsFor: 'backup-restore' stamp: 'ewe 9/23/2011 12:38'!
decompileSourceFor: aClass
	aClass methodDict keys do: [ :sel |
		(sel first = $_ or: [sel beginsWith: 'ctx'] ) ifFalse: [ 
			aClass compile: (aClass>>sel) decompileString. 
		]
	]! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 9/8/2011 11:31'!
diffClass: aClass with: anotherClass 

	| reporter |
	reporter := DiffReporter new from: aClass to: anotherClass .
	self diffInstVarsFor: aClass with: anotherClass using: reporter. 
	self diffMethodsFor: aClass with: anotherClass using: reporter.
	self diffInstVarsFor: aClass class with: anotherClass class using: reporter. 
	self diffMethodsFor: aClass class with: anotherClass class using: reporter! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 7/29/2011 15:56'!
diffClass: aClass with: anotherClass using: aReporter

	self diffInstVarsFor: aClass with: anotherClass using: aReporter. 
	self diffMethodsFor: aClass with: anotherClass using: aReporter! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 7/29/2011 15:58'!
diffInstVarsFor: aClass with: anotherClass using: aReporter 

	| setFrom setTo |
	setFrom := aClass allInstVarNames.
	setTo := anotherClass allInstVarNames .
	
	setFrom do: [ :instVar |  ( setTo includes: instVar ) ifFalse: [ aReporter notifyInstVarRemoved: instVar ]   ].
	setTo do: [ :instVar |  ( setFrom includes: instVar ) ifFalse: [ aReporter notifyInstVarAdded: instVar ]   ]! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 7/29/2011 16:18'!
diffMethodsFor: aClass with: anotherClass using: aReporter

	| setFrom setTo |
	setFrom := aClass methodDict.
	setTo := anotherClass methodDict .
	
	setFrom keysAndValuesDo: [ :selector :method   | 
		 ( anotherClass selectors includes: selector ) ifFalse: [ aReporter notifyMethodRemoved: selector body: method getSource   ]   ].
	
	setTo keysAndValuesDo: [ :selector :method   | 
		 ( aClass selectors includes: selector ) ifFalse: [ aReporter notifyMethodAdded: selector body: method getSource   ] 
			ifTrue: [ 
				| bodyFrom bodyTo |
				bodyFrom :=  (setFrom at: selector ) getSource.
				bodyTo := method getSource.  
				bodyFrom = bodyTo ifFalse: [
						aReporter notifyMethodChanged: selector from: bodyFrom to: bodyTo .   
					] .
			].  
		].
	
! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/28/2012 15:42'!
fillContextualClasses
	CurrentContext resetCache. 
	CurrentContext contextualClasses addAll: self classesOfKernelPrev .
	CurrentContext contextualClasses addAll: self classesOfKernelNext .
	CurrentContext contextualClasses addAll: self classesMetaOfKernelPrev . 
	CurrentContext contextualClasses addAll: self classesMetaOfKernelNext .
	CurrentContext contextualClasses addAll: self classesOfTests ! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/27/2012 15:49'!
generateAllAccessors
	CurrentContext contextualClasses do: [ :cls | 
		self generateIsPrimitiveFor: cls.   
		cls compilerClass = OptimizedContextualCompiler ifTrue: [
			self generateOptimizedAccessorsFor:  cls .
		].
	].! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/1/2011 17:17'!
generateIsPrimitiveFor: aClass
	aClass compile: 'isPrimitive ^ false'.! !

!ClassesUtils class methodsFor: 'compilation-inline' stamp: 'ewe 9/23/2011 12:57'!
generateOptimizedAccessors2For: aClass
	aClass allContextualInstVarNames do: [
		:n | 
			| get set | 
			get := 'ctxRead', n , ' (__ctxInfo__ = true )
			 ifTrue: [ self synchronize ]. ^  ', n.
			set := 'ctxWrite', n , ': v2 (__ctxInfo__ = true )
			 ifTrue: [ self synchronize; markOtherAsDirty ].  ^ ' , n ,' := v2  '.	
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/26/2012 11:36'!
generateOptimizedAccessorsFor: aClass
	self generateOptimizedPerFieldAccessorsFor: aClass     ! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/27/2012 15:52'!
generateOptimizedPerFieldAccessorsFor: aClass
	aClass contextualInstVarNames do: [
		:n | 
			| get set index | 
			index := aClass indexOfContextualInstVar: n.  
			get := 'ctxRead', n , ' self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: ' , index asString  , ' ]. ^  ', n.
			set := 'ctxWrite', n , ': v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: ' , index  asString  ,' . self markOtherAsDirty ].  ^ ' , n ,' := v2  '.	
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/27/2012 15:52'!
generateOptimizedPerObjectAccessorsFor: aClass
	aClass contextualInstVarNames do: [
		:n | 
			| get set | 
			get := 'ctxRead', n , ' self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary ]. ^  ', n.
			set := 'ctxWrite', n , ': v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary; markOtherAsDirty ].  ^ ' , n ,' := v2  '.	
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/27/2012 15:52'!
generateRegularAccessorsFor: aClass
	aClass contextualInstVarNames do: [
		:n |
			| get set |
			get := 'ctxRead', n , ' ^ ', n. 
			set := 'ctxWrite', n , ': v ^ ' , n ,' := v globalizeNoop '.	
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'compilation-inline' stamp: 'ewe 9/26/2011 15:27'!
inlineAccessorsFor: aClass
	aClass allContextualInstVarNames do: [ :s |
		| refRead refWrite |
		refRead := InlineAllSendersRefactoring 
		sendersOf:  ( #ctxRead , s ) asSymbol 
		in: aClass .
		refRead setOption: #inlineExpression
		toUse: [ :a :b | true ].
		[ refRead execute ] on: RBRefactoringError do: [] .
		refWrite := InlineAllSendersRefactoring 
		sendersOf:  ( #ctxWrite , s , ':' ) asSymbol 
		in: aClass .
		refWrite setOption: #inlineExpression
		toUse: [ :a :b | true ].
		[ refWrite execute ] on: RBRefactoringError do: [] .. 
	].
RefactoryChangeManager nuke.
RefactoringManager nuke .
	! !

!ClassesUtils class methodsFor: 'compilation-inline' stamp: 'ewe 9/13/2011 19:18'!
inlineCtxInfoFor: cls 

cls addInstVarNamed: '__ctxInfo__' asSymbol .   

cls allSubInstances do: [ :o |
	o instVarNamed: '__ctxInfo__' asSymbol put: o isCtxGlobal   
].

cls compile: 'contextInfo: value
	 __ctxInfo__ := true.
	super contextInfo: value.'.
	
cls compile: 'isCtxGlobal
	<ctxMeta>
	__ctxInfo__
		ifNil: [^ __ctxInfo__ := false].
	^ __ctxInfo__'.! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/28/2012 15:11'!
linkClassPrev: prevSet withNext: nextSet 
	
	| map |
	(prevSet size = nextSet size) ifFalse: [
		self error: 'Sets have different sizes'.
	].
	map := Dictionary new.
	prevSet do: [ :prev |
		( map includesKey: prev canonicalName ) ifTrue: [ self error: 'Collision on prev set' ].
		map at: prev canonicalName put: prev.
	].
	nextSet do: [ :next |
		| prev |
		prev := map at: next canonicalName ifAbsent: [ self error: 'No valid prev class found'].
		CurrentContext linkClassPrev: prev withNext:  next .
		map removeKey: next canonicalName .
	].



	
	! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 8/31/2011 12:04'!
optimizeClass: aClass
	self generateOptimizedAccessorsFor: aClass .
	aClass class compile: 'compilerClass ^ OptimizedContextualCompiler '.
	aClass recompileAll.     ! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/6/2011 13:29'!
orderClasses: original
	| ordered unordered t |
	
	ordered := OrderedCollection new.
	unordered := OrderedCollection new.
	unordered addAll: original .
	
	[ unordered size > 0 ] whileTrue: [  
		t := unordered copy.
		t do: [ :cls |
			( t includes: cls superclass ) ifFalse: [ ordered add: cls. unordered  remove: cls  ].  
		].
	].

	^ ordered. ! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/22/2011 09:18'!
packageName: originalName withSuffix: suffix

| items |
 items := '-' split: originalName. 
items at: 1 put: ( items at: 1) , suffix. 
^ '-' join: items . ! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/27/2012 15:50'!
recompileAllClasses
	CurrentContext contextualClasses do: [ :cls | cls recompileAll  ].! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/26/2012 11:41'!
removeAccessorsFor: aClass
	aClass allContextualInstVarNames do: [
		:n |
			| get set |
			get := 'ctxRead', n . 
			set := 'ctxWrite', n , ':'.	
			aClass removeSelector: get asSymbol.  		
			aClass removeSelector: set asSymbol. 
	]! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/27/2012 15:49'!
removeAllAccessors
	CurrentContext contextualClasses do: [ :cls | 		
		self removeAccessorsFor: cls.   
	].  ! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/27/2012 15:50'!
removeGenerateRecompileAllClasses
	self removeAllAccessors .
	self generateAllAccessors .
	self recompileAllClasses .! !

!ClassesUtils class methodsFor: 'backup-restore' stamp: 'ewe 9/23/2011 12:40'!
restoreMethodsFor: aClass

	aClass methodDict values do: [ :m |
		| src |
		src := m getSource. 
		(src first = $_ )  ifTrue: [	aClass compile:  ( src copyFrom: 2 to: src size ).  ].
	]! !

!ClassesUtils class methodsFor: 'rename' stamp: 'ewe 7/29/2011 16:45'!
suffixPackage: aPackageName with:  aSuffix

| newPackage |

newPackage := aPackageName , aSuffix .

( PackageInfo named: aPackageName ) classes do: [ :cls | 
	cls rename: ( cls name , aSuffix  ).
	cls environment organization classify: cls name under: newPackage
	]! !

Object subclass: #Context
	instanceVariableNames: 'cache ancestor global lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!Context class methodsFor: 'as yet unclassified' stamp: 'ewe 7/5/2011 16:36'!
ancestor: anAncestor
	^ self new ancestor: anAncestor .  ! !

!Context class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 21:03'!
newRoot
	^ self new postInitialize .! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 9/7/2011 14:09'!
ancestor
		^ ancestor get.! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 9/8/2011 17:21'!
ancestor: anAncestor
	ancestor set: anAncestor .
	
	self flag: 'Not elegant'.
	CurrentContext prevMe: anAncestor..
	CurrentContext nextMe: self .

	global dirty: true.
  	global prevMe: anAncestor global.
	anAncestor global nextMe: global.
	
	"self postInitialize. "! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 1/16/2012 14:41'!
bind: aUuid to: aContextualObject 
	| ctxUuid |
	ctxUuid := ContextualUUID newNamed: aUuid .  
	(aContextualObject isCtxGlobal and: [ aContextualObject uuid ~=  ctxUuid ]) ifTrue: [ Abort signal: 'binding a global to an invalid UUID'].
	global at: aUuid put: (aContextualObject globalize: ctxUuid).
! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 9/14/2011 09:28'!
cache
	cache ifNil: [ cache := IdentityDictionary new. ].
	^ cache. ! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 9/14/2011 09:07'!
cacheAt: key ifAbsentPut: aBlock
	^ self cache at: key ifAbsent: [ | v | 
		v := aBlock value. 
		self cache at: key put: v. 
		v ].
	! !

!Context methodsFor: 'closure' stamp: 'ewe 9/13/2011 17:13'!
do: aBlock
	| oldCtx |
	oldCtx := CurrentContext instance.
	CurrentContext instance: self.
	[ 
		^ [  aBlock value ] 
		   on: CurrentContextNotification 
		   do: [ :ex |
				 "Transcript show: 'Resume exception' ; cr. "
				ex resume: self ].
	] ensure: 
	[ CurrentContext instance: oldCtx   ]  	! !

!Context methodsFor: 'closure' stamp: 'ewe 7/6/2011 09:22'!
do: aBlock with: anObject
	| adaptedObject |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	^ self do:  [ aBlock value: adaptedObject   ].

  ! !

!Context methodsFor: 'closure' stamp: 'ewe 7/6/2011 09:30'!
do: aBlock with: anObject with: anObject2
	| adaptedObject  adaptedObject2  |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	adaptedObject2 := self globalizeAndAdaptReference: anObject2.  
	^ self do:  [ aBlock value: adaptedObject  value: adaptedObject2  ].
  ! !

!Context methodsFor: 'closure' stamp: 'ewe 7/6/2011 09:30'!
do: aBlock with: anObject with: anObject2 with: anObject3
	| adaptedObject  adaptedObject2 adaptedObject3  |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	adaptedObject2 := self globalizeAndAdaptReference: anObject2.  
	adaptedObject3 := self globalizeAndAdaptReference: anObject3.  
	^ self do:  [ aBlock value: adaptedObject  value: adaptedObject2 value: adaptedObject3  ].! !

!Context methodsFor: 'closure' stamp: 'ewe 7/6/2011 09:31'!
do: aBlock with: anObject with: anObject2 with: anObject3 with: anObject4
	| adaptedObject  adaptedObject2 adaptedObject3 adaptedObject4  |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	adaptedObject2 := self globalizeAndAdaptReference: anObject2.  
	adaptedObject3 := self globalizeAndAdaptReference: anObject3.  
	adaptedObject4 := self globalizeAndAdaptReference: anObject4. 
	^ self do:  [ aBlock value: adaptedObject  value: adaptedObject2 value: adaptedObject3 value: adaptedObject4  ].
  ! !

!Context methodsFor: 'gc' stamp: 'ewe 9/7/2011 14:20'!
executor
	^ super executor. ! !

!Context methodsFor: 'gc' stamp: 'ewe 9/27/2011 09:45'!
finalize
	Transcript show: 'Finalize context ', self identityHash ;cr.
	"^ self release"! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 7/6/2011 16:10'!
global
	^ global! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 1/15/2012 17:12'!
globalizeAndAdaptReference: anObject
	| uuid ctx  |
	
	anObject isPrimitive ifTrue: [ ^ anObject ].
	CurrentContext instance = self ifTrue: [ ^ anObject ].
	
	uuid := anObject globalize  uuid.   
	"CurrentContext is the caller context, we put the object there. It's normally the ancestor of this context."
	"ctx := CurrentContext instance."
	( self ancestor = CurrentContext instance )ifFalse: [ self halt. ].
	ctx := self ancestor. 
	ctx global at: uuid put: anObject.  

	self do:[
		^ self global at: uuid  .
	].

	self flag: 'The UUID can be removed from the list of global after the do:with: has completed. Indeed, object globalized because of closre 
	are not reachable like other global. The object remains global, but not reachable .'
! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 10/10/2012 12:04'!
initialize 
	global := DictionaryL1 new globalize .
	ancestor := WeakReference new.
	lock := Semaphore forMutualExclusion. 
	WeakRegistry default add: self.! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 1/16/2012 16:41'!
invalidateNext: aPrev
aPrev  nextMe dirty: true.  ! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 1/16/2012 16:41'!
invalidatePrev: aNext
aNext  prevMe dirty: true.  ! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 8/19/2011 11:26'!
migrateToNext: anObject
	
	^ anObject defMigrateToNext ! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 8/19/2011 11:27'!
migrateToPrev: anObject

	^ anObject defMigrateToPrev ! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 9/6/2011 14:32'!
postInitialize ! !

!Context methodsFor: 'gc' stamp: 'ewe 8/18/2011 16:09'!
release
	"Needs to be done in two steps. Indeed migration checks if next/prev is nil to know if object was migrated or not, which interfers with the process of nuking references next/prev."
	
	self global forceMigration .
	self global forceRelease 
! !

!Context methodsFor: 'gc' stamp: 'ewe 8/17/2011 16:00'!
releaseAncestor
	ancestor release. 
	ancestor := nil.! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 9/14/2011 09:07'!
resolve: aUuid ifAbsent: aBlock
	^ self cacheAt: aUuid  ifAbsentPut:  [
		lock critical: [	global at: aUuid ifAbsent: aBlock. ].
	]! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 8/15/2011 10:26'!
resolveClass: aClassName
	^ self resolve: aClassName ifAbsent:   [ Smalltalk at: aClassName ].! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 8/19/2011 11:36'!
synchronizeFromNext: aPrev
	^ aPrev defSynchronizeFromNext ! !

!Context methodsFor: 'activecontext-core' stamp: 'ewe 8/19/2011 11:36'!
synchronizeFromPrev: aNext
	^ aNext defSynchronizeFromPrev! !

Context subclass: #Page1Context
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:39'!
migrateToNext: anObject
	self fail: 'Should not be called'.  ! !

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 09:50'!
migrateToPrev: anObject
	self fail: 'Should not be called'.  ! !

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:39'!
synchronizeFromNext: anObject
	self fail: 'Should not be called'.  ! !

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:39'!
synchronizeFromPrev: anObject
	self fail: 'Should not be called'.  ! !

Context subclass: #Page2Context
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:38'!
migrateToNext: anObject
	( anObject class = Page1) ifTrue: [
		^ Page2 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = Page1 ) ifTrue: [
		^ Page2.
	].
	( anObject class = HtmlPage1) ifTrue: [
		^ HtmlPage2 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = HtmlPage1 ) ifTrue: [
		^ HtmlPage2.
	].
	^ super migrateToNext: anObject 
	    ! !

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 10:54'!
migrateToPrev: anObject
	( anObject class = Page2) ifTrue: [
		^ Page1 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = Page2 ) ifTrue: [
		^ Page1
	].
	( anObject class = HtmlPage2) ifTrue: [
		^ HtmlPage1 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = HtmlPage2 ) ifTrue: [
		^ HtmlPage1.
	].
	^ super migrateToPrev: anObject 
	    
	  ! !

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:06'!
synchronizeFromNext: anObject
	( anObject class = HtmlPage1) ifTrue: [
		| p2 header body |
		p2 := anObject nextMe. 
		header := p2 instVarNamed: #header. 
		body := p2 instVarNamed: #body.      
		anObject instVarNamed: #html put: ( header, body ).
		anObject instVarNamed: #name put: ( p2 instVarNamed: #name ).
		^ self.
	].
	^ super synchronizeFromNext: anObject 
	    ! !

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:08'!
synchronizeFromPrev: anObject
	( anObject class = HtmlPage2) ifTrue: [
		| p1 html header body  |
		p1 := anObject prevMe.. 
		html := p1 instVarNamed: #html.  
		header := (  html allRegexMatches: '<header>(.*)</header>' ) at: 1.
		body := (  html allRegexMatches: '<body>(.*)</body>' ) at: 1.
		anObject instVarNamed: #header put: header.
		anObject instVarNamed: #body put: body.
		anObject instVarNamed: #name put: ( p1 instVarNamed: #name ).
		^ self.
	].
	^ super synchronizeFromPrev: anObject 
	    ! !

Context subclass: #SingletonContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 16:29'!
migrateToNext: anObject
	( anObject = Singleton1 ) ifTrue: [
		^ Singleton2.
	].
	^ super migrateToNext: anObject 
	    ! !

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 14:41'!
migrateToPrev: anObject
	( anObject = Singleton2 ) ifTrue: [
		^ Singleton1
	].
	^ super migrateToPrev: anObject 
	    
	  ! !

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 14:41'!
synchronizeFromNext: anObject
	^ super synchronizeFromNext: anObject 
	    ! !

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 14:41'!
synchronizeFromPrev: anObject
	^ super synchronizeFromPrev: anObject 
	    ! !

Object subclass: #ContextInfoBinding
	instanceVariableNames: 'binding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

ContextInfoBinding class
	instanceVariableNames: 'instance'!

ContextInfoBinding class
	instanceVariableNames: 'instance'!

!ContextInfoBinding class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 15:25'!
instance
	instance isNil ifTrue: [ 
		instance := self new.
	].
	^ instance .! !

!ContextInfoBinding class methodsFor: 'as yet unclassified' stamp: 'ewe 7/5/2011 17:12'!
reset
	instance:= nil.! !

!ContextInfoBinding methodsFor: 'as yet unclassified' stamp: 'ewe 9/9/2011 11:22'!
bind: anObject to: aContextInfo
	aContextInfo isNil ifTrue:[
		self unbind: anObject .  
	] ifFalse: [
		binding  at: anObject put: aContextInfo
	].! !

!ContextInfoBinding methodsFor: 'as yet unclassified' stamp: 'ewe 8/8/2011 11:26'!
binding
	^binding! !

!ContextInfoBinding methodsFor: 'as yet unclassified' stamp: 'ewe 5/30/2011 16:08'!
for: anObject
	^ binding at: anObject  ifAbsent: [ ^ nil ].  ! !

!ContextInfoBinding methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 15:26'!
initialize 
	binding := WeakIdentityKeyDictionary new.! !

!ContextInfoBinding methodsFor: 'as yet unclassified' stamp: 'ewe 8/8/2011 10:06'!
unbind: anObject 
	binding removeKey: anObject  ifAbsent:   [ ].
! !

Object subclass: #ContextStatistics
	instanceVariableNames: 'counters'
	classVariableNames: 'Check Read Resolve Track Write'
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 19:01'!
checkStatistics
	Check ifNil: [ Check := self new ].
	^ Check. ! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:33'!
readStatistics
	Read ifNil: [ Read := self new ].
	^ Read.! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2011 10:00'!
resetAll
	self readStatistics reset.
	self writeStatistics reset.
	self resolveStatistics reset.  
	self checkStatistics reset.
	self resetTrack.! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2011 10:00'!
resetTrack
	Track := nil.
! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:24'!
resolveStatistics
	Resolve ifNil: [ Resolve := self new ].
	^ Resolve.! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2011 10:00'!
track
	Track ifNil: [ Track := IdentitySet new ].
	^ Track.! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2011 10:02'!
track: anObject
	self track add: anObject .! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:25'!
writeStatistics
	Write ifNil: [ Write := self new ].
	^ Write.! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:22'!
counter: key
	^ counters at: key ifAbsent: [ 0 ].! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:22'!
decrement: key
	| value |
	value :=  counters at: key ifAbsent: [ 1 ].
	 counters at: key put: value - 1.  ! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:22'!
increment: key
	| value |
	value := counters at: key ifAbsent: [ 0 ].
	counters at: key put: value + 1.  ! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:22'!
initialize 
	counters := Dictionary  new.! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:23'!
reset
	counters := Dictionary new.! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:23'!
statistics
	^ counters associations sorted: [ :a :b | a value <= b value ].! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 19:11'!
sum
	| s|
	s := 0.
	counters valuesDo: [ :v| s := s + v ].
	^ s.   ! !

Object subclass: #ContextualInfo
	instanceVariableNames: 'prev next dirtyBits global uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/16/2012 14:39'!
clear
	prev:=nil.
	next:=nil.
	"uuid:=nil. "
	self dirty: false. 
	! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/15/2012 15:33'!
dirty
	^ dirtyBits at: 1! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/16/2012 09:07'!
dirty: anObject
"16rFF bitAnd: (1 bitShift: 3)"
	dirtyBits := Array new: 20.
	anObject ifTrue: [
		dirtyBits fillWith: true   ]
	ifFalse: [ 
		dirtyBits fillWith: false   ]! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/15/2012 15:33'!
dirtyBit: index
	^ dirtyBits at: index! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/15/2012 15:34'!
dirtyBit: index set: bit
	^ dirtyBits at: index put: bit! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/16/2012 14:12'!
dirtyBits
	^ dirtyBits! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/16/2012 14:12'!
dirtyBits: anObject
	dirtyBits := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:18'!
global
	self flag: 'to remove'.
	^ global! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:18'!
global: anObject
	self flag: 'to remove'.
	global := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	^ next! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:07'!
nextMe: anObject
	next := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:08'!
prevMe
	^ prev! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:07'!
prevMe: anObject
	prev := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:01'!
uuid
	^ uuid! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:01'!
uuid: anObject
	uuid := anObject! !

Object subclass: #ContextualUUID
	instanceVariableNames: 'uuid lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextualUUID class methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:32'!
newNamed: aName
	^ self new uuid: aName. ! !

!ContextualUUID class methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:32'!
newRandom 
	^ self new uuid: UUID new. ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:26'!
= anotherObject
 ^ uuid = anotherObject uuid. ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:28'!
hash
	^ uuid hash. ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:32'!
initialize
	lock := Semaphore forMutualExclusion.  ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:27'!
lock
	^ lock.! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:27'!
uuid 
	^ uuid.! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:33'!
uuid: aUuid
	uuid := aUuid .! !

Object subclass: #CurrentContext
	instanceVariableNames: ''
	classVariableNames: 'Contextual Latest Lock Next Normalized Prev'
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:08'!
classesOfBaseKernel
	|  base col |
	col := OrderedCollection new. 
	base := 
	{ HashedCollectionL1 .
	  OrderedCollectionL1 .
	  LookupKeyL1 .  
	  ArrayL1 .
	  HashedCollection22 .
	  OrderedCollection22 .
	  LookupKey22 .  
	  Array22 .} .
	
	base do: [ :cls |
		col  add: cls . 
		col addAll: cls  allSubclasses.
		col  add: cls class  . 
		col addAll: cls class  allSubclasses.
	].
	^ col  select: [ :cls | cls isObsolete not ].! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 10:26'!
classesOfJQuery
^ self classesOfPackage: 'Prototype'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 10:26'!
classesOfJavascript
^ self classesOfPackage: 'Javascript'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/9/2011 14:06'!
classesOfMagritte
^ self classesOfPackage: 'Magritte'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2011 19:57'!
classesOfPackage: named 
	| col | 
	col := Set new.
	( PackageInfo named: named )classes  do: [ :cls |
		col add: cls . 
		col addAll: cls  allSubclasses.
		col add: cls class. 
		col addAll: cls class  allSubclasses.
	].
	^ col select: [ :cls | cls isObsolete not ]! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/9/2011 14:06'!
classesOfPier
^ self classesOfPackage: 'Pier'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 10:29'!
classesOfPierStack
	| col |
	col := self classesOfSwazoo .
	col addAll: self classesOfSeaside  .
	col addAll: self classesOfMagritte  .
	col addAll: self classesOfPier .
	col addAll: self classesOfRSS.
	col addAll: self classesOfJavascript .    
	col addAll: self classesOfJQuery .
	col addAll: self classesOfScriptaculous .
	col addAll: self classesOfPrototype.
	^ col. ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 10:26'!
classesOfPrototype
^ self classesOfPackage: 'Prototype'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 10:26'!
classesOfRSS
^ self classesOfPackage: 'RSS'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 10:27'!
classesOfScriptaculous
^ self classesOfPackage: 'Prototype'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/9/2011 14:06'!
classesOfSeaside
^ self classesOfPackage: 'Seaside'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2011 23:45'!
classesOfStartup
	| col |
	
	col := Set  new.
	col addAll: self classesOfBaseKernel . 
	"col addAll: self classesOfWebClient ."
	
	col addAll: self classesOfPierStack .. 
	col remove: SwazooBuffer.  "Swazoo-inheritent from stream"		
	col add: OBCommand . "Seaside- inherited by seaside cmd"
	
	col remove: WebCounter. 
	
	col remove: MAProxyObject .
	col remove: MAProxyObject class. 
	col remove: MADynamicObject .
	col remove: MADynamicObject class. 

	^ col! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/9/2011 14:06'!
classesOfSwazoo
^ self classesOfPackage: 'Swazoo'  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/9/2011 13:56'!
classesOfWebClient

	| col |
	col := OrderedCollection new.
	
	{ '73' . '74'. '75' . '76' . '77' . '78' . '79' . '80' . '81' . '82' . '83' . '84' } do: [ :version |
		| tmp | 
		tmp := { 'WebServer' } ,
		{ 'WebSocket' },
		{ 'WebMessage' . 'WebRequest' . 'WebResponse' } ,
		{ 'WebCookie' } ,
		{ 'WebUtils' }.
		tmp := tmp collect: [ :cls | Smalltalk at: ( cls, version ) asSymbol ] .
		tmp do: [ :cls | col add: cls. col add: cls class ].	
	].
	^ col.
! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 15:36'!
contextualClasses 
	^ Contextual ifNil: [ Set new ]! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/23/2011 10:58'!
fillCache
	
	Contextual := self classesOfStartup.. 
	Normalized  := Set new. ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 15:22'!
init
	ClassesUtils copyPackage: 'ActiveContext-Kernel' suffix: '2' .
	ClassesUtils copyClassAndSubclassOf: Example suffix:  '2' .
	Class addInstVarNamed: '__ctxInfo__'   .

	ClassesUtils fillContextualClasses.
	ClassesUtils removeGenerateRecompileAllClasses .
	
	ClassesUtils  
	linkClassPrev: ClassesUtils classesOfKernelPrev 
	 withNext: ClassesUtils classesOfKernelNext .
	
	CurrentContext instance: nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	CurrentContext latest: nil. 
	CurrentContext initLock.
	
	ContextualInfo allInstances do: [ : i | i clear ].
	ContextInfoBinding  instance binding removeAll.
	! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 6/6/2012 12:19'!
initLock
	Lock := Semaphore  forMutualExclusion .! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:17'!
initialize 
	Prev := WeakReference new. ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 17:19'!
instance
	^ Processor activeProcess environmentAt: #activeContext ifAbsent: [ CurrentContextNotification signal ] 
	"^ CurrentContextNotification signal. "! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/14/2011 10:37'!
instance: anObject
	Processor activeProcess environmentAt: #activeContext put: anObject .
	! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/15/2011 17:13'!
latest
	^ Latest  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/15/2011 17:13'!
latest: aContext
	Latest := aContext .! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/28/2012 14:55'!
linkClassPrev: prevClass withNext: nextClass
	
	| prevInfo nextInfo |
	
	( prevClass canonicalName = nextClass canonicalName ) ifFalse: [
		self error: 'Classes are not a valid pair of prev/next'	
	].
	
	prevInfo := ContextualInfo new.
	prevInfo global: true.
	prevInfo dirty: false. 
	prevInfo uuid: ( ContextualUUID newNamed: prevClass canonicalName ).
	prevInfo nextMe: nextClass. 
	prevClass contextInfo: prevInfo. 
	
	nextInfo := ContextualInfo new.
	nextInfo global: true.
	nextInfo dirty: false. 
	nextInfo uuid: ( ContextualUUID newNamed: nextClass canonicalName ).
	nextInfo prevMe: prevClass. 
	nextClass contextInfo: nextInfo. ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 6/6/2012 12:18'!
lock
	^ Lock! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	^ Next ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
nextMe: aContext
	Next := aContext .! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 15:36'!
normalizedClasses 
	^ Normalized  ifNil: [ Set new ]! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:17'!
prevMe
	^ Prev get.! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:17'!
prevMe: aContext
	Prev set: aContext.! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 13:51'!
resetCache
	
	Contextual := Set new.. 
	Normalized  := Set new. .! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 10/10/2012 12:08'!
resetSystem
	"ContextInfoBinding  instance binding removeAll."
	WAServerManager reset. 
	HTTPResponse initialize .
	FileResource initialize .
	SwazooServer reset .
	CurrentContext instance: nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	CurrentContext latest: nil. 
	PBBlog ctxInstVarNamed: #Languages put:   PBBlog buildLanguages.
	PRDocumentParser initialize.

	{ HashedCollectionL1 .
	  OrderedCollectionL1 .  
	  ArrayL1 . LookupKeyL1 .
	  HashedCollection22 .
	  OrderedCollection22  .  
	  Array22 . LookupKey22}  
		do: [ :cls |
			cls allSubInstances do: [ :o | 
			o instVarNamed: '__ctxInfo__' asSymbol put:  false.  ].
		].
	"{ WAObject . MAObject . PRObject . } 
	do: [ :cls |
		cls allSubInstances do: [ :o | 
		o instVarNamed: '__ctxInfo__' asSymbol put:  nil.  ].
	]."
	ContextualInfo allInstances do: [ : i | i clear ].
	ContextInfoBinding  instance binding removeAll.

	WADispatcher resetDefault .
	Context newRoot do: [ 
		HeaderField resetHttpFieldNameToClassDictionary ; 	httpFieldNameToClassDictionary.
		HeaderField2 resetHttpFieldNameToClassDictionary ; 	httpFieldNameToClassDictionary.
		HTTPResponse  initialize. HTTPResponse2 initialize.
		WAKeyGenerator2 initialize. WAKeyGenerator initialize.  
		PRMacroExpander initialize. PRMacroExpander2 initialize. 
		WAUrlEncoder initialize. WAUrlEncoder2 initialize. 
		WAXmlEncoder initialize. WAXmlEncoder2 initialize.
		WARenderer2 default:  WARenderCanvas2  .
		WARenderer default: WARenderCanvas.  "hierarchy is borken--selectAsDefault not working"
		WAResponse initializeStatusMessages. " And 2 subclasses"
		WASharedConfiguration initialize. 
		WASystemConfiguration allSubclasses do: [ :each | each instance clearDescription ].
		PRDistribution register
	 ].

	WADispatcher globalize. 
	WADispatcher2 globalize.
	WADispatcher nextMe: WADispatcher2. 
	WADispatcher2 prevMe: WADispatcher. 
	WADispatcher2 dirty: true. ! !

Object subclass: #DiffReporter
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Utils'!

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 15:57'!
from: aClass to: anotherClass
	from := aClass .
	to := anotherClass .! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyInstVarAdded: anInstVar  

	Transcript show: ( to name , '. ' ,  anInstVar , ' added' )  ; cr.
	! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyInstVarRemoved: anInstVar  

	Transcript show: ( from name , '. ' ,  anInstVar , ' removed' )  ; cr.! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:13'!
notifyMethodAdded: selector body: body  

		Transcript show: ( to name , '>> ' ,  selector , ' added' ) ; cr.! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyMethodChanged: selector from: oldBody to: newBody   

			Transcript show: ( from name , '>> ' ,  selector , ' and ' , to name , '>>' , selector,   ' differ' ) ; cr.! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyMethodRemoved: selector body: body

		Transcript show: ( from name , '>> ' ,  selector , ' removed' ) ; cr.! !

Object subclass: #Meta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

Meta class
	instanceVariableNames: 'flag'!

Meta class
	instanceVariableNames: 'flag'!

!Meta class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 17:29'!
do: aBlock otherwise: anotherBlock
	flag isNil
		ifTrue: [ 
			flag := true.
			[ ^ aBlock value ] ensure: [ flag := nil ] ]
		ifFalse: [ ^ anotherBlock value ]	

"    (Processor activeProcess environmentAt: #level ifAbsent: [ nil ] ) isNil ifTrue:    
   [
	Processor activeProcess environmentAt: #level put: #meta .
	[ ^ aBlock value.  ] ensure:
	[ Processor activeProcess environmentAt: #level put: nil. ].
   ]  ifFalse: 
   [
   	^ anotherBlock value.
   ]. "! !

!Object class methodsFor: '*ActiveContext' stamp: 'ewe 9/1/2011 16:15'!
compilerClass 
	
	( CurrentContext contextualClasses  includes: self  ) ifTrue: [
		"Transcript show:( 'Contextual compiler for ',  self asString  ); cr. "
		  ^OptimizedContextualCompiler 
	].
	(  CurrentContext normalizedClasses includes: self  ) ifTrue: [
		Transcript show:( 'Normalized compiler for ',  self asString  ); cr.
		  ^NormalizedCompiler.
	].
	^ super compilerClass .! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:07'!
--> anObject
	"Answer an Association between self and anObject"

	^ (self ctxClass: #AssociationL1) basicNew key: self value: anObject! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 09:41'!
contextInfo
	"ContextStatistics checkStatistics  increment: self class."
	^ ContextInfoBinding instance for: self . ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 5/19/2011 15:42'!
contextInfo: info
	ContextInfoBinding instance bind: self to: info.! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/15/2011 15:51'!
countChildrenObjects
	| visited potentialGlobal effectivelyGlobalDirty effectivelyGlobalClean |
	visited := IdentitySet new.
	potentialGlobal := IdentitySet new.
	effectivelyGlobalDirty := IdentitySet new.
	effectivelyGlobalClean := IdentitySet new. 
	self traverseAndDo:  [ :prev | 
		prev isClass ifFalse:  [
			prev isCtxGlobal 
				ifTrue: [ 
					prev dirty ifTrue: [ effectivelyGlobalDirty add: prev ] 
							  ifFalse: [ effectivelyGlobalClean add: prev ]. ]
				ifFalse: [ potentialGlobal add: prev ].    
			].
		 ] exclude: visited globalize: false.
	{  potentialGlobal  . effectivelyGlobalDirty . effectivelyGlobalClean   } inspect. 
	^ {  #potential -> potentialGlobal size . #dirty -> effectivelyGlobalDirty size . #clean -> effectivelyGlobalClean size }.  

! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:08'!
ctxClass: c
	| sym cls  |
	sym := c asSymbol .
	"ContextStatistics resolveStatistics increment: c."
	
	( sym =  #Delay ) ifTrue: [ ^ Delay ].	
	( sym =  #Array ) ifTrue: [ ^ ArrayL1 ].
	( sym =  #Association ) ifTrue: [ ^ AssociationL1  ].
	( sym =  #BlockClosure ) ifTrue: [ ^ BlockClosure ].
	( sym =  #HashedCollection ) ifTrue: [ ^ HashedCollectionL1 ].
	( sym =  #Dictionary ) ifTrue: [ ^ DictionaryL1 ].
	( sym =  #IdentityDictionary ) ifTrue: [ ^ IdentityDictionaryL1 ].
	( sym =  #Set ) ifTrue: [ ^ SetL1 ].
	( sym =  #LookupKey ) ifTrue: [ ^ LookupKeyL1  ].
	( sym =  #OrderedCollection ) ifTrue: [ ^ OrderedCollectionL1 ].
			  
	CurrentContext instance isNil ifTrue: [
		self flag: 'should be remove afterwards when we always have a context'.
		
		cls := Smalltalk at: sym. 
		( CurrentContext contextualClasses includes: cls ) 
		ifTrue: [ ^ cls ]
		 ifFalse: [ "Transcript show: sym; cr. " ^ cls ].
		
	] ifFalse:       
	[  
		self flag: 'We must not end in a meta-recursion, and shortcut the resolution of class dictionary depends on'.
		^ CurrentContext instance resolveClass: sym.    
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:17'!
ctxInstVarNamed: name
	"ugly hack because I can not apparently name a method on instance and class side with same name"
	( self isClass and: [ name first isUppercase ]) ifTrue: [
		^ self classPool at: name asSymbol ifAbsent: [ self superclass  ctxInstVarNamed: name ]  .
	]  ifFalse: [   
		^ self instVarNamed: name.  
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:18'!
ctxInstVarNamed: name put: value
	"ugly hack because I can not apparently name a method on instance and class side with same name"
	( self isClass and: [ name first isUppercase ])  ifTrue: [
		self flag: 'Should handle inheritance, if the class var is not in this class but an upper one'.
		self classPool at: name asSymbol ifAbsent: [ ^ self superclass  ctxInstVarNamed: name put: value ]  .
		^ self classPool at: name asSymbol put: value.
	]  ifFalse: [   
		^ self instVarNamed: name put: value.
	]
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/31/2011 10:25'!
ctxRead: f 
		ContextStatistics readStatistics increment: self class. 
		
		self isCtxGlobal  ifTrue: [    
			"self dirty ifTrue: [  Transcript show: 'ctxRead ', f , '[', Processor activeProcess identityHash , ']' ;cr.   ]."
			self synchronizeIfNecessary.
			^ self ctxInstVarNamed: f.  
		]
		ifFalse: [
			^ self ctxInstVarNamed: f .   	
		]  
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/31/2011 10:25'!
ctxWrite: f value: v
		ContextStatistics writeStatistics increment: self class. 
		  
		self isCtxGlobal  ifTrue: [    
			"self dirty ifTrue: [  Transcript show: 'ctxWrite ', f,  '[', Processor activeProcess identityHash , ']' ;cr.   ]."
			self synchronizeIfNecessary.
			self markOtherAsDirty .
			^ self ctxInstVarNamed: f put: v globalize. 
		]
		ifFalse: [
			^ self ctxInstVarNamed: f put: v.   	
		]
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 14:49'!
defMigrateToNext
	self isClass ifTrue: [
		^ (Smalltalk at: (self canonicalName , '2') asSymbol) globalize: self uuid.
	] ifFalse: [  
		self class migrateToNextIfNecessary..
		^ self class nextMe basicNew globalize: self uuid. 
	]  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/28/2012 14:50'!
defMigrateToPrev
	self isClass ifTrue: [
		^ (Smalltalk at: self canonicalName) globalize: self uuid.
	] ifFalse: [ 
		^ self class basicNew globalize: self uuid. 
	]  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:08'!
defSynchronizeFromNext

	self class allContextualInstVarNames do: [ :field |
		| n |
		n := self nextMe ctxInstVarNamed: field.  
			( n isPrimitive not )  ifTrue: [
			"lazy migration after update"
			n migrateToPrevIfNecessary .
			self ctxInstVarNamed:  field put: n prevMe.
			"Transcript show: ( self uuid, '.' , field, ' := ', n prev asString ); cr."
		] ifFalse: [
			self ctxInstVarNamed: field put: n.  
			"Transcript show: ( self uuid, '.' , field, ' := ', n asString ); cr."
		]. 
	]    ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 14:20'!
defSynchronizeFromPrev

	ContextStatistics track: self . 
	  
	self isClass ifTrue: [ self defSynchronizeFromPrevClass ]
	ifFalse: [ self defSynchronizeFromPrevObj ].  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 14:20'!
defSynchronizeFromPrevClass

	self class allContextualInstVarNames do: [ :field |
		| p |
		p := self prevMe ctxInstVarNamed: field.   
		( p isPrimitive not )  ifTrue: [
			"lazy migration after update"
			p migrateToNextIfNecessary.
			self ctxInstVarNamed:  field put: p nextMe. .
			"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
		] ifFalse: [
			self ctxInstVarNamed: field put: p.  
			"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
		]. 
	]   ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 14:20'!
defSynchronizeFromPrevObj

	(1 to: self class instSize ) do: [ :pos |
		| p |
		p := self prevMe instVarAt: pos.   
		( p isPrimitive not )  ifTrue: [
			"lazy migration after update"
			p migrateToNextIfNecessary.
			self instVarAt: pos put: p nextMe. .
			"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
		] ifFalse: [
			self instVarAt: pos  put: p.  
			"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
		]. 
	].! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 15:57'!
dirty
	| info flag |
	info := self contextInfo .
	info isNil ifTrue: [ self halt. ].
	flag := info dirty.
	flag class = QuanticBoolean ifTrue: [ self halt. ].
	^ flag. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 7/7/2011 14:20'!
dirty: flag
	( self contextInfo isNil and: [ flag = true ])  ifTrue: [
			Abort signal: 'Local object can not be dirty.'.
	]. 
	"if contextInfo is nil object and flag it false it's ok' "
	( self contextInfo isNil not )  ifTrue: [
			self contextInfo dirty: flag.
	]  .
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:50'!
dirtyBit: index
	| info flag |
	info := self contextInfo .
	info isNil ifTrue: [ self halt. ].
	flag := info dirtyBit: index.
	flag class = QuanticBoolean ifTrue: [ self halt. ].
	^ flag. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:50'!
dirtyBit: index set: flag
	( self contextInfo isNil and: [ flag = true ])  ifTrue: [
			Abort signal: 'Local object can not be dirty.'.
	]. 
	"if contextInfo is nil object and flag it false it's ok' "
	( self contextInfo isNil not )  ifTrue: [
			self contextInfo dirtyBit: index set: flag.
	]  . 
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 15:43'!
forceMigration	
	| visited |
	visited := IdentitySet new.
	self traverseAndDo:  [ :prev |
			| infPrev infNext  next |
			
			"Get the couple of representations"
			infPrev := ContextInfoBinding instance for: prev. 
			next := infPrev nextMe. 
			infNext := ContextInfoBinding instance for: next.
			"Force migration"
			next ifNotNil: [
				"assert prev dirty = false"
				next synchronizeIfNecessary .
			]
	] exclude: visited. 

! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 16:17'!
forceRelease	
	| visited collect |
	collect := OrderedCollection new.
	visited := IdentitySet new.
	self traverseAndDo:  [ :prev |
			| infPrev infNext  next |
			"Get the couple of representations"
			infPrev := ContextInfoBinding instance for: prev. 
			next := infPrev nextMe. 
			infNext := ContextInfoBinding instance for: next.
			"Nuke the bi-directional refs"
			infNext ifNotNil: [ infNext prevMe: nil ].  "assert: infNext prev = prev "
			infPrev nextMe: nil. 
			collect add: prev. 
	] exclude: visited. 
	self flag: 'Should''nt be necessary, but because classes are permanent, we need to uncontextualize them manually. Also do it outside traverse block as traverse itself globalizes objects'.
	collect do: [ :prev | prev contextInfo: nil   ].
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/16/2012 14:30'!
globalize
	"Transcript show: 'Globalize ', self class ;cr."
	self isClass
	ifTrue: [ ^ self globalize: (ContextualUUID newNamed: self name) ]
	ifFalse: [ ^ self globalize: (ContextualUUID newRandom ). ].   ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 17:21'!
globalize: uuid
	self isPrimitive ifTrue: [
		^ self. 
	].   
	self isCtxGlobal ifFalse: [   
		
		"Transcript show: ( 'Globalize ', self class , '@', self identityHash  ) ; cr."
		
		self contextInfo: ContextualInfo new.
		self contextInfo global: true.
		self contextInfo dirty: false.
		self contextInfo uuid: uuid.

		"disabled"
		"(self class = self optimizedClass ) ifFalse: [
			| n |
			n := self optimizedClass new.
			self flag: 'Don''t know why we need to instantiate the class--might cause problems'.
			self class allContextualInstVarNames do: [ :field | n ctxInstVarNamed: field put: (self ctxInstVarNamed: field) globalize ].
			self become: n. 
			
		] ifTrue: ["
			self class allContextualInstVarNames do: [ :field | 
				self ctxInstVarNamed: field put: (self ctxInstVarNamed: field)  ].
		"]."
	
	].
	^ self.
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/1/2011 14:42'!
globalizeNoop
	| uuid |
	"uuid := UUID new.    "
"	self isPrimitive ifTrue: [
		^ self. 
	].   "
"	self isCtxGlobal ifFalse: [  " 
		
		"Transcript show: ( 'Globalize ', self class , '@', self identityHash  ) ; cr."
		
	"	self contextInfo: ContextualInfo new.
		self contextInfo global: true.
		self contextInfo dirty: false.
		self contextInfo uuid: uuid."
		
		
		"self class allContextualInstVarNames do: [ :field | 
			self ctxInstVarNamed: field put: (self ctxInstVarNamed: field) globalize ]."
		
	"	(1 to: Example instSize ) do: [ :pos | 	(self instVarAt: pos ) globalize ]"
	
	"]."
	^ self. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 5/19/2011 15:43'!
initialize 
	self contextInfo: nil. 
	super initialize.! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 5/23/2011 10:15'!
isClass
	^ false! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:53'!
isCtxGlobal
"	ContextStatistics checkStatistics  increment: self class. "

	self isPrimitive ifTrue: [
		^ false. 
	]. 
"	((self class = Array_ ) or: [ self class = BlockClosure_ ]) ifTrue: [ ^ true ]."
	(self class = Array ) ifTrue: [ ^ false ].
	^ self contextInfo isNil not.
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 14:26'!
isPrimitive
	| names |
	
	ContextStatistics checkStatistics  increment: self class.
	
	self flag: 'Ugliy hack to manage optmizied and non-opt classes: we normalize fist to optimizedClass. Note that optimizedClass will not
	work for metaclass, it computes e.g. [WebServer class_] instead of [WebServer_ class]. Also, as we do not want to break the metaclass invariant, 
	we need to compare based on names, not identity. There can be several metaclasses that are identical, e.g. [WebServer class].'.

	names := CurrentContext contextualClasses collect: [ :cls | cls name ].
	^ ( names includes: self optimizedClass name ) not ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/16/2012 16:42'!
markOtherAsDirty
	self prevMe ifNotNil: [
		CurrentContext nextMe invalidatePrev: self .
	] 
	ifNil: [
		self nextMe ifNotNil: [
			CurrentContext nextMe invalidateNext: self. 
		].
		"if there is only one context, there is not next/prev even if the object is global"
	].
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
migrateToNext
	| clone |
	clone :=  CurrentContext nextMe migrateToNext: self.  
	clone dirty: true.
	self nextMe: clone.
	clone prevMe: self.! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 6/6/2012 12:15'!
migrateToNextIfNecessary
	self isCtxGlobal ifFalse: [ self globalize ].
	
		self nextMe ifNil: [ self migrateToNext ].
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
migrateToPrev
	| clone |
	clone := CurrentContext nextMe migrateToPrev: self.  
	clone dirty: true.
	self prevMe: clone.
	clone nextMe: self.! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 6/6/2012 12:15'!
migrateToPrevIfNecessary
	self isCtxGlobal ifFalse: [ self globalize ].
	
		self prevMe ifNil: [ self migrateToPrev ].
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/16/2012 14:55'!
migrationLock
	^ self contextInfo uuid lock ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	^ self contextInfo nextMe! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
nextMe: anObject
	self contextInfo nextMe: anObject! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 5/30/2011 15:19'!
optimizedClass 
	^ Smalltalk at:  ( self class name , '_' ) asSymbol ifAbsent: [ self class ]  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 15:00'!
perform: selector withArguments: argArray inSuperclass: lookupClass
	^ self primPerform: selector withArguments: argArray asNativeArray inSuperclass: lookupClass. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:08'!
prevMe
	^ self contextInfo prevMe! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
prevMe: anObject
	self contextInfo prevMe: anObject! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 15:00'!
primPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isSymbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/15/2011 17:21'!
synchronize
		"self dirty: QuanticBoolean new.. "
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			CurrentContext nextMe synchronizeFromPrev: self.     
		] 
		ifNil: [
			CurrentContext nextMe synchronizeFromNext: self.   
		].
		self dirty: false.! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/16/2012 15:53'!
synchronize: indexOfField
		"self dirty: QuanticBoolean new.. "
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			CurrentContext nextMe synchronizeFromPrev: self.     
		] 
		ifNil: [
			CurrentContext nextMe synchronizeFromNext: self.   
		].
		self dirty: false. 
		self flag: 'should be per-field'.
"		self dirtyBit: indexOfField set: false. "! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/15/2011 17:22'!
synchronizeIfNecessary 
	self dirty ifTrue: [
		self synchronize .
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 6/6/2012 12:19'!
synchronizeIfNecessary: indexOfField
	CurrentContext lock critical: [  
	(self dirtyBit: indexOfField ) ifTrue: [
		self synchronize.
	]
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 13:51'!
traverseAndDo: aBlock exclude: visited 
	self traverseAndDo: aBlock exclude: visited globalize: true.   ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 16:54'!
traverseAndDo: aBlock exclude: visited globalize: doGlobalize
	| infPrev infNext prev next |	
	
	self isPrimitive ifTrue: [ ^ self ].  
	doGlobalize ifTrue: [ self globalize ].
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	self class allContextualInstVarNames do: [ :name | ( self ctxInstVarNamed: name  ) traverseAndDo: aBlock exclude:  visited globalize: doGlobalize  ].! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 7/6/2011 11:44'!
uuid
	^ self contextInfo uuid! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 7/7/2011 12:10'!
uuid: aUuid

	Abort signal: 'Only global object have UUID and it must be set only when initially globalized with globalize:'! !

Object subclass: #QuanticBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifFalse: a 
Abort signal: 'In unknown state'. ! !

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifFalse: a ifTrue: b 
Abort signal: 'In unknown state'. ! !

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifTrue: a 
Abort signal: 'In unknown state'. ! !

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifTrue: a ifFalse:  b
Abort signal: 'In unknown state'. ! !

!ClassDescription methodsFor: '*ActiveContext' stamp: 'ewe 5/23/2011 10:15'!
isClass
	^ true! !
CurrentContext initialize!
